<?
/************************************************************************
*
*  online.QTAFI - online survey
*
*  Copyright (C) 2008  Martin Guist guist@incher.uni-kassel.de
*
*  This program is free software: you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation, either version 3 of the License, or
*  (at your option) any later version.
*
*  This program is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  You should have received a copy of the GNU General Public License
*  along with this program.  If not, see <http://www.gnu.org/licenses/>.
*
*************************************************************************/
/**
* Background
* Width / Height
* Value 
* Gradient
*
* Example;
* chart.php?width=100&height=10&value=20&color1=ff0000&color2=00ff00&background=ffffff&gradient=double
*/
	header( "Content-type: image/png" );
	$width = 102;
	if( isset( $_GET["width"] ) ) $width = $_GET["width"];
	$height = 10;
	if( isset( $_GET["height"] ) ) $height = $_GET["height"];
	$value = 66;
	if( isset( $_GET["value"] ) ) $value = $_GET["value"];
	$gradient = "single";
	if( isset( $_GET["gradient"] ) ) $gradient = $_GET["gradient"];
	list( $r1,$g1,$b1 ) = hex2rgb( "#ee0000" );
	if( isset( $_GET["color1"] ) ) list( $r1,$g1,$b1 ) = hex2rgb( $_GET["color1"] );
	list( $r2,$g2,$b2 ) = hex2rgb( "#ffffff" );
	if( isset( $_GET["color2"] ) ) list( $r2,$g2,$b2 ) = hex2rgb( $_GET["color2"] );
	list( $rb,$gb,$bb ) = hex2rgb( "#ffffff" );
	if( isset( $_GET["background"] ) ) list( $rb,$gb,$bb ) = hex2rgb( $_GET["background"] );
	
	$img = imagecreatetruecolor( $width, $height );
	//Background
	$bgcolor = imagecolorallocate( $img, $rb, $gb, $bb );
	imagefilledrectangle( $img, 0, 0, $width, $height, $bgcolor );
	
	//Foreground
	$color1 = imagecolorallocate( $img, $r1, $g1, $b1 );
	imagefilledrectangle( $img, 2, 2, $value+2, $height - 4 , $color1 );
	
	//Gradient
	$rr = 0; $gg = 0; $bb = 0; 
	if( $gradient == "single" ){
		$count = $height - 4;
		$cc = imagecolorallocate( $img, $r1, $g1, $b1 );
		for( $i = 0; $i < $count; $i++ ){
			$old_r = $rr; $old_g = $gg; $old_b = $bb;
			$rr = ( $r2 - $r1 != 0 ) ? intval( $r1 + ( $r2 - $r1 ) * ( $i / $count ) ): $r1;
			$gg = ( $g2 - $g1 != 0 ) ? intval( $g1 + ( $g2 - $g1 ) * ( $i / $count ) ): $g1;
			$bb = ( $b2 - $b1 != 0 ) ? intval( $b1 + ( $b2 - $b1 ) * ( $i / $count ) ): $b1;
			if( "$old_r,$old_g,$old_b" != "$rr,$gg,$bb" ){
				$cc = imagecolorallocate( $img, $rr, $gg, $bb );
			}
			imagefilledrectangle( $img, 2, (2 + $i), $value+2, (3 + $i), $cc );
		}
	}
	elseif( $gradient == "double" ){
		$count = ($height - 4)/2;
		$cc = imagecolorallocate( $img, $r1, $g1, $b1 );
		for( $i = 0; $i < $count; $i++ ){
			$old_r = $rr; $old_g = $gg; $old_b = $bb;
			$rr = ( $r2 - $r1 != 0 ) ? intval( $r1 + ( $r2 - $r1 ) * ( $i / $count ) ): $r1;
			$gg = ( $g2 - $g1 != 0 ) ? intval( $g1 + ( $g2 - $g1 ) * ( $i / $count ) ): $g1;
			$bb = ( $b2 - $b1 != 0 ) ? intval( $b1 + ( $b2 - $b1 ) * ( $i / $count ) ): $b1;
			if( "$old_r,$old_g,$old_b" != "$rr,$gg,$bb" ){
				$cc = imagecolorallocate( $img, $rr, $gg, $bb );
			}
			imagefilledrectangle( $img, 2, (2 + $i), $value+2, (3 + $i), $cc );
			imagefilledrectangle( $img, 2, ($height-2-$i), $value+2, ($height-3-$i), $cc );
		}
	}

	imagepng( $img );
	imagedestroy( $img );
	
function hex2rgb( $color ){
	$color = str_replace('#','',$color);
	$s = strlen($color) / 3;
	$rgb[]=hexdec(str_repeat(substr($color,0,$s),2/$s));
	$rgb[]=hexdec(str_repeat(substr($color,$s,$s),2/$s));
	$rgb[]=hexdec(str_repeat(substr($color,2*$s,$s),2/$s));
	return $rgb;
}
?>