<?
/************************************************************************
*
*  online.QTAFI - online survey
*
*  Copyright (C) 2008 Martin Guist guist@incher.uni-kassel.de
*
*  This program is free software: you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation, either version 3 of the License, or
*  (at your option) any later version.
*
*  This program is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
*  GNU General Public License for more details.
*
*  You should have received a copy of the GNU General Public License
*  along with this program. If not, see <http://www.gnu.org/licenses/>.
*
*************************************************************************/

include_once "nodes/InputNode.class.php";

class Postprocessor {

	protected $document;
	protected $rootelement;
	protected static $muliplechoiceCount = array();
	protected static $variables = array(); //Zugriff self::$variables
	protected static $qtafiNodes = array();
	public static $flaggedVariables = array();

	public static $declarations = array();

	function __construct(){
		$this->document = new DOMDocument("1.0", "utf-8");
	}

	/**
	* processes a given file
	*/
	function processFile($doc){
		global $__PAGE,$__AUTHENTICATIONMODE, $__ERROR;
		if($__AUTHENTICATIONMODE == "open"){
			$this->document->load($doc);
			$this->rootelement = $this->document->documentElement;
			$this->process();
			return;
		}
		if($__ERROR != ERROR_OK){
			$this->document->load(PROJECT_PATH."index.survey");
			$this->rootelement = $this->document->documentElement;
			$this->process();
		}
		else {
			$this->document->load($doc);
			$this->rootelement = $this->document->documentElement;
			$this->process();
		}
	}

	/**
	* processes a given string
	*/
	function processContent($str){
		global $__PAGE,$__AUTHENTICATION;
		//$str = str_replace( "&", "&#38;", $str );
		@$this->document->loadXML($str);
		$this->rootelement = $this->document->documentElement;
		$this->process();
	}

	function process(){
		$items = $this->rootelement->getElementsByTagNameNS("http://localhost/qtafi3", "*");
		while($items->length > 0){
			$el = $items->item(0);
			$this->replace($el->nodeName, $el);
			$items = $this->rootelement->getElementsByTagNameNS("http://localhost/qtafi3", "*");
		}
		/*
		for( $i = 0; $i < $items->length; $i++ ){
			$el = $items->item( $i );
			print "Name: ".$el->nodeName."\n";
			$this->replace( $el->nodeName, $el );
		}*/
	}

	function replace($name, &$node){
		$iNode = NULL;
		$vname = $node->getAttribute("variable");
		if(! array_key_exists($vname, self::$muliplechoiceCount)) self::$muliplechoiceCount[$vname] = 1;
		else self::$muliplechoiceCount[$vname]++;
		$nn = (int)self::$muliplechoiceCount[$vname];
		switch($name){
			case "qtafi:TE": $iNode = new TENode($this->document, $node);break;
			case "qtafi:TL": $iNode = new TLNode($this->document, $node);break;
			case "qtafi:ME": $iNode = new MENode($this->document, $node);break;
			case "qtafi:OR": $iNode = new ORNode($this->document, $node, $nn);break;
			case "qtafi:CV": $iNode = new CVNode($this->document, $node, $nn);break;
			case "qtafi:MD": $iNode = new MDNode($this->document, $node, $nn);break;
			case "qtafi:PIN": $iNode = new PINNode($this->document, $node );break;
			case "qtafi:COUNTRY": $iNode = new COUNTRYNode($this->document, $node);break;
			case "qtafi:HIDDEN": $iNode = new HIDDENNode($this->document, $node);break;
			case "qtafi:ERROR": $iNode = new ERRORNode($this->document, $node);break;
			case "qtafi:QUERY": $iNode = new QUERYNode($this->document, $node);break;
			case "qtafi:COUNT": $iNode = new COUNTNode($this->document, $node);break;
			case "qtafi:RECORD": $iNode = new RECORDNode($this->document, $node);break;
			case "qtafi:RESULT": $iNode = new RESULT($this->document, $node);break;
			case "qtafi:IGNORE_IF": $iNode = new IGNORE_IFNode($this->document, $node);break;
			case "qtafi:USE_IF": $iNode = new USE_IFNode($this->document, $node);break;
			//case "qtafi:SNIPPET" : $iNode = new SNIPPETNode($this->document, $node);break;
			case "qtafi:RECEPTION": $iNode = new RECEPTIONNode($this->document, $node);break;
			case "qtafi:CALL": $iNode = new CALLNode($this->document, $node);break;
			default: $iNode = new VARNode($this->document, $node);
		}
		self::$variables[$vname] = "";
		self::$qtafiNodes[] = $iNode;
		$iNode->setNum((int)self::$muliplechoiceCount[$vname]);
	}

	function &getVariables(){
		return self::$variables;
	}

	function setVariables(&$vars){
		foreach(self::$qtafiNodes as $inode){
			$inode->setValue($vars);
		}
	}

	function toScreen(){
		header("Content-type: text/html; charset=UTF-8", true);
		$str = $this->document->saveXML();
		$str = str_replace("#EURO", "&euro;", $str);
		
		$str = str_replace("[+]", "&amp;", $str);
		//Strange
		$str = str_replace("<![CDATA[", "//* <![CDATA[ *//", $str);
		$str = str_replace("]]>", "//* ]]> *//", $str);
		foreach(self::$declarations as $def) $str = str_replace($def["name"], $def["value"], $str);
		$str = str_replace("xmlns:qtafi=\"http://localhost/qtafi3\"", "", $str);
		return $str;
	}
}

?>