<?
/************************************************************************
*
*  online.QTAFI - online survey
*
*  Copyright (C) 2008  Martin Guist guist@incher.uni-kassel.de
*
*  This program is free software: you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation, either version 3 of the License, or
*  (at your option) any later version.
*
*  This program is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
*  GNU General Public License for more details.
*
*  You should have received a copy of the GNU General Public License
*  along with this program. If not, see <http://www.gnu.org/licenses/>.
*
*************************************************************************/

class Project /*extends FormItem*/ {

	public static $document = null;
	public static $rootelement = null;
	public $vars = array();
	
	public $usestyle = "style.css";
	
	public $formatter = null;
	public $shownavigation = true;
	public $formatterclass = "";

	function __construct(){
		global $__AUTHOR,$__AUTHENTICATIONMODE;
		$this->formatterclass = "ProjectFormatter";
	}

	function buildPage( $i = 1 ){
		global $__PAGE,$__REQUEST_PAGE,$__MAX_PAGE,$__AUTHENTICATIONMODE,$__ERROR;
		$this->rootelement = new Page();
		$this->rootelement->readXML(simplexml_load_string("<?xml version=\"1.0\" ?><Page/>"));
		include_once "./classes/format/".FormItem::$formatterdirectory."/StandardFormatter.class.php";
		include_once "./classes/format/".FormItem::$formatterdirectory."/".$this->formatterclass.".class.php";
		$this->formatter = new $this->formatterclass;
		if(! $this->checkConfiguration()) return;
		//self::$document = simplexml_load_file( PROJECT_PATH.QUESTIONNAIRE );
		$cb_string = file_get_contents(PROJECT_PATH.QUESTIONNAIRE);
		$cb_string = str_replace("&amp;", "[+]", $cb_string);
		$cb_string = str_replace("& ", "[+] ", $cb_string);
		self::$document = simplexml_load_string($cb_string);
		if( ! $this->checkTiming() ) return;
		
		$codebook =  self::$document->codebook[0];
		foreach( self::$document as $cc ){
			if( FormItem::shouldRead( $cc ) ){
				$codebook = $cc;
				break;
			}
		}
		
		if( ! $this->import( $codebook ) ){
			$this->readXML( $codebook );
		}
	}
	
	function checkConfiguration(){
		global $__PAGE,$__REQUEST_PAGE,$__MAX_PAGE,$__AUTHENTICATIONMODE,$__ERROR;
		if( ! file_exists( PROJECT_PATH.QUESTIONNAIRE ) ){
			$re = new RE();
			$x = simplexml_load_string("<?xml version=\"1.0\" ?><RE><text>Survey not configured</text></RE>");
			$re->readXML($x);
			$this->rootelement->addChild( $re );
			return false;
		}
		return true;
	}
	
	function checkTiming(){
		global $__PAGE,$__REQUEST_PAGE,$__MAX_PAGE,$__AUTHENTICATIONMODE,$__ERROR;
		if( START > Timing::currentTime() ){
			if( file_exists( PROJECT_PATH."setup.html" ) ){
				$this->rootelement = null;
				require( PROJECT_PATH."setup.html" );
				return false;
			}
			else if( isset( self::$document->codebook[0]->SETUP[0] ) ){
				$this->rootelement->readXML( self::$document->codebook[0]->SETUP[0] );
				return false;
			}
			else {
				$re = new RE();
				$x = simplexml_load_string("<?xml version=\"1.0\" ?><RE><text>Survey on setup</text></RE>");
				$re->readXML($x);
				$this->rootelement->addChild( $re );
				return false;
			}
		}
		else if( END < Timing::currentTime() ){
			if( file_exists( PROJECT_PATH."finish.html" ) ){
				$this->rootelement = null;
				require( PROJECT_PATH."finish.html" );
				return false;
			}
			else if( isset( self::$document->codebook[0]->FINISH[0] ) ){
				$this->rootelement->readXML( self::$document->codebook[0]->FINISH[0] );
				return false;
			}
			else {
				$re = new RE();
				$x = simplexml_load_string("<?xml version=\"1.0\" ?><RE><text>Survey finished</text></RE>");
				$re->readXML($x);
				$this->rootelement->addChild( $re );
				return false;
			}
		}
		return true;
	}
	
	function import( &$codebook ){
		global $__PAGE,$__REQUEST_PAGE,$__MAX_PAGE,$__AUTHENTICATIONMODE,$__ERROR;
		/** IMPORT **/
		$att = $codebook->attributes();
		if( isset( $att["importfile"] ) ){
			$import = $att["importfile"];
			if( count( split( "/", $import) ) == 2 ){
				if( file_exists( PROJECT_PATH."/../".$import ) ){
					$docimp = simplexml_load_file( PROJECT_PATH."/../".$import );
					$this->readXML( $docimp );
					return true;
				}
			}
			else{
				if( file_exists( PROJECT_PATH."/".$import ) ){
					$docimp = simplexml_load_file( PROJECT_PATH."/".$import );
					$this->readXML( $docimp );
					return true;
				}
			}
		}
		if( isset( $att["import"] ) ){//Anderes Projekt import="master#A1", eigenes Projekt import="#A2"
			$ref = $att["import"];
			list($remoteproject,$remoteid) = split("#",$ref);
			if( strlen($remoteproject) < 1 ){
				$resultNode = null;
				$restag = "";
				self::xmlSearch( Project::$document, $remoteid, $resultNode, $restag );
				if( $resultNode != null ){
					$this->readXML( $resultNode );
					return true;
				}
			}
			else{
				if( ! isset( self::$remotedocument[$remoteproject] ) ){
					self::$remotedocument[$remoteproject] = simplexml_load_file( PROJECTS_PATH."/".$remoteproject."/.questionnaire" );
				}
				$resultNode = null;
				$restag = "";
				self::xmlSearch( self::$remotedocument[$remoteproject], $remoteid, $resultNode, $restag );
				if( $resultNode != null ){
					$this->readXML( $resultNode );
					return true;
				}
			}
		}
		return false;
	}
	
	function readXML(&$codebook){
		global $__PAGE,$__REQUEST_PAGE,$__MAX_PAGE,$__AUTHENTICATIONMODE,$__ERROR;
		$page = $__REQUEST_PAGE;
		$att = $codebook->attributes();
		
		if(isset($att["format"])) FormItem::$formatterdirectory = $att["format"];
		if(isset($att["dir"])) FormItem::$direction = $att["dir"];
		
		$form = null;
		if(isset($att["use_formatter"])) $form = $att["use_formatter"];
		else $form = $this->formatterclass;

		include_once "./classes/format/".FormItem::$formatterdirectory."/StandardFormatter.class.php";
		include_once "./classes/format/".FormItem::$formatterdirectory."/".$form.".class.php";
		$fce = split("/",$form);
		$fc = $fce[count($fce)-1];
		$this->formatter = new $fc;
		
		if( isset( $att["usestyle"] ) ){
			$this->usestyle = (string)utf8_decode($att["usestyle"]);
		}
		
		foreach( $codebook as $dec => $decl ){
			if( $dec = "declare" ) array_push( Postprocessor::$declarations, $decl );
		}
		$this->rootelement = new Page();
		
		$j = 0;
		foreach( $codebook as $pp => $pa ) if( $pp == "Page" ) $j++;
		if( $j == 0 ){
			$re = new RE();
			$x = simplexml_load_string("<?xml version=\"1.0\" ?><RE><text>No element</text></RE>");
			$re->readXML($x);
			$this->rootelement->addChild($re);
			return;
		}
		$__MAX_PAGE = $j;
		
		if( $__AUTHENTICATIONMODE == "pin" || $__AUTHENTICATIONMODE == "request" ){
			if( $__PAGE >= 1 && $__ERROR != ERROR_OK ){
				$__PAGE = 1;
				if( isset( $codebook->Head[0] ) ){
					if( FormItem::shouldRead( $codebook->Head[0] ) )$this->rootelement->header->readXML( $codebook->Head[0] );
				}
				if( isset( $codebook->Foot[0] ) ){
					if( FormItem::shouldRead( $codebook->Foot[0] ) )$this->rootelement->footer->readXML( $codebook->Foot[0] );
				}
				$this->rootelement->readXML( $codebook->Page[0] );
			}
			else{//no error
				if( $page < $__MAX_PAGE + 1 ){
					$loop = 0;
					while( ! FormItem::shouldRead( $codebook->Page[$page-1] ) ){
						if( $__PAGE < $__REQUEST_PAGE ) $page++;
						else $page--;
						$loop++;
						if( $loop > 100 ){
							print "ERROR";
							die();
							break;
						}							
					}
					$__PAGE = $page;
					if( isset( $codebook->Head[0] ) ){
						if( FormItem::shouldRead( $codebook->Head[0] ) )$this->rootelement->header->readXML( $codebook->Head[0] );
					}
					if( isset( $codebook->Foot[0] ) ){
						if( FormItem::shouldRead( $codebook->Foot[0] ) )$this->rootelement->footer->readXML( $codebook->Foot[0] );
					}
					$this->rootelement->readXML( $codebook->Page[$page-1] );
				}
				else{
					$__PAGE = 1;
					if( isset( $codebook->Head[0] ) ){
						if( FormItem::shouldRead( $codebook->Head[0] ) )$this->rootelement->header->readXML( $codebook->Head[0] );
					}
					if( isset( $codebook->Foot[0] ) ){
						if( FormItem::shouldRead( $codebook->Foot[0] ) )$this->rootelement->footer->readXML( $codebook->Foot[0] );
					}
					$this->rootelement->readXML( $codebook->Page[0] );
				}
			}
		}
		else {//open or poll
			if( $page < $__MAX_PAGE + 1 ){
				$loop = 0;
				while( ! FormItem::shouldRead( $codebook->Page[$page-1] ) ){
					if( $__PAGE < $__REQUEST_PAGE ) $page++;
					else $page--;
					$loop++;
					if( $loop > 100 ){
						print "ERROR";
						die();
						break;
					}
				}
				$__PAGE = $page;
				if( isset( $codebook->Head[0] ) ){
					if( FormItem::shouldRead( $codebook->Head[0] ) ) $this->rootelement->header->readXML( $codebook->Head[0] );
				}
				if( isset( $codebook->Foot[0] ) ){
					if( FormItem::shouldRead( $codebook->Foot[0] ) ) $this->rootelement->footer->readXML( $codebook->Foot[0] );
				}
				$this->rootelement->readXML( $codebook->Page[$page-1] );
			}
			else{
				$__PAGE = 1;
				if( isset( $codebook->Head[0] ) ){
					if( FormItem::shouldRead( $codebook->Head[0] ) )$this->rootelement->header->readXML( $codebook->Head[0] );
				}
				if( isset( $codebook->Foot[0] ) ){
					if( FormItem::shouldRead( $codebook->Foot[0] ) )$this->rootelement->footer->readXML( $codebook->Foot[0] );
				}
				$this->rootelement->readXML( $codebook->Page[0] );
			}
		}	
	}
	
	
	function buildReference( $ref ){
		if( file_exists( PROJECT_PATH.QUESTIONNAIRE ) ){
			$form = $this->formatterclass;
			include_once "./classes/format/".FormItem::$formatterdirectory."/StandardFormatter.class.php";
			include_once "./classes/format/".FormItem::$formatterdirectory."/".$form.".class.php";
			$fce = split("/",$form);
			$fc = $fce[count($fce)-1];
			$this->formatter = new $fc;

			self::$document = simplexml_load_file(PROJECT_PATH.QUESTIONNAIRE);
			$resultNode = null;
			$resultTag = "";
			$level = 0;
			$this->rootelement = new Page();
			$this->rootelement->readXML(simplexml_load_string("<?xml version=\"1.0\" ?><Page/>"));
			self::recursivSearch( self::$document->codebook[0], $ref, $resultNode, $resultTag, $level );
			if( $resultNode != null ){
				$childelement = FormFactory::create( $resultTag );
				$childelement->level = 1;
				$childelement->readXML( $resultNode );
				$this->rootelement->addChild( $childelement );
			}
			else {
				$this->rootelement = new Page();
				$re = new RE();
				$x = simplexml_load_string("<?xml version=\"1.0\" ?><RE><text>Reference not found</text></RE>");
				$re->readXML($x);
				$this->rootelement->addChild( $re );
			}
		}
	}
	
	function searchReference( $ref ){
		if( file_exists( PROJECT_PATH.QUESTIONNAIRE ) ){

			self::$document = simplexml_load_file( PROJECT_PATH.QUESTIONNAIRE );
			$resultNode = null;
			$resultTag = "";
			$level = 0;
			self::recursivSearch(self::$document->codebook[0], $ref, $resultNode, $resultTag, $level);
			$this->rootelement = FormFactory::create( $resultTag );
			$this->rootelement->readXML( $resultNode );
			$this->rootelement->level = 1;//$level;
		}
	}
	
	static function recursivSearch( &$ch, &$search, &$resnode, &$restag, &$level ){
		foreach($ch as $tag=>$nod){
			if($tag == "children") $level++;
			if($nod->id[0] == $search){
				$resnode = $nod;
				$restag = $tag;
				break;
			}
			self::recursivSearch($nod, $search, $resnode, $restag, $level);
		}
	}

	/**
	* 2. Collect variables
	*
	* obsolet
	*/
	function &getVariables(){
		$this->rootelement->getVariables( $this->vars );
		return $this->vars;
	}

	/**
	* 3. Set values
	*
	* obsolet
	*/
	function setVariables( &$vars ){
		$this->rootelement->setVariables( $vars );
	}

	/**
	* 4. Format
	*/
	function format(){
		if($this->rootelement == null) return;
		header("Content-Encoding: text/html; charset=\"UTF-8\"", true);
		$this->formatter->before( $this );
		$this->rootelement->format();
		$this->formatter->behind( $this );
	}

	function formatElement(){
		if($this->rootelement == null) return;
		header("Content-Encoding: text/html; charset=\"UTF-8\"", true);
		print "<html xmlns=\"http://www.w3.org/1999/xhtml\" lang=\"de\" xml:lang=\"de\"\n";
		print "xmlns:qtafi=\"http://localhost/qtafi3\">\n";
		$this->rootelement->format();
		print "</html>";
	}

	function printAllVariables(){
		print_r( $this->vars );
	}
}
?>
