<?
/************************************************************************
*
*  online.QTAFI - online survey
*
*  Copyright (C) 2008  Martin Guist guist@incher.uni-kassel.de
*
*  This program is free software: you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation, either version 3 of the License, or
*  (at your option) any later version.
*
*  This program is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  You should have received a copy of the GNU General Public License
*  along with this program. If not, see <http://www.gnu.org/licenses/>.
*
*************************************************************************/


class StringUtil {
	
	/*
	* Konvertiert [p]fffff[/p] in <p>fffff</p>
	*/
	static function convertHTMLMarker( $s ){
		$s  = htmlentities( $s );
		$s = str_replace( "[", "<", $s );
		$s = str_replace( "]", ">", $s );
		return $s;
	}
	
	static function parseBBCodeSimple( $bbstring ){
		$bbstring = mb_ereg_replace( "[b]", "<b>", $bbstring );
		$bbstring = mb_ereg_replace( "[/b]", "</b>", $bbstring );
		$bbstring = mb_ereg_replace( "[i]", "<i>", $bbstring );
		$bbstring = mb_ereg_replace( "[/i]", "</i>", $bbstring );
		$bbstring = mb_ereg_replace( "[u]", "<u>", $bbstring );
		$bbstring = mb_ereg_replace( "[/u]", "</u>", $bbstring );
		$bbstring = mb_ereg_replace( "[center]", "<center>", $bbstring );
		$bbstring = mb_ereg_replace( "[/center]", "</center>", $bbstring );
		$bbstring = mb_ereg_replace( "[br]", "<br/>", $bbstring );
		$bbstring = mb_ereg_replace( "[br/]", "<br/>", $bbstring );
		return $bbstring;
	}
	
	static function parseBBCodess( $bbstring ){
		return StringUtil::parseBBCodeSimple( $bbstring );
		return $bbstring;
	}
	
	/**
	* Error multibyte support
	*/
	static function parseBBCode( $bbstring ){
		//var_dump( $bbstring );
		$result = "";
		$starttag = "";
		$tagstack = array();
		$endtag = "";
		$state = 0;
		$cont = false;
		for( $i = 0; $i < mb_strlen( $bbstring ); $i++ ){
			$char = mb_substr( $bbstring, $i, 1 );
			switch( $char ){
				case "[": 
					$state = 1;
					$cont = true;
				break;
				case "]":
					if( $state == 1 ){
						if( $starttag == "br" ) $result .= "<br/>";
						else if( StringUtil::tagAllowed( $starttag ) ){
							$result .= "<".$starttag.">";
							array_push( $tagstack, $starttag );
						}
						else $result .= "[".$starttag."]";
						$starttag = "";
					}
					else if( $state == 2 ){
						if( StringUtil::tagAllowed( $endtag ) ) {
							$xtag = array_pop( $tagstack );
							if( $xtag == $endtag ) $result .= "</".$endtag.">";
							else array_push( $tagstack, $xtag );
						}
						else $result .= "[/".$endtag."]";
						$endtag = "";
					}
					$state = 0;
					$cont = true;
				break;
				case "/":
					if( $state == 1 ){
						$state = 2;
						$cont = true;
					}
				break;
			}
			if( $cont ){
				$cont = false;
			}
			else{
				switch( $state ){
					case 0: $result .= $char; break;
					case 1: $starttag .= $char; break;
					case 2: $endtag .= $char; break;
				}
			}
		}
		
		while( count( $tagstack ) ){
			$ee = array_pop( $tagstack );
			$result .= "</".$ee.">";
		}
		//var_dump( $result );
		return $result;
	}
	
	static function tagAllowed( $bbtag ){
		switch( $bbtag ){
			case "b" : return true;
			case "u" : return true;
			case "center" : return true;
			case "br" : return true;
			case "i": return true;
			case "small": return true;
			default: return false;
		}
	}
	
}
?>
