<?
/************************************************************************
*
*  online.QTAFI - online survey
*
*  Copyright (C) 2008  Martin Guist guist@incher.uni-kassel.de
*
*  This program is free software: you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation, either version 3 of the License, or
*  (at your option) any later version.
*
*  This program is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  You should have received a copy of the GNU General Public License
*  along with this program. If not, see <http://www.gnu.org/licenses/>.
*
*************************************************************************/

/**
* COLUMNCONTAINER
*
*/
class COLUMNCONTAINER extends FormItem {

	public $columns = array();
	public $labels = array();

	function __construct(){
		parent::__construct();
		$this->type = "COLUMNCONTAINER";
		$this->formatterclass = "COLUMNCONTAINERFormatter";
	}

	function readXML( &$doc ){
		parent::readXML( $doc );
		foreach( $doc as $n => $v ){
			switch( $n ){
				case "column":
					$att = $v->attributes();
					if( isset( $att["ref"] ) ){
						if( isset( $att["type"] ) ){
							$t = utf8_decode($att["type"]);
							$ref = array( "ref" => utf8_decode($att["ref"]), "type" => $t );
							array_push( $this->columns, $ref );
						}
						else {
							$ref = array( "ref" => utf8_decode($att["ref"]), "type" => "input" );
							array_push( $this->columns, $ref );
						}
					}
					else if( isset( $att["labelref"] ) ){
						$ref = array( "ref" => utf8_decode($att["labelref"]), "type" => "label" );
						array_push( $this->columns, $ref );
					}
					if( isset( $att["align"] ) ){
					}

					if( isset( $att["label"] ) ){
						$bb = StringUtil::parseBBCode( $att["label"] );
						//array_push( $this->labels, $att["label"] );
						array_push( $this->labels, $bb );
					}
					else array_push( $this->labels, "" );
				break;
			}
		}
	}
}
?>