<?
/************************************************************************
*
*  online.QTAFI - online survey
*
*  Copyright (C) 2008  Martin Guist guist@incher.uni-kassel.de
*
*  This program is free software: you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation, either version 3 of the License, or
*  (at your option) any later version.
*
*  This program is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
*  GNU General Public License for more details.
*
*  You should have received a copy of the GNU General Public License
*  along with this program. If not, see <http://www.gnu.org/licenses/>.
*
*************************************************************************/

/**
* Categorical Question
*
* Example
*
* <CV>
* 	<text>How do you feel?</text>
* 	<variable>feeling</variable>
* 	<answer label="good" category="XXX">1</answer>
* 	<answer label="bad" size="50" >10</answer>
* </CV>
*/
class CV extends FormItem {

	public $values = array();
	public $valueprops = array();
	public $missing = array();
	public $otherref = array();
	public $labels = array();
	public $layoutType = "radiobutton"; //horizontal, pulldown, hierarchic
	public $size = 1;

	function __construct(){
		parent::__construct();
		$this->type = "CV";
		$this->formatterclass = "CVFormatter";
	}

	function readXML( &$doc ){
		global $__IE6;
		parent::readXML( $doc );
		$att = $doc->attributes();
		if(isset( $att["type"])){//deprecated
			$this->layoutType = $att["type"];
			if($this->layoutType =='popup' && $__IE6) $this->layoutType = 'pulldown';
		}
		foreach( $doc as $n => $v ){
			switch( $n ){
				case "value":
					$an = utf8_decode($v);
					$val = array();
					$this->values[] = $an;
					$att = $v->attributes();

					if( isset($att["label"] ) ){
						$this->labels[$an] = StringUtil::parseBBCode( $att["label"] );
						$val["label"] = $att["label"];
					}
					else {
						$this->labels[$an] = "";
						$val["label"] = "";
					}

					if(isset($att["missing"])) $this->missing[$an] = $att["missing"];
					else $this->missing[$an] = "false";

					if( isset($att["otherref"])) $this->otherref[$an] = utf8_decode($att["otherref"]);
					else if( isset($att["subitem"])) $this->otherref[$an] = utf8_decode($att["subitem"]);
					//if( isset($att["subitem"])) $this->otherref[$an] = utf8_decode($att["subitem"]);
					else $this->otherref[$an] = "__none";

					
					if( isset( $att["category"] )){
						$val["category"] = $att["category"];
						$val["catkey"] = (string)utf8_decode($att["category"]);
					}
					else{
						$val["category"] = "__none";
						$val["catkey"] = "__none";
					}

					if( isset( $att["subcategory"] )){
						$val["subcategory"] = $att["subcategory"];
						$val["subcatkey"] = (string)utf8_decode($att["subcategory"]);
					}
					else {
						$val["subcategory"] = "__none";
						$val["subcatkey"] = "__none";
					}

					$val["value"] = $an;
					$this->valueprops[$an] = $val;
				break;

				case "type":
					$this->layoutType = $v;
					if($this->layoutType =='popup' && $__IE6) $this->layoutType = 'pulldown';
				break;

				case "size":
					$this->size = $v;
				break;
			}
		}
	}
}
?>