<?
/************************************************************************
*
*  online.QTAFI - online survey
*
*  Copyright (C) 2008  Martin Guist guist@incher.uni-kassel.de
*
*  This program is free software: you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation, either version 3 of the License, or
*  (at your option) any later version.
*
*  This program is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
*  GNU General Public License for more details.
*
*  You should have received a copy of the GNU General Public License
*  along with this program. If not, see <http://www.gnu.org/licenses/>.
*
*************************************************************************/

include_once "Serializable.interface.php";

/**
* Example
*
* <item type>
* 	<text>How do you feel?</text>
* 	<variable label="" >feeling</variable>
* 	<subject>Subject</subject>
* 	<id>A</id>
* 	<children>
* 		<another_item />
* 	</children>
* </item type>
*/
abstract class FormItem implements Serializable2 {

	public static $formatterdirectory = "";
	public static $direction = "ltr"; //rtl;

	public $nr = 0;					//typ int (internal id)
	public $id = "";				//typ string
	public $subject = "";				//typ string
	public $text = "";				//typ string
	public $moretext = "";				//typ string
	public $type = "FormItem";			//typ string
	public $number = "";				//typ string
	public $layout = "vertical";			//typ string
	public $formatterclass = "";
		

	public $level = 0;				//typ int
	public $filter = array();

	public $variables = array();
	public $varlabels = array();
	public $before = array();
	public $behind = array();
	public $category = array();
	public $appearance = array();

	public $childCount = 0;				//typ int
	public $childNum = 0;				//typ int

	protected $parentObj;				//typ FormItem
	public $children = array();			//typ array FormItem
	public $formatter;				//typ Formater

	public $empty;					//typ boolean
	public $invisible;				//typ boolean

	public $footer;
	public $header;
	
	public $show_if = array();
	public $enable_if = array();
	public $execute_on = array();
	public $variableprefix = "";

	public static $remotedocument = array();
	public static $ccc = 0;
	
	function __construct(){
		$this->formatterclass = "StandardFormatter";
		$this->empty = true;
		$this->invisible = false;
		FormItem::$ccc++;
		$this->nr = FormItem::$ccc;
		//$this->nr = $this->type."".FormItem::$ccc;
	}

	function format(){
		global $__PAGE;
		//$this->nr = FormItem::$ccc;//($__PAGE * 100) + ($this->level * 10) + $this->childNum;
		$i = sizeof( $this->children );
		if( ! $this->invisible ) $this->formatter->before( $this );
		$j = 1;
		foreach( $this->children as $child ){
			if( ! $child->invisible ){
				if( strlen( $child->id ) > 0 ) print "<div id=\"".$child->id."\">\n";
				$child->format();
				if( strlen( $child->id ) > 0 ) print "</div>\n";
				if( ! $this->invisible )  if( $j < $i ) $this->formatter->between( $this, $j );
				$j++;
			}
		}
		if( ! $this->invisible ) $this->formatter->behind( $this );
	}

	function setText( $str ){
		$this->text = $str;
	}

	function readXML( &$doc ){
		$att = $doc->attributes();
		if(isset($att["variableprefix"])) $this->variableprefix = $att["variableprefix"];
		if(isset($att["level"])) $this->level = $att["level"];
		
		$form = null;
		if(isset($att["use_formatter"])) $form = $att["use_formatter"];
		else $form = $this->formatterclass;
	
		include_once "./classes/format/".FormItem::$formatterdirectory."/StandardFormatter.class.php";
		include_once "./classes/format/".FormItem::$formatterdirectory."/".$form.".class.php";
		$fce = split("/",$form);
		$fc = $fce[count($fce)-1];
		$this->formatter = new $fc;
		
		if( isset( $att["importfile"] ) ){
			$import = $att["importfile"];
			if( count( split( "/", $import) ) == 2 ){
				if( file_exists( PROJECT_PATH."/../".$import ) ){
					$docimp = simplexml_load_file( PROJECT_PATH."/../".$import );
					$this->readXML( $docimp );
				}
			}
			else {
				if( file_exists( PROJECT_PATH."/".$import ) ){
					$docimp = simplexml_load_file( PROJECT_PATH."/".$import );
					$this->readXML( $docimp );
				}
			}
		}
		if( isset( $att["import"] ) ){//Anderes Projekt import="master#A1", eigenes Projekt import="#A2"
			$ref = $att["import"];
			list($remoteproject,$remoteid) = split("#",$ref);
			if( strlen($remoteproject) < 1 ){
				$resultNode = null;
				$restag = "";
				self::xmlSearch( Project::$document, $remoteid, $resultNode, $restag );
				if( $resultNode != null ) $this->readXML( $resultNode );
			}
			else{
				if( ! isset( self::$remotedocument[$remoteproject] ) ){
					self::$remotedocument[$remoteproject] = simplexml_load_file( PROJECTS_PATH."/".$remoteproject."/.questionnaire" );
				}
				$resultNode = null;
				$restag = "";
				self::xmlSearch( self::$remotedocument[$remoteproject], $remoteid, $resultNode, $restag );
				if( $resultNode != null ) $this->readXML( $resultNode );
			}
		}

		foreach( $doc as $n => $v ){
			switch( $n ){
				case "declare":
					$att = $v->attributes();
					Postprocessor::$declarations[(string)utf8_decode($att["name"])] = $v;
				break;
				
				case "text":
					$this->empty = false;
					//$ss = mb_ereg_replace( "<text>", "", $v->asXML() );
					//$ss = mb_ereg_replace( "</text>", "", $ss );
					//$this->text = StringUtil::parseBBCode( $ss );
					if(count($v->children())>0) $this->text = StringUtil::parseBBCode($v->children()->asXML());
					else $this->text = StringUtil::parseBBCode($v);
					
				break;

				case "moretext":
					//$ss = mb_ereg_replace( "<moretext>", "", $v->asXML() );
					//$ss = mb_ereg_replace( "</moretext>", "", $ss );
					//$this->moretext = StringUtil::parseBBCode($ss);
					if(count($v->children())>0) $this->moretext = StringUtil::parseBBCode($v->children()->asXML());
					else $this->moretext = StringUtil::parseBBCode($v);
				break;

				case "subject":
					$this->subject = $v->asXML();
				break;

				case "id":
					$this->id = (string)utf8_decode($v);
				break;

				case "number":
					//$ss = mb_ereg_replace( "<number>", "", $v->asXML() );
					//$ss = mb_ereg_replace( "</number>", "", $ss );
					//$this->number = StringUtil::parseBBCode( $ss );
					//$this->number = $v;
					if(count($v->children())>0) $this->number = StringUtil::parseBBCode($v->children()->asXML());
					else $this->number = StringUtil::parseBBCode($v);
				break;

				case "appearance":
					$att = $v->attributes();
					foreach( $att as $an => $av ) $this->appearance[$an] = $av;
				break;

				case "variable":
					$variablename = (string)($this->variableprefix.$v);
					$this->variables[(string)$variablename] = MISSING;
					$att = $v->attributes();

					if(isset($att["label"])) $this->varlabels[(string)$variablename] = StringUtil::parseBBCode( $att["label"] );//$att["label"];
					else $this->varlabels[(string)$variablename] = "";

					if(isset($att["before"])) $this->before[(string)$variablename] = StringUtil::parseBBCode( $att["before"] );//$att["before"];
					else $this->before[(string)$variablename] = "";

					if(isset($att["behind"])) $this->behind[(string)$variablename] = StringUtil::parseBBCode( $att["behind"] );//$att["behind"];
					else $this->behind[(string)$variablename] = "";

					if( isset( $att["category"] )){
						$this->category[(string)$variablename]["category"] = $att["category"];
						$this->category[(string)$variablename]["catkey"] = (string)utf8_decode($att["category"]);
					}
					else{
						$this->category[(string)$variablename]["category"] = "__none";
						$this->category[(string)$variablename]["catkey"] = "__none";
					}
				break;

				case "layout":
					$this->layout = $v;
				break;

				case "invisible":
					$this->invisible = true;
				break;

				case "filter":
					foreach( $v as $filter => $filter_val ){
						$att = $filter_val->attributes();
						switch( $filter ){
							case "show_if":
								$ff = array();
								if(isset($att["variable"])) $ff["var"]=$att["variable"];
								else $ff["var"]="-9";
								if(isset($att["value"])) $ff["val"]=$att["value"];
								else $ff["val"]="-9";
								if(isset($att["operator"])) $ff["op"]=$att["operator"];
								else $ff["op"] = "IS";
								$ff["cond"] = "root";
								array_push( $this->show_if, $ff );
							break;
							case "show_group":
								$sgroup = array();
								$sgroup["cond"] = (string)$att["condition"];
								foreach( $filter_val as $nns => $vals ){
									$satt = $vals->attributes();
									if( $nns == "show_if" ){
										$ff = array();
										if(isset($satt["variable"])) $ff["var"]=$satt["variable"];
										else $sff["var"]="-9";
										if(isset($satt["value"])) $ff["val"]=$satt["value"];
										else $ff["val"]="-9";
										if(isset($satt["operator"])) $ff["op"]=$satt["operator"];
										else $ff["op"] = "IS";
										$ff["cond"] = "-9";
										array_push( $sgroup, $ff );
									}
								}
								array_push( $this->show_if, $sgroup );
							break;
							case "enable_if":
								$ff = array();
								if(isset($att["variable"])) $ff["var"]=$att["variable"];
								else $ff["var"]="-9";
								if(isset($att["value"])) $ff["val"]=$att["value"];
								else $ff["val"]="-9";
								if(isset($att["operator"])) $ff["op"]=$att["operator"];
								else $ff["op"] = "IS";
								array_push( $this->enable_if, $ff );
							break;
							
							case "validate_on":
								$valObj = array();
								$valObj["type"] = "validate";
								$valObj["var"] = "";
								if(isset($att["variable"])) $valObj["var"] = $att["variable"];
								$valObj["val"] = "-9";
								if(isset($att["value"])) $valObj["val"] = $att["value"];
								if(isset($att["operator"]))$valObj["op"] = $att["operator"];
								else $valObj["op"] = "IS";
								$nset = 0; $nalert = 0;
								foreach( $filter_val as $set => $set_val ){
									$setatt = $set_val->attributes();
									if( $set == "set" ){
										if( ! isset( $valObj["set"] ) ) $valObj["set"] = array();
										$valObj["set"][$nset] = array();
										$valObj["set"][$nset]["setvar"] = $setatt["variable"];
										$valObj["set"][$nset]["setval"] = $setatt["value"];
										$nset++;
									}
									else if( $set == "alert" ){
										if(! isset( $valObj["alert"] ) ) $valObj["alert"] = array();
										$valObj["alert"][$nalert] = array();
										$valObj["alert"][$nalert]["message"] = $setatt["message"];
										$nalert++;
									}
									else if( $set == "enable" ){
										if(! isset( $valObj["enable"] ) ){
											$valObj["enable"] = array();
											$nenable = 0;
										}
										$valObj["enable"][$nenable] = array();
										$valObj["enable"][$nenable]["var"] = $setatt["variable"];
										$nenable++;
									}
									else if( $set == "disable" ){
										if(! isset( $valObj["disable"] ) ){
											$valObj["disable"] = array();
											$ndisable = 0;
										}
										$valObj["disable"][$ndisable] = array();
										$valObj["disable"][$ndisable]["var"] = $setatt["variable"];
										$ndisable++;
									}
									else if( $set == "scrollto" ){
										if(! isset( $valObj["scrollto"] ) ){
											$valObj["scrollto"] = array();
											$nscrollto = 0;
											$valObj["scrollto"][$nscrollto] = array();
											$valObj["scrollto"][$nscrollto]["id"] = $setatt["id"];
										}
										$nscrollto++;
									}
								}
								array_push($this->execute_on, $valObj);
							break;
										
							case "request_on_change":
								$valObj = array();
								$valObj["var"] = "";
								$valObj["type"] = "request_on_change";
								if(isset($att["variable"])) $valObj["var"] = $att["variable"];
								if(isset($att["post"])) $valObj["post"] = $att["post"];
								array_push($this->execute_on, $valObj);
							break;
							
							case "post_on_change":
								$valObj = array();
								$valObj["var"] = "";
								$valObj["type"] = "post_on_change";
								if(isset($att["variable"])) $valObj["var"] = $att["variable"];
								if(isset($att["post"])) $valObj["post"] = $att["post"];
								array_push($this->execute_on, $valObj);
							break;
						}
					}
				break;
				
				case "children":
					$this->empty = false;
					foreach( $v as $item => $item_val ){
						if( $this->shouldRead( $item_val ) ){
							$child = FormFactory::create( $item );
							$child->variableprefix = $this->variableprefix;
							$this->addChild( $child );
							$child->readXML( $item_val );
						}
					}
				break;
			}
		}
	}

	function addChild( &$item ){
		global $__PAGE;
		$this->children[] = $item;
		$item->parentObj = $this;
		$item->childNum = $this->childCount;
		$this->childCount++;
		$item->level = $this->level + 1;
	}

	function removeChild( &$item ){
		$i = array_search( $item, $this->children );
		unset( $this->children[$i] );
		$item->parentObj = null;
		$this->childCount--;
	}

	function getVariables( &$vars ){
		$vars = array_merge( $vars, $this->variables );
		foreach( $this->children as $child ){
			$child->getVariables( $vars );
		}
	}

	function setVariables( &$vars ){
		foreach( $this->variables as $n => $v ){
			if( array_key_exists( (string)$n, $vars ) ){
				$this->variables[(string)$n] = $vars[(string)$n];
			}
		}
		foreach( $this->children as $child ){
			$child->setVariables( $vars );
		}
	}

	/**
	* Checks whether the item should be ignored cause of an ignore_if tag
	*
	* Return true if it has to be read, false if not
	*
	* <ignore_if variable="ddd" value="dd" operator="" />
	* Operators:
	* - IS (default) 	=> 0
	* - IS_NOT		=> 1
	* - IS_LOWER		=> 2
	* - IS_GREATER		=> 3
	*
	* <ignore_group condition="AND"|"OR">
	* 	<ignore_if variable="" value="" />
	* 	<ignore_if variable="" value="" />
	* <ignore_group>
	*/
	static function shouldRead( &$item ){
		global $user,$__PAGE,$__REQUEST_PAGE,$__MAX_PAGE;
		$operator = "IS";
		$result = true;
		foreach( $item as $n => $v ){
			if( $n == "ignore_if" ){
				$att = $v->attributes();
				if( isset( $att["variable"] ) && isset( $att["value"] ) ){
					if( isset( $att["operator"] ) ) $operator = $att["operator"];
					else $operator = "IS";
					$variable = $att["variable"];
					$value = $att["value"];
					if( $variable == "__page" ){
						if( $value == "LASTPAGE" ){
							//if( self::compare( $__PAGE, $__MAX_PAGE, $operator ) ) return false;
							if( self::compare( $__PAGE, $__MAX_PAGE, $operator ) ) return false;
						}
						if( $value == "FIRSTPAGE" ){
							if( self::compare( $__PAGE, 1, $operator ) ) return false;
						}
						if( self::compare( $__PAGE, $value, $operator ) ) return false;
					}
					else{
						if( self::compare( $user->getValue( $variable ), $value, $operator ) ) return false;
					}
				}
			}
			else if( $n == "ignore_group" ){
				$condition = "AND";
				$att = $v->attributes();
				if( isset( $att["condition"] ) ) $condition = $att["condition"];
				if( $condition == "AND" ) $res = false;
				else $res = true;
				$operator2 = "IS";
				foreach( $v as $n2 => $v2 ){
					if( $n2 == "ignore_if" ){
						$att2 = $v2->attributes();
						if( isset( $att2["variable"] ) && isset( $att2["value"] ) ){
							if( isset( $att2["operator"] ) ) $operator2 = $att2["operator"];
							else $operator2 = "IS";
							$variable2 = $att2["variable"];
							$value2 = $att2["value"];
							if( $condition == "AND" ){
								if( ! self::compare( $user->getValue( $variable2 ), $value2, $operator2 ) ) $res = true;
							}
							else {
								if( self::compare( $user->getValue( $variable2 ), $value2, $operator2 ) ) return false;
							}
						}
					}
				}
				if( $res == false ) return false;
				//return $res;
			}
			else if( $n == "filter" ){
				return self::shouldRead( $v );
			}
		}
		return true;
	}

	static function xmlSearch( &$ch, &$search, &$resnode, &$restag ){
		foreach( $ch as $tag=>$nod ){
			if( $nod->id[0] == $search ){
				$resnode = $nod;
				$restag = $tag;
				break;
			}
			self::xmlSearch( $nod, $search, $resnode, $restag );
		}
	}


	static function search( $startnode, $refid, &$result ){
		foreach( $startnode->children as $chi ){
			if( $chi->id == $refid ){
				$result = $chi;
				return;
			}
			self::search( $chi, $refid, $result );
		}
 	}

	static function compare( $value1, $value2, $op ){
		switch( $op ){
			case 'IS':
				return $value1 == $value2;

			case 'IS_NOT':
				return $value1 != $value2;

			case 'IS_LOWER':
				return $value1 < $value2;

			case 'IS_GREATER':
				return $value1 > $value2;

			default:
				return false;
		}
	}

	function toString(){
		print "$this->text \n";
		foreach( $this->children as $child ){
			$child->toString();
		}
	}
}

$files = scandir( "./classes/composite/" );
foreach( $files as $f ) if( $f != "." && $f != ".." ) include_once $f;
?>
