<?
/************************************************************************
*
*  online.QTAFI - online survey
*
*  Copyright (C) 2008  Martin Guist guist@incher.uni-kassel.de
*
*  This program is free software: you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation, either version 3 of the License, or
*  (at your option) any later version.
*
*  This program is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
*  GNU General Public License for more details.
*
*  You should have received a copy of the GNU General Public License
*  along with this program. If not, see <http://www.gnu.org/licenses/>.
*
*************************************************************************/

/**
* Multiple Dichotomous Question
*
* Example
*
* <MD>
* 	<text>Question</text>
* 	<variable label="Answer 1">V1</variable>
*   <value label="ffff" missing="true">x</value>
* </MD>
*/
class MD extends FormItem {

	public $values = array();
	public $labels = array(""=>"");
	public $otherref = array();
	public $missing = array();

	function __construct(){
		parent::__construct();
		$this->type = "MD";
		$this->formatterclass = "MDFormatter";
		//$this->formatter = new MDFormatter();
	}

	function readXML( &$doc ){
		parent::readXML( $doc );
		foreach( $doc as $n => $v ){
			switch( $n ){

				case "value":
					$an = (string)utf8_decode($v);
					$this->values[] = $an;
					$att = $v->attributes();

					if(isset($att["label"]))$this->labels[$an] = $att["label"];
					else $this->labels[$an] = "";

					if(isset($att["missing"])) $this->missing[$an] = $att["missing"];
					else $this->missing[$an] = "false";
				break;

				case "variable":
					$variablename = (string)($this->variableprefix.$v);
					$att = $v->attributes();
 					if( isset( $att["otherref"] )) $this->otherref[(string)$variablename] = utf8_decode($att["otherref"]);
					else if( isset( $att["subitem"] )) $this->otherref[(string)$variablename] = utf8_decode($att["subitem"]);
					else $this->otherref[(string)$variablename] = "__none";
				break;
			}
		}
	}
}
?>