<?
/************************************************************************
*
*  online.QTAFI - online survey
*
*  Copyright (C) 2008  Martin Guist guist@incher.uni-kassel.de
*
*  This program is free software: you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation, either version 3 of the License, or
*  (at your option) any later version.
*
*  This program is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
*  GNU General Public License for more details.
*
*  You should have received a copy of the GNU General Public License
*  along with this program. If not, see <http://www.gnu.org/licenses/>.
*
*************************************************************************/

/**
* The Navigation Buttons
*
* like Forward and Backward
*
* <NavigationButton>
*     <forwardbutton label="Weiter"/>
* </NavigationButton>
*/
class NavigationButton extends FormItem {

	public $forwardlabel = "Forward";
	public $backwardlabel = "Back";

	function __construct(){
		parent::__construct();
		$this->type = "NavigationButton";
		$this->formatterclass = "NavigationButtonFormatter";
	}

	function readXML( &$doc ){
		parent::readXML( $doc );
		$att = $doc->attributes();

		if( isset( $att["forwardlabel"] ) ){//deprecated
			$this->forwardlabel = $att["forwardlabel"];
		}
		if( isset( $att["backwardlabel"] ) ){//deprecated
			$this->backwardlabel = $att["backwardlabel"];
		}

		foreach( $doc as $n => $v ){
			$att = $v->attributes();
			switch( $n ){
				case "forwardbutton":
					if(isset($att["label"])) $this->forwardlabel = $att["label"];
					break;
				case "backwardbutton":
					if(isset($att["label"])) $this->backwardlabel = $att["label"];
					break;
			}
		}
	}
}
?>