<?
/************************************************************************
*
*  online.QTAFI - online survey
*
*  Copyright (C) 2008  Martin Guist guist@incher.uni-kassel.de
*
*  This program is free software: you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation, either version 3 of the License, or
*  (at your option) any later version.
*
*  This program is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
*  GNU General Public License for more details.
*
*  You should have received a copy of the GNU General Public License
*  along with this program. If not, see <http://www.gnu.org/licenses/>.
*
*************************************************************************/

/**
* Ordinale Question
*
* Example
*
* <OR>
* 	<text>How do you feel?</text>
* 	<variable>feeling</variable>
* 	<value label="good">1</value>
* 	<value label="ohlala">5</value>
* 	<value label="bad">10</value>
* 	<value label="no answer" missing="true">10</value>
* </OR>
*
*/
class ORD extends FormItem {

	public $values = array();
	public $visiblenumber = array();
	public $labels = array();
	public $missing = array();
	public $otherref = array();
	public $hidevalue = array();
	public $columnWidth = 50;

	function __construct(){
		parent::__construct();
		$this->type = "OR";
		$this->formatterclass = "ORFormatter";
	}

	function readXML( &$doc ){
		parent::readXML( $doc );
		foreach( $doc as $n => $v ){
			switch( $n ){
				case "value":
					$an = utf8_decode($v);
					$this->values[] = $an;
					$att = $v->attributes();
					if(isset($att["label"])) $this->labels[$an] = StringUtil::parseBBCode($att["label"]);
					else $this->labels[$an] = "";

					if(isset($att["missing"]))$this->missing[$an] = $att["missing"];
					else $this->missing[$an] = "false";
					
					if(isset($att["hidevalue"])) $this->hidevalue[$an] = $att["hidevalue"];
					else $this->hidevalue[$an] = "false";
					
					if(isset($att["number"])) $this->visiblenumber[$an] = StringUtil::parseBBCode($att["number"]);
					else $this->visiblenumber[$an] = "";
				break;

 				case "variable":
					$variablename = (string)($this->variableprefix.$v);
					$att = $v->attributes();

 					if( isset( $att["otherref"] )) $this->otherref[(string)$variablename] = $att["otherref"];
					else if( isset( $att["subitem"] )) $this->otherref[(string)$variablename] = $att["subitem"];
					else $this->otherref[(string)$variablename] = "__none";

					if(isset($att["category"])) $this->category[(string)$variablename] = $att["category"];
					else $this->category[(string)$variablename] = "__none";
				break;

				case "width" :
					$this->columnWidth = (int)$v;
				break;
			}
		}
	}
}
?>