<?
/************************************************************************
*
*  online.QTAFI - online survey
*
*  Copyright (C) 2008  Martin Guist guist@incher.uni-kassel.de
*
*  This program is free software: you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation, either version 3 of the License, or
*  (at your option) any later version.
*
*  This program is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
*  GNU General Public License for more details.
*
*  You should have received a copy of the GNU General Public License
*  along with this program. If not, see <http://www.gnu.org/licenses/>.
*
*************************************************************************/

/**
* The Login Item
*
* the variable is always __pin
*
* <PIN buttonlabel="Logon" requestmessage="Dein PIN" requestbuttonlabel="Hol Ihn dir" >
*    <text>Question</text>
*    <logonbutton label="Logon" />
*    <requesthelp>Bitte notieren Sie sich den PIN</requesthelp>
*    <errormessage></errormessage>
* </PIN>
*/
class PIN extends FormItem {

	public $buttonlabel = "Logon";
	public $errormessage = "PIN not valid";

	public $requestbuttonlabel = "Request PIN";
	public $requestmessage = "Your PIN:";
	public $requesthelp = "";

	function __construct(){
		parent::__construct();
		$this->type = "PIN";
		$this->formatterclass = "PINFormatter";
	}

	function readXML( &$doc ){
		parent::readXML( $doc );
		$att = $doc->attributes();
		
		if(isset($att["buttonlabel"])){
			$this->buttonlabel =  $att["buttonlabel"];
		}
		if( isset( $att["requestbuttonlabel"] ) ){
				$this->requestbuttonlabel = $att["requestbuttonlabel"];
		}
		if( isset( $att["requestmessage"] ) ){
			$this->requestmessage = $att["requestmessage"];
		}
		
		foreach( $doc as $n => $v ){
			$att = $v->attributes();
			switch( $n ){
				case "errormessage":
					$this->errormessage = $v;
					//$this->errormessage = utf8_decode( $v );
				break;
				case "requesthelp":
					$this->requesthelp = $v->asXML();
					$this->requesthelp = str_replace( "<requesthelp>", "", $this->requesthelp );
					$this->requesthelp = str_replace( "</requesthelp>", "", $this->requesthelp );
					break;
				case "logonbutton":
					if(isset($att["label"])) $this->buttonlabel = $att["label"];
					break;
				case "requestbutton":
					if(isset($att["label"])) $this->requestbuttonlabel = $att["label"];
					break;
				case "requestmessage":
					if(isset($att["label"])) $this->requestmessage = $att["label"];
					break;
			}
		}
	}
}
?>