<?
/************************************************************************
*
*  online.QTAFI - online survey
*
*  Copyright (C) 2008  Martin Guist guist@incher.uni-kassel.de
*
*  This program is free software: you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation, either version 3 of the License, or
*  (at your option) any later version.
*
*  This program is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
*  GNU General Public License for more details.
*
*  You should have received a copy of the GNU General Public License
*  along with this program. If not, see <http://www.gnu.org/licenses/>.
*
*************************************************************************/

/**
* Textarea input field
*
* datatype in database should be TEXT
*
* <TL>
*    <text>Question</text>
*    <subject></subject>
*    <variable></variable>
*    <width></width>
*    <height></height>
* </TL>
*/
class TL extends FormItem {

	public $width = 30;
	public $height = 5;
	public $before = array();
	public $behind = array();

	function __construct(){
		parent::__construct();
		$this->type = "TL";
		$this->formatterclass = FormItem::$formatterdirectory."/TLFormatter";
		//$this->formatter = new TLFormatter();
	}

	function readXML( &$doc ){
		parent::readXML( $doc );
		foreach( $doc as $n => $v ){ 
			switch( $n ){
				case "width":
				$this->width = (int)$v;
			break;
			case "height":
				$this->height = (int)$v;
			break;
			case "variable":
				$variablename = (string)($this->variableprefix.$v);
				$att = $v->attributes();
				if(isset($att["before"])) $this->before[(string)$variablename] = $att["before"];
				else $this->before[(string)$variablename] = "";

				if(isset($att["behind"])) $this->behind[(string)$variablename] = $att["behind"];
				else $this->behind[(string)$variablename] = "";
			break;
			}
		}
	}
}
?>