<?
/************************************************************************
*
*  online.QTAFI - online survey
*
*  Copyright (C) 2008  Martin Guist guist@incher.uni-kassel.de
*
*  This program is free software: you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation, either version 3 of the License, or
*  (at your option) any later version.
*
*  This program is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
*  GNU General Public License for more details.
*
*  You should have received a copy of the GNU General Public License
*  along with this program. If not, see <http://www.gnu.org/licenses/>.
*
*************************************************************************/

/**
* Formats the column container
*/
class COLUMNCONTAINERFormatter extends StandardFormatter {

	function before( &$quest ){
		$columnNodes = array();
		$labelsNode = null;
		$labelColumn = -1;
		$containsOR = false;
		$colcounter = 0;
		$colnum = 0;
		foreach( $quest->columns as $ref ){
			if( $ref["type"] == "label" ){
				FormItem::search( $quest, $ref["ref"], $labelsNode );
				$labelColumn = $colnum;
			}
			FormItem::search( $quest, $ref["ref"], $columnNodes[$colnum] );
			if( $columnNodes[$colnum]->type == "OR" ){
				$containsOR = true;
				foreach( $columnNodes[$colnum]->values as $n ){
					if( $columnNodes[$colnum]->missing[$n] == "true" ) continue;
					$colcounter++;
				}
			}
			else $colcounter++;
			$colnum++;
		}

		$cols = 1;
		if( $quest->layout == "horizontal" ) $cols = $quest->childCount;
		print "<!-- start CCFormatter -->\n";
		print "<table width=\"100%\" class=\"item".$quest->level."\" cellpadding=\"0\" cellspacing=\"0\" >\n";
		print "    <tr>\n";
		print "          <td colspan=\"".($colcounter)."\" >\n";
		$this->head( $quest );
		print "          </td>\n";
		print "     </tr>\n";


		//Kopf
		print "<tr>\n";
		for( $nn = 0; $nn < $colnum; $nn++ ){
			if( $quest->columns[$nn]["type"] != "label" && $columnNodes[$nn]->type=="OR" ){
				$orcount = 0;
				foreach( $columnNodes[$nn]->values as $n ){
					if( $columnNodes[$nn]->missing[$n] == "true" ) continue;
					$orcount++;
				}
				print "<td class=\"cc_headinput\" style=\"width:40px; padding-bottom:6px;\" colspan=\"$orcount\">".$quest->labels[$nn]."</td>\n";
			}
			else if( $quest->columns[$nn]["type"] != "label" && isset( $quest->labels[$nn] ) ){
				print "<td class=\"cc_headlabel\" style=\"width:40px; padding-bottom:6px;padding-left:4px;padding-right:4px;\">".$quest->labels[$nn]."</td>\n";				
			}
			else if( isset( $quest->labels[$nn] ) ){
				print "<td class=\"cc_headlabel\" style=\"padding-bottom:6px;padding-left:4px;padding-right:4px;\">".$quest->labels[$nn]."</td>\n";
			}
			else print "<td></td>\n";
		}
		print "</tr>\n";

		if( $containsOR ){
			print "<tr>\n";
			for( $nn = 0; $nn < $colnum; $nn++ ){
				if( $quest->columns[$nn]["type"] != "label" && $columnNodes[$nn]->type=="OR" ){
					foreach( $columnNodes[$nn]->values as $n ){
						if( $columnNodes[$nn]->missing[$n] == "true" ) continue;
						print "<td class=\"orhead\" style=\"width:40px;\" ><center>".$columnNodes[$nn]->labels[$n]."</center></td>";
					}
				}
				else if( isset( $quest->labels[$nn] ) ){
					print "<td></td>\n";
				}
				else print "<td></td>\n";
			}
			print "</tr>\n";
			print "<tr>\n";
			for( $nn = 0; $nn < $colnum; $nn++ ){
				if( $quest->columns[$nn]["type"] != "label" && $columnNodes[$nn]->type=="OR" ){
					foreach( $columnNodes[$nn]->values as $n ){
						if( $columnNodes[$nn]->missing[$n] == "true" ) continue;
						print "<td class=\"item".$quest->level."\" style=\"width:40px;\"><center>".$n."</center></td>";
					}
				}
				else if( isset( $quest->labels[$nn] ) ){
					print "<td></td>\n";
				}
				else print "<td></td>\n";
			}
			print "</tr>\n";
		}

		$firstNode = $columnNodes[0];
		//Body
		$cv = false;
		if( $firstNode->type == "CV"){
			if( $firstNode->layoutType=="pulldown" ) $cv = false;
			else $cv = true;
		}
		if( $cv ){
			$row = 0;
			foreach( $firstNode->values as $n ){
				if( $firstNode->missing[$n] == "true" ) continue;
				$even = ($row % 2 != 0);
				print "<tr>\n";
				for( $nn = 0; $nn < $colnum; $nn++ ){
					if( $quest->columns[$nn]["type"] == "label" ){
						if( $even ) print "<td class=\"evenitem".$quest->level."\">";
						else print "<td style=\"width:80%;\" class=\"odditem".$quest->level."\">";
						print $labelsNode->labels[$n];
						$otherNode = null;
						if( isset( $labelsNode->otherref[$n] ) ){
							if( $labelsNode->otherref[$n] != "__none" ){
								FormItem::search( $labelsNode, $labelsNode->otherref[$n], $otherNode );
							}
						}
						if( $otherNode != null){
							if( $otherNode->type == "TE" || $otherNode->type == "ME" ){
								$vars = array_keys( $otherNode->variables );
								$otvar = $vars[0];
								$prefilled = "";
								$type = $otherNode->type;
								if( isset( $otherNode->prefilled ) ) $prefilled = $otherNode->prefilled;
								$length = 40;
								if( isset( $otherNode->length ) ) $length = $otherNode->length;
								print " <qtafi:$type size=\"$length\" variable=\"$otvar\" prefilled=\"".$prefilled."\" />\n";
							}
						}
						print "</td>\n";
					}
					else $this->formatCell( $quest, $columnNodes[$nn], $row );
				}
				$row++;
				print "</tr>\n";
			}
		}
		else if( $firstNode ){
			$row = 0;
			foreach( $firstNode->variables as $vn => $vv ){
				print "<tr>\n";
				for( $nn = 0; $nn < $colnum; $nn++ ){
					$even = ($row % 2 != 0);
					if( $quest->columns[$nn]["type"] == "label" ){
						if( $even ) print "<td class=\"evenitem".$quest->level."\">";
						else print "<td class=\"odditem".$quest->level."\">";
						print $labelsNode->varlabels[$vn];
						$otherNode = null;
						if( isset( $labelsNode->otherref[$vn] ) ){
							if( $labelsNode->otherref[$vn] != "__none" ){
								FormItem::search( $labelsNode, $labelsNode->otherref[$vn], $otherNode );
							}
						}
						if( $otherNode != null){
							if( $otherNode->type == "TE" || $otherNode->type == "ME" ){
								$vars = array_keys( $otherNode->variables );
								$otvar = $vars[0];
								$prefilled = "";
								$type = $otherNode->type;
								if( isset( $otherNode->prefilled ) ) $prefilled = $otherNode->prefilled;
								$length = 40;
								if( isset( $otherNode->length ) ) $length = $otherNode->length;
								print " <qtafi:$type size=\"$length\" variable=\"$otvar\" prefilled=\"".$prefilled."\" />\n";
							}
						}

						print "</td>\n";
					}
					else  $this->formatCell( $quest, $columnNodes[$nn], $row );
				}
				$row++;
				print "</tr>\n";
			}
		}

		if( $quest->childCount > 0 ){
			print "<tr>\n";
			print "<td colspan=\"".($colcounter)."\">\n";
			print "<table width=\"100%\" cellspacing=\"0\" cellpadding=\"0\">\n";
			print "<tr><td class=\"item".($quest->level +1)."\" valign=\"top\">\n";
		}
		print "<!-- end CCFormatter -->\n";
	}

	function formatCell( &$quest, &$node, $row ){
		$vars = array_keys( $node->variables );
		$even = ($row % 2 != 0);
		if( $node->type == "CV" ){
			if( $node->layoutType == "pulldown" ){
				if( $even ) print "<td class=\"evenitem".$quest->level."\">";
				else print "<td class=\"odditem".$quest->level."\">";
				print "<qtafi:CV variable=\"".$vars[0]."\" type=\"pulldown\" >\n";
				foreach( $node->values as $n ){
					if( $node->missing[$n] == "true" ) continue;
					print "<option value=\"$n\" label=\"".$node->labels[$n]."\" />\n";
				}
				print "</qtafi:CV></td>\n";
			}
			else {
				if( $even ) print "<td  style=\"width:40px;max-width:40px;\" class=\"evenitem".$quest->level."\">";
				else print "<td style=\"width:40px;max-width:40px;\" class=\"odditem".$quest->level."\">";
				print "<qtafi:CV variable=\"".$vars[0]."\" value=\"".$node->values[$row]."\"/></td>";
			}
		}
		else if( $node->type == "OR"){
			if( isset( $vars[$row] ) ){
				foreach( $node->values as $n ){
					if( $node->missing[$n] == "true" ) continue;
					if( $even ) print "<td width=\"".$node->columnWidth."\" class=\"evenitem".$quest->level."\">";
					else print "<td width=\"".$node->columnWidth."\" class=\"odditem".$quest->level."\">";
					print "<center><qtafi:OR variable=\"".$vars[$row]."\" value=\"$n\"/></center></td>";
				}
			}
			else print "<td>ORX $row</td>";
		}
		else if( $node->type == "ME" ){
			if( isset( $vars[$row] ) ){
				if( $even ) print "<td class=\"evenitem".$quest->level."\">";
				else print "<td class=\"odditem".$quest->level."\">";
				print "<qtafi:". $node->type." variable=\"".$vars[$row]."\" size=\"".$node->length."\"/></td>";
			}
			else print "<td></td>";
		}
		else if( $node->type == "TE" ){
			if( isset( $vars[$row] ) ){
				if( $even ) print "<td class=\"evenitem".$quest->level."\">";
				else print "<td class=\"odditem".$quest->level."\">";
				print "<qtafi:". $node->type." variable=\"".$vars[$row]."\" size=\"".$node->length."\" prefilled=\"".$node->prefilled."\" /></td>";
			}
			else print "<td></td>";
		}
		else if( $node->type == "MD" ){
			if( isset( $vars[$row] ) ){
				if( $even ) print "<td class=\"evenitem".$quest->level."\">";
				else print "<td class=\"odditem".$quest->level."\">";
				print "<qtafi:". $node->type." variable=\"".$vars[$row]."\" /></td>";
			}
			else print "<td></td>";
		}
		else print "<td>X</td>";
	}


	function behind( &$quest ){
		print "<!-- start CCFormatter -->\n";
		if( $quest->childCount > 0 ){
			print "</td></tr></table> \n";
			print "        </td>\n";
			print "    </tr>\n";
		}
		print "</table>\n";
		print "<!-- end CCFormatter -->\n";
	}
}