<?
/************************************************************************
*
*  online.QTAFI - online survey
*
*  Copyright (C) 2008  Martin Guist guist@incher.uni-kassel.de
*
*  This program is free software: you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation, either version 3 of the License, or
*  (at your option) any later version.
*
*  This program is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
*  GNU General Public License for more details.
*
*  You should have received a copy of the GNU General Public License
*  along with this program. If not, see <http://www.gnu.org/licenses/>.
*
*************************************************************************/

/**
* Formats the CV-Questiontype
*
* Layout types:
* - vertikal
* - pulldown
* - horizontal
* - hierarchic
* - popup
*/
class CVFormatter extends StandardFormatter {

	public $oot = false;
	public $layouttype = "radiobutton";

	function before( &$quest ){
		$cols = 1;
		if( $quest->layout == "horizontal" ) $cols = $quest->childCount;
		$this->validator( $quest );
		print "<!-- start CVFormatter -->\n";
		$this->dynamicFilter( $quest );
		print "<table id=\"TA_{$quest->nr}\" width=\"100%\" class=\"item".$quest->level."\" cellpadding=\"0\" cellspacing=\"0\" >\n";
		print "	<tr>\n";
		print "		<td colspan=\"2\" >\n";
		$this->head( $quest );
		print "		</td>\n";
		print "	</tr>\n";

		if( isset( $quest->appearance["layouttype"] ) ){
			$this->layouttype = $quest->appearance["layouttype"];
		}
		else $this->layouttype = $quest->layoutType;

		if( isset( $quest->appearance["orientation"] ) ){
			if( $quest->appearance["orientation"] == "right" ){
				$this->beforeRight( $quest );
				return;
			}
		}
		$this->beforeLeft( $quest );
	}

	function beforeLeft(&$quest){
		if( $this->layouttype == "hierarchic" ){
			foreach( $quest->variables as $vn => $vv ){
				print "<tr>\n";
				print "<td class=\"item".$quest->level."\" colspan=\"2\">\n";
				print $quest->varlabels[$vn];
				print "</td>\n";
				print "</tr>\n";
				print "<tr>\n";
				print "<td class=\"item".$quest->level."\" colspan=\"2\">\n";
				print "<table cellspacing=\"5\" cellpadding=\"0\" border=\"0\" >";
				print "<tr>";

				print "<td>\n";
				print "<qtafi:HIDDEN variable=\"$vn\"></qtafi:HIDDEN>\n";
				print "<script type=\"text/javascript\">\n";
				print "<![CDATA[ \n";
				$categories = array(); // categories[ "KAT" ] = value
				$hierarchy = array(); //hierarchy[ "KAT" ] = set val;

				//Kategorien sammeln
				foreach( $quest->valueprops as $value ){
					if( $quest->missing[$value["value"]] == "true" ) continue;
					$cat = $value["catkey"];
					$selcat = $value["subcatkey"]; //->andere Kategorie -> level + 1

					if( ! array_key_exists( $cat, $categories ) ) $categories[$cat] = array();
					$categories[$cat][] = $value["value"];

					$hierarchy[$selcat] = $value["value"];
				}

				print "cv_hierachy[\"$vn\"] = new Object();\n";
				foreach( $quest->valueprops as $value ){
					$val = $value["value"];
					if( $value["catkey"] == "__none" ) print "cv_hierachy[\"$vn\"][\"$val\"] = \"__none\";\n";
					else{
						if( isset( $hierarchy[$value["catkey"]] ) ){
							print "cv_hierachy[\"$vn\"][\"$val\"] = \"".$hierarchy[$value["catkey"]]."\";\n";
						}
						else print "cv_hierachy[\"$vn\"][\"$val\"] = \"__none\";\n";
					}
				}
				print "\n";

				//Alle Kategorien schreiben
				print "cv_values[\"$vn\"] = new Object();\n";
				foreach( $quest->valueprops as $value ){
					if( $value["subcatkey"] != "__none" ){
						$destcat = $value["subcatkey"];
						$val = $value["value"];
						print "cv_values[\"".$vn."\"][\"".$value["value"]."\"]=\"<select class='cv_hierarchic' name=%%%__".$vn."_".$val."%%% onChange=%%%selectCategory('$vn',this.name);valueChanged('{$vn}');%%% size=%%%".$quest->size."%%%>";
						foreach( $categories[$destcat] as $valv ){
							print "<option value='".$valv."'>".$quest->labels[$valv]."</option>";
						}
						print "</select>\";\n";
					}
				}
				print "]]>\n";
				print "</script>";

				print "<select class=\"cv_hierarchic\" name=\"__".$vn."___none\" type=\"pulldown\" size=\"".$quest->size."\" onChange=\"selectCategory('$vn',this.name );valueChanged('{$vn}');\">\n";
				if( isset( $quest->labels["-9"] ) ){
					print "<option value=\"-9\">".$quest->labels["-9"]."</option>\n";
				}
				else print "<option value=\"-9\">Select...</option>\n";
				foreach( $quest->values as $n ){
					if( $quest->missing[$n] == "true" ) continue;
					$cat = $quest->valueprops[$n]["catkey"];
					if( $cat == "__none" ){
						print "<option value=\"$n\">".$quest->labels[$n]."</option>\n";
					}
				}
				print "</select>\n";
				print "</td>\n";

				//Category 1
				$c = 1;
				for( $c = 1; $c < 4; $c++ ){
					print "<td id=\"".$vn."_L".$c."\"> ";
					print "</td>";
				}

				print "</tr>\n";
				print "</table>";
				print "<script type=\"text/javascript\">\n";
				print " 	initCategory( \"$vn\");\n";
				print "</script>";

				print "</td>\n";
				print "</tr>\n";
			}
			if( $quest->childCount > 0 ){
				print "<tr>\n";
				print "<td colspan=\"2\">\n";
				print "<table width=\"100%\" cellspacing=\"0\" cellpadding=\"0\">\n";
				print "<tr><td class=\"item".($quest->level +1)."\" valign=\"top\">\n";
			}
			print "<!-- end CVFormatter -->\n";
			return;
		}

		if($this->layouttype == "popup"){
			foreach( $quest->variables as $vn => $vv ){
				print "<tr>\n";
				print "<td class=\"item".$quest->level."\" colspan=\"2\">";
				print "<a class=\"cv_popup\" style=\"font-size:14pt;\" id=\"".($quest->nr)."_show\"  onclick=\"popup_CV(event,'".($quest->nr)."');\"  href=\"javascript:;\">Select...</a>\n";
				print "</td>\n";
				print "</tr>";
			}
			if( $quest->childCount > 0 ){
				print "<tr>\n";
				print "<td colspan=\"2\">\n";
				print "<table width=\"100%\" cellspacing=\"0\" cellpadding=\"0\">\n";
				print "<tr><td class=\"item".($quest->level +1)."\" valign=\"top\">\n";
			}
			print "<!-- end CVFormatter -->\n";
			return;
		}

		if( $this->layouttype == "pulldown" ){
			foreach( $quest->variables as $vn => $vv ){
				print "<tr>\n";
				print "<td class=\"item".$quest->level."\" colspan=\"2\">\n";

				print "<table cellspacing=\"0\" cellpadding=\"0\" style=\"margin-top:6px;margin-bottom:5px;\"><tr><td class=\"item".$quest->level."\">\n";
				print $quest->before[$vn]." ";
				print "<qtafi:CV variable=\"$vn\" type=\"pulldown\" size=\"".$quest->size."\">\n";
				if( isset( $quest->labels["-9"] ) ){
					print "<option value=\"".MISSING."\" label=\"".$quest->labels["-9"]."\" />\n";
				}
				else print "<option value=\"".MISSING."\" label=\"Select...\" />\n";
				$catk = "__none";
				$cat = "__none";

				foreach( $quest->values as $n ){
					if( $quest->missing[$n] == "true" ) continue;
					$currentcatk = $quest->valueprops[$n]["catkey"];
					$currentcat = $quest->valueprops[$n]["category"];
					if( $currentcatk != $catk ){
						if( $catk != "__none" ) print "</group>\n";
						if( $currentcatk != "__none" ) print "<group label=\"$currentcat\">\n";
					}
					print "<option value=\"$n\" label=\"".$quest->labels[$n]."\" />\n";
					$catk = $currentcatk;
				}
				if( $catk != "__none" ) print "</group>\n";

				print "</qtafi:CV>\n";
				print " ".$quest->behind[$vn];
				print "</td></tr></table>\n";
				print "</td>\n";
				print "</tr>\n";
			}

			if( $quest->childCount > 0 ){
				print "<tr>\n";
				print "<td colspan=\"2\">\n";
				print "<table width=\"100%\" cellspacing=\"0\" cellpadding=\"0\">\n";
				print "<tr><td class=\"item".($quest->level +1)."\" valign=\"top\">\n";
			}
			print "<!-- end CVFormatter -->\n";
			return;
		}

		if( $this->layouttype == "horizontal" ){
			print "<tr>\n";
			print "<td class=\"item".$quest->level."\" colspan=\"2\">\n";
			print "<table cellspacing=\"0\" cellpadding=\"0\" width=\"100%\"><tr><td class=\"item".$quest->level."\">\n";
			foreach( $quest->variables as $vn => $vv ){
				print "<tr>\n";
				foreach( $quest->values as $n ){
					if( $quest->missing[$n] == "true" ) continue;
					print "<td align=\"center\" class=\"item".$quest->level."\">".$quest->labels[$n]."</td>\n";
				}
				print "</tr>\n";
				print "<tr>\n";

				foreach( $quest->values as $n ){
					if( $quest->missing[$n] == "true" ) continue;
					print "<td align=\"center\" class=\"item".$quest->level."\">\n";
					print "<qtafi:CV variable=\"$vn\" value=\"$n\" />\n";
					print "</td>\n";
				}
				print "</tr>\n";
			}
			print "</td></tr></table>\n";
			print "</td>\n";
			print "</tr>\n";

			if( $quest->childCount > 0 ){
				print "<tr>\n";
				print "<td colspan=\"2\">\n";
				print "<table width=\"100%\" cellspacing=\"0\" cellpadding=\"0\">\n";
				print "<tr><td class=\"item".($quest->level +1)."\" valign=\"top\">\n";
			}
			print "<!-- end CVFormatter -->\n";
			return;
		}

		//radiobuttons vertical
		foreach( $quest->variables as $vn => $vv ){
			$nn = 0;
			$oldcatk = "";
			foreach( $quest->values as $n ){
				if( $quest->missing[$n] == "true" ) continue;
				$even = ($nn % 2 != 0);

				//Kategorien experimentell
				$catk = $quest->valueprops[$n]["catkey"];
				$cat = $quest->valueprops[$n]["category"];
				if( $catk != "__none" && $oldcatk != $catk ){
					print "<tr>";
					if( $even ){
						print "<td class=\"evenitem".$quest->level."\" colspan=\"2\"><b>".$cat."</b></td>";
					}
					else print "<td class=\"odditem".$quest->level."\" colspan=\"2\"><b>".$cat."</b></td>";
					print "</tr>";
				}
				$oldcatk = $catk;

				$otherNode = null;
				if( $quest->otherref[$n] != "__none" ){
					FormItem::search( $quest, $quest->otherref[$n], $otherNode );
				}

				if( $otherNode != null){
					print "<tr>\n";
					if( $even ){
						print "<td valign=\"top\" width=\"40\" class=\"evenitem".$quest->level."\">\n";
					}
					else{
						print "<td valign=\"top\" width=\"40\" class=\"odditem".$quest->level."\">\n";
					}

					print "<qtafi:CV variable=\"$vn\" value=\"$n\" />\n";
					print "</td>\n";

					if( $even ){
						print "<td valign=\"top\" width=\"95%\" class=\"evenitem".$quest->level."\">";
					}
					else{
						print "<td  valign=\"top\" width=\"95%\" class=\"odditem".$quest->level."\">";
					}

					$otvar = "";
					if( $otherNode->type == "TE" || $otherNode->type == "ME" ){
						$vars = array_keys( $otherNode->variables );
						$otvar = $vars[0];
						$prefilled = "";
						$type = $otherNode->type;
						if( isset( $otherNode->prefilled ) ) $prefilled = $otherNode->prefilled;
						$length = 40;
						if( isset( $otherNode->length ) ) $length = $otherNode->length;
						print $quest->labels[$n];
						$otherNode->formatter->validator( $otherNode );
						$otherNode->formatter->dynamicFilter( $otherNode );
						print $otherNode->before[$otvar];
						print " <qtafi:$type size=\"$length\" variable=\"$otvar\" prefilled=\"".$prefilled."\" />\n";
						print $otherNode->behind[$otvar];
						$otherNode->formatter->dynamicFilterInit( $otherNode );
					}
					else { //CV,MD,OR,TL
						$vars = array_keys( $otherNode->variables );
						$prefilled = "";
						$type = $otherNode->type;
						if( isset( $otherNode->prefilled ) ) $prefilled = $otherNode->prefilled;
						$length = 40;
						if( isset( $otherNode->length ) ) $length = $otherNode->length;
						$otherNode->invisible = false;
						print $quest->labels[$n];
						print "<table id=\"".$otherNode->id."\" cellspacing=\"0\" cellpadding=\"0\" border=\"0\" width=\"100%\">";
						print "<tr><td>";
						$otherNode->format();
						$otherNode->invisible = true;
						$numb = $otherNode->id;
						print "</td></tr></table>";
					}
				}
				else {
					print "<tr>\n";
					if( $even ){
						print "<td width=\"40\" class=\"evenitem".$quest->level."\">\n";
					}
					else{
						print "<td width=\"40\" class=\"odditem".$quest->level."\">\n";
					}

					print "<qtafi:CV variable=\"$vn\" value=\"$n\" />\n";
					print "</td>\n";

					if( $even ){
						print "<td width=\"95%\" class=\"evenitem".$quest->level."\">".$quest->labels[$n];
					}
					else{
						print "<td width=\"95%\" class=\"odditem".$quest->level."\">".$quest->labels[$n];
					}

				}
				print "</td>\n";
				print "</tr>\n";
				$nn++;
			}
		}
		if( $quest->childCount > 0 ){
			print "<tr>\n";
			print "<td colspan=\"2\">\n";
			print "<table width=\"100%\" cellspacing=\"0\" cellpadding=\"0\">\n";
			print "<tr><td class=\"item".($quest->level +1)."\" valign=\"top\">\n";
		}
		print "<!-- end CVFormatter -->\n";
	}


	function selectionArea(&$quest,$vn){
		//print "<div id=\"".($quest->nr)."_popup\" width=\"100%\" style=\"position:absolute; top:0px; left:20px; bottom:0px; height:100%; visibility:hidden; display:none; opacity:0.9; filter:alpha(opacity=90);\">\n";
		print "<div id=\"".($quest->nr)."_popup\" width=\"100%\" style=\"position:absolute; top:0px; left:20px; width:100%; height:2000px; wvisibility:hidden; display:none; opacity:0.9; filter:alpha(opacity=90);\">\n";
		//print "<table style=\"width:100%; height:100%; overflow:auto; background-color:#ffffff;\"><tr><td>";
		print "<table style=\"width:100%; height:2000px; overflow:auto; background-color:#ffffff;\"><tr><td align=\"center\" valign=\"top\">";
		print "<table width=\"90%\" align=\"center\" style=\"text-align:center; margin-top:2cm; background-color:#ffffff;\" cellspacing=\"0\" cellpadding=\"1\">\n";
		
		$columns = 4;
		$c = count($quest->values);
		$per_col = $c / $columns; 
		$oldcatk = "";
		
		print "<tr>";
		
		$i_counter = 0;
		
		for($col = 0; $col < $columns; $col++){
			if($col < $columns-1) print "<td style=\"border-right:solid 1px; text-align:left;\" valign=\"top\"><table>";
			else print "<td style=\"text-align:left;\" valign=\"top\"><table>";
			for($i = 0; $i < $per_col ; $i++){
				$in = $i + ($col * $per_col);
				if($i_counter < $c){
					$n = $quest->values[$i_counter];
					//Kategorien
					$catk = $quest->valueprops[$n]["catkey"];
					$cat = $quest->valueprops[$n]["category"];
					if( $catk != "__none" && $oldcatk != $catk ){
						print "<tr>";
						print "<td colspan=\"2\"><b style=\"font-family:Arial;\">".$cat."</b></td>";
						print "</tr>";
					}
					$oldcatk = $catk;
					print "<tr>";
					print "<td><qtafi:CV variable=\"$vn\" value=\"$n\" onClick=\"popdown_CV('".$vn."','".($quest->nr)."');\" /></td>\n";
					print "<td><span style=\"font-family:Arial;font-size:8pt;\" id=\"".$vn."_".$n."\">". $quest->labels[$n]."</span></td>\n";
					print "</tr>";
					$i_counter++;
				}
			}
			print "</table></td>";
			
		}
		print "</tr>";
		print "</table></td></tr></table>\n";
		print "</div>\n";
		print "<script type=\"text/javascript\">\n";
		print "	var sel = getVariable('".$vn."');\n";
		//print "	document.getElementById('".($quest->nr)."_show').firstChild.data = document.getElementById('".$vn."_'+sel).firstChild.data;\n";
		print "	document.getElementById('".($quest->nr)."_show').innerHTML = document.getElementById('".$vn."_'+sel).innerHTML;\n";
		print "</script>\n";
	}


	function beforeRight( &$quest ){
		print "<!-- not yet implemented CVFormatter -->\n";
	}

	function behind( &$quest ){
		print "<!-- start CVFormatter -->\n";
		if( $quest->childCount > 0 ){
			print "</td></tr></table>\n";
			print "        </td>\n";
			print "    </tr>\n";
		}
		print "</table>\n";
		if($this->layouttype == "popup"){
			foreach( $quest->variables as $vn => $vv ){
				$this->selectionArea($quest,$vn);
			}
		}
		
		$this->dynamicFilterInit( $quest );
		print "<!-- end CVFormatter -->\n";
    }
}
?>