<?
/************************************************************************
*
*  online.QTAFI - online survey
*
*  Copyright (C) 2008  Martin Guist guist@incher.uni-kassel.de
*
*  This program is free software: you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation, either version 3 of the License, or
*  (at your option) any later version.
*
*  This program is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
*  GNU General Public License for more details.
*
*  You should have received a copy of the GNU General Public License
*  along with this program. If not, see <http://www.gnu.org/licenses/>.
*
*************************************************************************/

/**
* Formats MD-Questiontype
*
*/
class MDFormatter extends StandardFormatter {

	public $layouttype = "checkbox";
	
	function before( &$quest ){
		$cols = 1;
		if( $quest->layout == "horizontal" ) $cols = $quest->childCount;
		$this->validator( $quest );
		print "<!-- start MDFormatter -->\n";
		$this->dynamicFilter( $quest );
		print "<table id=\"TA_{$quest->nr}\" width=\"100%\" class=\"item".$quest->level."\" cellpadding=\"0\" cellspacing=\"0\" >\n";
		print "    <tr>\n";
		print "          <td colspan=\"2\" >\n";
		$this->head( $quest );
		print "          </td>\n";
		print "     </tr>\n";

		if( isset( $quest->appearance["layouttype"] ) ){
			$this->layouttype = $quest->appearance["layouttype"];
		}
		//else $this->layouttype = $quest->layoutType;

		if( isset( $quest->appearance["orientation"] ) ){
			if( $quest->appearance["orientation"] == "right" ){
				$this->beforeRight( $quest );
				return;
			}
		}
		$this->beforeLeft( $quest );
	}

	function beforeLeft( &$quest ){
		$oldcatk = "";
		$nn = 0;
		foreach( $quest->variables as $vn => $vv ){
			$n = $quest->values[0];//first answer is checked value
			if( $quest->missing[$n] == "true" ) continue;
			$even = ($nn % 2 != 0);

			$cat = $quest->category[$vn]["category"];
			$catk = $quest->category[$vn]["catkey"];
			if( $catk != "__none" && $oldcatk != $catk ){
				print "<tr>";
				if( $even ){
					print "<td class=\"evenitem".$quest->level."\" colspan=\"2\"><b>".$cat."</b></td>";
				}
				else print "<td class=\"odditem".$quest->level."\" colspan=\"2\"><b>".$cat."</b></td>";
				print "</tr>";
			}
			$oldcatk = $catk;

			$otherNode = null;
			if( $quest->otherref[$vn] != "__none" ){
				FormItem::search( $quest, $quest->otherref[$vn], $otherNode );
			}

			if( $otherNode != null ){
				$otvar = "";
				print "<tr>\n";
				if( $even ){
					print "<td valign=\"top\" width=\"40\" class=\"evenitem".$quest->level."\">\n";
				}
				else{
					print "<td valign=\"top\" width=\"40\" class=\"odditem".$quest->level."\">\n";
				}
				print "<qtafi:MD variable=\"$vn\" value=\"$n\" />\n";
				print "</td>\n";

				if( $even ) {
					print "<td valign=\"top\" width=\"95%\" class=\"evenitem".$quest->level."\">";
				}
				else{
					print "<td valign=\"top\" width=\"95%\" class=\"odditem".$quest->level."\">";
				}

				if( $otherNode->type == "TE" || $otherNode->type == "ME" ){//TE, ME
					$vars = array_keys( $otherNode->variables );
					$otvar = $vars[0];
					$prefilled = "";
					$type = $otherNode->type;
					if( isset( $otherNode->prefilled ) ) $prefilled = $otherNode->prefilled;
					$length = 40;
					if( isset( $otherNode->length ) ) $length = $otherNode->length;
					print $quest->varlabels[$vn]."\n";
					$otherNode->formatter->validator( $otherNode );
					$otherNode->formatter->dynamicFilter( $otherNode );
					print $otherNode->before[$otvar];
					print "  <qtafi:".$type." size=\"".$length."\" variable=\"$otvar\" prefilled=\"".$prefilled."\" />\n";
					print $otherNode->behind[$otvar];
					$otherNode->formatter->dynamicFilterInit( $otherNode );
					
				}
				else {
					$vars = array_keys( $otherNode->variables );
					$prefilled = "";
					$type = $otherNode->type;
					if( isset( $otherNode->prefilled ) ) $prefilled = $otherNode->prefilled;
					$length = 40;
					if( isset( $otherNode->length ) ) $length = $otherNode->length;
					$otherNode->invisible = false;
					print $quest->varlabels[$vn]."\n";
					print "<table id=\"".$otherNode->id."\" cellspacing=\"0\" cellpadding=\"0\" border=\"0\" width=\"100%\">";
					print "<tr>";
					print "<td valign=\"top\">";
					$otherNode->format();
					$otherNode->invisible = true;
					$numb = $otherNode->id;
					print "</td></tr></table>";
				}
				print "</td>\n";
			}
			else {
				print "<tr>\n";
				if( $even )
					print "<td width=\"40\" class=\"evenitem".$quest->level."\">\n";
				else
					print "<td width=\"40\" class=\"odditem".$quest->level."\">\n";
				print "<qtafi:MD variable=\"$vn\" value=\"$n\" />\n";
				print "</td>\n";

				if( $even ) print "<td width=\"95%\" class=\"evenitem".$quest->level."\">";
				else print "<td width=\"95%\" class=\"odditem".$quest->level."\">";
				print $quest->varlabels[$vn]."\n";
				print "</td>\n";
			}

			print "</tr>\n";
			$nn++;
		}

		if( $quest->childCount > 0 ){
			print "<tr>\n";
			print "<td colspan=\"2\">\n";
			print "<table width=\"100%\" cellspacing=\"0\" cellpadding=\"0\">\n";
			print "<tr><td class=\"item".($quest->level +1)."\" valign=\"top\">\n";
		}
		print "<!-- end MDFormatter -->\n";
	}

	function beforeRight( &$quest ){
		$oldcat = "";
		$nn = 0;
		foreach( $quest->variables as $vn => $vv ){
			$n = $quest->values[0];//first answer is checked value
			if( $quest->missing[$n] == "true" ) continue;
			$even = ($nn % 2 != 0);
			$cat = $quest->category[$vn];
			if( $cat != "__none" && $oldcat != $cat ){
				print "<tr>";
				if( $even ){
					print "<td class=\"evenitem".$quest->level."\" colspan=\"2\"><b>".$cat."</b></td>";
				}
				else print "<td class=\"odditem".$quest->level."\" colspan=\"2\"><b>".$cat."</b></td>";
				print "</tr>";
			}
			$oldcat = $cat;

			$otherNode = null;
			if( $quest->otherref[$vn] != "__none" ){
				FormItem::search( $quest, $quest->otherref[$vn], $otherNode );
			}

			if( $otherNode != null ){
				$otvar = "";
				print "<tr>\n";

				if( $even ) {
					print "<td valign=\"top\" width=\"95%\" class=\"evenitem".$quest->level."\">";
				}
				else{
					print "<td valign=\"top\" width=\"95%\" class=\"odditem".$quest->level."\">";
				}
				if( $otherNode->type == "TE" || $otherNode->type == "ME" ){//TE, ME
					$vars = array_keys( $otherNode->variables );
					$otvar = $vars[0];
					$prefilled = "";
					$type = $otherNode->type;
					if( isset( $otherNode->prefilled ) ) $prefilled = $otherNode->prefilled;
					$length = 40;
					if( isset( $otherNode->length ) ) $length = $otherNode->length;
					print $quest->varlabels[$vn]."\n";
					print "  <qtafi:".$type." size=\"".$length."\" disabled=\"true\" variable=\"$otvar\" prefilled=\"".$prefilled."\" />\n";
					print "<script type=\"text/javascript\">\n";
					//print "/* <![CDATA[ */\n";
					print "init_OTHER('$otvar','$vn','$n',1);\n";
					//print "/* ]]> */\n";
					print "</script>\n";
				}
				else {
					$vars = array_keys( $otherNode->variables );
					$prefilled = "";
					$type = $otherNode->type;
					if( isset( $otherNode->prefilled ) ) $prefilled = $otherNode->prefilled;
					$length = 40;
					if( isset( $otherNode->length ) ) $length = $otherNode->length;
					$otherNode->invisible = false;
					print "<table cellspacing=\"0\" cellpadding=\"0\" border=\"0\" width=\"100%\"><tr>";
					print "<td valign=\"top\">";
					print $quest->varlabels[$vn]."\n";
					print "</td>";
					print "<td valign=\"top\" width=\"60%\">";
					print "<div id=\"".$otherNode->id."__\">[...]</div>";
					print "</td></tr>";
					print "<tr><td colspan=\"2\" >";
					print "<div id=\"".$otherNode->id."\" style=\"display:none;\" >";
					$otherNode->format();
					print "</div>";
					$otherNode->invisible = true;
					$numb = $otherNode->id;
					print "</td></tr></table>";

					print "<script type=\"text/javascript\">\n";
					//print "/* <![CDATA[\n */";
					print "init_OTHER('$numb','$vn','$n', 1);\n";
					//print "/* ]]> */\n";
					print "</script>\n";
				}
				print "</td>\n";

				if( $even ){
					print "<td valign=\"top\" width=\"40\" class=\"evenitem".$quest->level."\">\n";
				}
				else{
					print "<td valign=\"top\" width=\"40\" class=\"odditem".$quest->level."\">\n";
				}
				print "<qtafi:MD variable=\"$vn\" value=\"$n\" />\n";
				print "</td>\n";
			}
			else {
				print "<tr>\n";
				if( $even ) print "<td width=\"95%\" class=\"evenitem".$quest->level."\">";
				else print "<td width=\"95%\" class=\"odditem".$quest->level."\">";
				print $quest->varlabels[$vn]."\n";
				print "</td>\n";

				if( $even )
					print "<td width=\"40\" class=\"evenitem".$quest->level."\">\n";
				else
					print "<td width=\"40\" class=\"odditem".$quest->level."\">\n";
				print "<qtafi:MD variable=\"$vn\" value=\"$n\" />\n";
				print "</td>\n";
			}

			print "</tr>\n";
			$nn++;
		}

		if( $quest->childCount > 0 ){
			print "<tr>\n";
			print "<td colspan=\"2\">\n";
			print "<table width=\"100%\" height=\"100%\" cellspacing=\"0\" cellpadding=\"0\">\n";
			print "<tr><td class=\"item".($quest->level +1)."\" valign=\"top\">\n";
		}
		print "<!-- end MDFormatter -->\n";
	}

	function behind( &$quest ){
		print "<!-- start MDFormatter -->\n";
		if( $quest->childCount > 0 ){
			print "</td></tr></table> \n";
			print "        </td>\n";
			print "    </tr>\n";
		}
		print "</table>\n";
		$this->dynamicFilterInit( $quest );
		print "<!-- end MDFormatter -->\n";
	}
}
?>