<?
/************************************************************************
*
*  online.QTAFI - online survey
*
*  Copyright (C) 2008  Martin Guist guist@incher.uni-kassel.de
*
*  This program is free software: you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation, either version 3 of the License, or
*  (at your option) any later version.
*
*  This program is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
*  GNU General Public License for more details.
*
*  You should have received a copy of the GNU General Public License
*  along with this program. If not, see <http://www.gnu.org/licenses/>.
*
*************************************************************************/

/**
* Formats ME-Questions
*
*/
class MEFormatter extends StandardFormatter {

	public $mecols = 1;
	public $inputfieldsize = 4;

    function before( &$quest ){
		if( isset( $quest->appearance["size"] ) ){// evtl. in variable
			$this->inputfieldsize = $quest->appearance["size"];
		}
		else $this->inputfieldsize = $quest->length; //deprecated

		foreach( $quest->variables as $n => $v ){
    		if( strlen( $quest->before[$n] ) > 1 ){
    			$this->mecols = 2;
    			break;
    		}
    	}

        $cols = 1;
	    if( $quest->layout == "horizontal" ) $cols = $quest->childCount;
		$this->validator( $quest );
		print "<!-- start MEFormatter -->\n";
		$this->dynamicFilter( $quest );
		print "<table id=\"TA_{$quest->nr}\" width=\"100%\" class=\"item".$quest->level."\" cellpadding=\"0\" cellspacing=\"0\" >\n";
		print "	<tr>\n";
		print "		<td colspan=\"".$this->mecols."\">\n";
		$this->head( $quest );
		print "		</td>\n";
		print "	</tr>\n";

    	foreach( $quest->variables as $vn => $vv ){
			$otherNode = null;
			if( $quest->otherref[$vn] != "__none" ){
				FormItem::search( $quest, $quest->otherref[$vn], $otherNode );
			}

			print "<tr>\n";
			if( $this->mecols == 2 ){
				print "<td width=\"".(strlen($quest->before[$vn])*4)."\" class=\"item".$quest->level."\">".$quest->before[$vn]."</td>\n";
				//print "<td width=\"80%\" class=\"item".$quest->level."\"><qtafi:ME variable=\"$vn\" size=\"".$this->inputfieldsize."\" />\n";
				print "<td class=\"item".$quest->level."\"><qtafi:ME variable=\"$vn\" size=\"".$this->inputfieldsize."\" />\n";
			}
			else print "<td class=\"item".$quest->level."\"><qtafi:ME variable=\"$vn\" size=\"".$this->inputfieldsize."\" />\n";
			print $quest->behind[$vn];

			if( $otherNode != null ){
				if( $otherNode->type == "TE" || $otherNode->type == "ME" ){//TE, ME
					$vars = array_keys( $otherNode->variables );
					$otvar = $vars[0];
					$prefilled = "";
					$type = $otherNode->type;
					if( isset( $otherNode->prefilled ) ) $prefilled = $otherNode->prefilled;
					$length = 40;
					if( isset( $otherNode->length ) ) $length = $otherNode->length;
					print "  <qtafi:".$type." size=\"".$length."\" variable=\"$otvar\" prefilled=\"".$prefilled."\" />\n";
				}
			}

			print "</td>\n";
			print "</tr>";
		}

		if( $quest->childCount > 0 ){
			print "<tr>\n";
			print "<td colspan=\"".$this->mecols."\">\n";
			print "<table width=\"100%\" cellspacing=\"0\" cellpadding=\"0\">\n";
			print "<tr><td valign=\"top\" class=\"item".($quest->level +1)."\">\n";
		}
		print "<!-- end MEFormatter -->\n";
    }

 	function behind( &$quest ){
		print "<!-- start MEFormatter -->\n";
		if( $quest->childCount > 0 ){
			print "</td></tr></table> \n";
			print "        </td>\n";
			print "    </tr>\n";
		}
		print "</table>\n";
		$this->dynamicFilterInit( $quest );
		print "<!-- end MEFormatter -->\n";
    }
}
?>