<?
/************************************************************************
*
*  online.QTAFI - online survey
*
*  Copyright (C) 2008  Martin Guist guist@incher.uni-kassel.de
*
*  This program is free software: you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation, either version 3 of the License, or
*  (at your option) any later version.
*
*  This program is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
*  GNU General Public License for more details.
*
*  You should have received a copy of the GNU General Public License
*  along with this program. If not, see <http://www.gnu.org/licenses/>.
*
*************************************************************************/

/**
* Formate OR-Questions
*
*/
class ORFormatter extends StandardFormatter {

	public $cols = 0;
	public $columnWidth = 40;

	function before( &$quest ){
		$this->cols = 0;
		foreach( $quest->variables as $vn => $vv ){
			$this->cols = 0;
			foreach( $quest->values as $n ) $this->cols++;
		}

		if( isset( $quest->appearance["columnwidth"] ) ){
			$this->columnWidth = $quest->appearance["columnwidth"];
		}
		else $this->columnWidth = $quest->columnWidth; //deprecated
		$this->validator( $quest );
		print "<!-- start ORFormatter -->\n";
		$this->dynamicFilter( $quest );
		print "<table id=\"TA_{$quest->nr}\" width=\"100%\" class=\"item".$quest->level."\" cellpadding=\"0\" cellspacing=\"0\" >\n";
		print "	<tr>\n";
		print "		<td colspan=\"".($this->cols+1)."\" >\n";
		$this->head( $quest );
		print "		</td>\n";
		print "	</tr>\n";

		if( isset( $quest->appearance["orientation"] ) ){
			if( $quest->appearance["orientation"] == "right" ){
				$this->beforeRight( $quest );
				return;
			}
		}
		$this->beforeLeft( $quest );
	}

	function beforeLeft( &$quest ){
		//Head
		$orlabs = array();
		$max = 0;
		foreach( $quest->values as $n ){
			if( $quest->missing[$n] == "true" ) continue;
			$orlabs[$max] = $quest->labels[$n];
			$max++;
		}

		$i = 0;
		$span = false;
		print "<tr>\n";
		foreach( $quest->values as $n ){
			if( $quest->missing[$n] == "true" ) continue;
			if(strlen($quest->labels[$n]) >0){
				print "<td class=\"orhead".$quest->level."\" width=\"".$this->columnWidth."\" >".$quest->labels[$n]." </td>\n";
			}
			else print "<td class=\"orhead".$quest->level."\" width=\"".$this->columnWidth."\"> </td>\n";
		}
		print "<td class=\"orhead\"> </td>\n";
		print "</tr>\n";

		//Numbers
		print "<tr>\n";
		foreach( $quest->values as $n ){
			if($quest->missing[$n] == "true") continue;
			if($quest->hidevalue[$n] == "true") print "<td class=\"item".$quest->level."\"> </td>";
			else{
				if(strlen($quest->visiblenumber[$n])>0){
					$num = $quest->visiblenumber[$n];
					print "<td class=\"item".$quest->level."\" width=\"".$this->columnWidth."\"><center>{$num}</center></td>\n";
				}
				else{
					print "<td class=\"item".$quest->level."\" width=\"".$this->columnWidth."\"><center>$n</center></td>\n";
				}
			}
		}
		print "<td class=\"item".$quest->level."\"> </td>\n";
		print "</tr>\n";

		//Body
		$oldcat = "";
		$nn = 0;
		foreach( $quest->variables as $vn => $vv ){
			$even = ($nn % 2 != 0);
			$cat = $quest->category[$vn];
			if( $cat != "__none" && $oldcat != $cat ){
				print "<tr>";
				if( $even ){
					print "<td class=\"evenitem".$quest->level."\" colspan=\"".($this->cols+1)."\"><b>".$cat."</b></td>";
				}
				else print "<td class=\"odditem".$quest->level."\" colspan=\"".($this->cols+1)."\"><b>".$cat."</b></td>";
				print "</tr>";
			}
			$oldcat = $cat;


			print "<tr>\n";
			$cols = 0;
			foreach( $quest->values as $n ){
				if( $quest->missing[$n] == "true" ) continue;
				if( $even ) print "<td class=\"evenitem".$quest->level."\" width=\"".$this->columnWidth."\">\n";
				else print "<td valign=\"top\" class=\"odditem".$quest->level."\" width=\"".$this->columnWidth."\">\n";
				print "<center><qtafi:OR variable=\"$vn\" value=\"$n\" /></center>\n";
				print "</td>\n";
				$cols++;
			}

			$otherNode = null;
			if( $quest->otherref[$vn] != "__none" ){
				FormItem::search( $quest, $quest->otherref[$vn], $otherNode );
			}

			if( $otherNode != null ){
				$otvar = "";
				if( $even ) {
					print "<td valign=\"top\" class=\"evenitem".$quest->level."\" >";
				}
				else{
					print "<td valign=\"top\" class=\"odditem".$quest->level."\" >";
				}

				if( $otherNode->type == "TE" || $otherNode->type == "ME" ){//TE, ME
					$vars = array_keys( $otherNode->variables );
					$otvar = $vars[0];
					$prefilled = "";
					$type = $otherNode->type;
					if(isset($otherNode->prefilled)) $prefilled = $otherNode->prefilled;
					$length = 40;
					if( isset( $otherNode->length ) ) $length = $otherNode->length;
					print $quest->varlabels[$vn];
					$otherNode->formatter->validator( $otherNode );
					$otherNode->formatter->dynamicFilter( $otherNode );
					print $otherNode->before[$otvar];
					print " <qtafi:".$type." size=\"".$length."\" variable=\"$otvar\" prefilled=\"".$prefilled."\" />\n";
					print $otherNode->behind[$otvar];
					$otherNode->formatter->dynamicFilterInit( $otherNode );
				}
				else {
					$vars = array_keys( $otherNode->variables );
					$otvar = $vars[0];
					$prefilled = "";
					$type = $otherNode->type;
					if( isset( $otherNode->prefilled ) ) $prefilled = $otherNode->prefilled;
					$length = 40;
					if( isset( $otherNode->length ) ) $length = $otherNode->length;
					$otherNode->invisible = false;
					print $quest->varlabels[$vn];
					print "<table id=\"".$otherNode->id."\" cellspacing=\"0\" cellpadding=\"0\" border=\"0\" width=\"100%\">";
					print "<tr>";
					print "<td valign=\"top\">";
					$otherNode->format();
					$otherNode->invisible = true;
					$numb = $otherNode->id;
					print "</td></tr></table>";
				}
			}
			else {
				if( $even ) {
					if( strlen( $quest->varlabels[$vn] ) > 0 ){
						print "<td class=\"evenitem".$quest->level."\" >".$quest->varlabels[$vn];
					}
					else print "<td class=\"evenitem".$quest->level."\" width=\"40%\"> ";
				}
				else{
					if( strlen( $quest->varlabels[$vn] ) > 0 ){
						print "<td class=\"odditem".$quest->level."\" >".$quest->varlabels[$vn];
					}
					else print "<td class=\"odditem".$quest->level."\" width=\"40%\"> ";
				}
			}
			print "</td>\n";
			print "</tr>\n";
			$nn++;
		}

		if( $quest->childCount > 0 ){
			print "<tr>\n";
			print "<td colspan=\"".($this->cols+1)."\" >\n";
			print "<table width=\"100%\" cellspacing=\"0\" cellpadding=\"0\">\n";
			print "<tr><td class=\"item".($quest->level +1)."\" valign=\"top\">\n";
		}
		print "<!-- end ORFormatter -->\n";
	}

	function beforeRight( &$quest ){
		//Head
		$orlabs = array();
		$max = 0;
		foreach( $quest->values as $n ){
			if( $quest->missing[$n] == "true" ) continue;
			$orlabs[$max] = $quest->labels[$n];
			$max++;
		}
		$i = 0;
		$span = false;
		print "<tr>\n";
		print "<td class=\"orhead\"> </td>\n";//labels
		foreach( $quest->values as $n ){
			if( $quest->missing[$n] == "true" ) continue;
			print "<td class=\"orhead\" width=\"".$this->columnWidth."\" ><center>".$quest->labels[$n]."</center></td>\n";
		}
		print "</tr>\n";

		//Numbers
		print "<tr>\n";
		print "<td class=\"item".$quest->level."\"> </td>\n";
		foreach( $quest->values as $n ){
			if( $quest->missing[$n] == "true" ) continue;
			if( $quest->hidevalue[$n] == "true" ) print "<td class=\"item".$quest->level."\"> </td>";
			else print "<td class=\"item".$quest->level."\" width=\"".$this->columnWidth."\"><center>$n</center></td>\n";		}
		print "</tr>\n";

		//Body
		$oldcat = "";
		$nn = 0;
		foreach( $quest->variables as $vn => $vv ){
			$even = ($nn % 2 != 0);
			$cat = $quest->category[$vn];
			if( $cat != "__none" && $oldcat != $cat ){
				print "<tr>";
				if( $even ){
					print "<td class=\"evenitem".$quest->level."\" colspan=\"".($this->cols+1)."\"><b>".$cat."</b></td>";
				}
				else print "<td class=\"odditem".$quest->level."\" colspan=\"".($this->cols+1)."\"><b>".$cat."</b></td>";
				print "</tr>";
			}
			$oldcat = $cat;
			print "<tr>\n";

			$otherNode = null;
			if( $quest->otherref[$vn] != "__none" ){
				FormItem::search( $quest, $quest->otherref[$vn], $otherNode );
			}

			if( $otherNode != null ){
				$otvar = "";
				if( $even ) {
					print "<td valign=\"top\" width=\"50%\" class=\"evenitem".$quest->level."\" >";
				}
				else{
					print "<td valign=\"top\" width=\"50%\" class=\"odditem".$quest->level."\" >";
				}

				if( $otherNode->type == "TE" || $otherNode->type == "ME" ){//TE, ME
					$vars = array_keys( $otherNode->variables );
					$otvar = $vars[0];
					$prefilled = "";
					$type = $otherNode->type;
					if( isset( $otherNode->prefilled ) ) $prefilled = $otherNode->prefilled;
					$length = 40;
					if( isset( $otherNode->length ) ) $length = $otherNode->length;
					print $quest->varlabels[$vn];
					print " <qtafi:".$type." size=\"".$length."\" disabled=\"true\" variable=\"$otvar\" prefilled=\"".$prefilled."\" />\n";
					print "<script type=\"text/javascript\">\n";
					//print "/* <![CDATA[ */\n";
					print "init_OTHER_OR('$otvar','$vn','$n',1);\n";
					//print "/* ]]> */\n";
					print "</script>\n";
				}
				else {
					$vars = array_keys( $otherNode->variables );
					$otvar = $vars[0];
					$prefilled = "";
					$type = $otherNode->type;
					if( isset( $otherNode->prefilled ) ) $prefilled = $otherNode->prefilled;
					$length = 40;
					if( isset( $otherNode->length ) ) $length = $otherNode->length;
					$otherNode->invisible = false;
					print "<table cellspacing=\"0\" cellpadding=\"0\" border=\"0\" width=\"100%\"><tr>";
					print "<td valign=\"top\">";
					print $quest->varlabels[$vn];
					print "</td><td valign=\"top\" width=\"80%\">";
					print "<div id=\"".$otherNode->id."__\">[...]</div>";
					print "<div id=\"".$otherNode->id."\" style=\"display:none;\" >";
					$otherNode->format();
					print "</div>";
					$otherNode->invisible = true;
					$numb = $otherNode->id;
					print "</td></tr></table>";
					print "<script type=\"text/javascript\">\n";
					//print "/* <![CDATA[\n */";
					print "init_OTHER_OR('$numb','$vn','$n', 1);\n";
					//print "/* ]]> */\n";
					print "</script>\n";
				}
			}
			else {
				if( $even ) {
					print "<td width=\"*\" class=\"evenitem".$quest->level."\" >".$quest->varlabels[$vn];
				}
				else{
					print "<td width=\"*\" class=\"odditem".$quest->level."\" >".$quest->varlabels[$vn];
				}
			}

			print "</td>\n";

			$cols = 0;
			foreach( $quest->values as $n ){
				if( $quest->missing[$n] == "true" ) continue;
				if( $even ) print "<td class=\"evenitem".$quest->level."\" width=\"".$this->columnWidth."\">\n";
				else print "<td valign=\"top\" class=\"odditem".$quest->level."\" width=\"".$this->columnWidth."\">\n";
				print "<center><qtafi:OR variable=\"$vn\" value=\"$n\" /></center>\n";
				print "</td>\n";
				$cols++;
			}

			print "</tr>\n";
			$nn++;
		}

		if( $quest->childCount > 0 ){
			print "<tr>\n";
			print "<td colspan=\"".($this->cols+1)."\" >\n";
			print "<table width=\"100%\" height=\"100%\" cellspacing=\"0\" cellpadding=\"0\">\n";
			print "<tr><td class=\"item".($quest->level +1)."\" valign=\"top\">\n";
		}
		print "<!-- end ORFormatter -->\n";
	}

	function behind( &$quest ){
		print "<!-- start ORFormatter -->\n";
		if( $quest->childCount > 0 ){
			print "</td></tr></table> \n";
			print "        </td>\n";
			print "    </tr>\n";
		}
		print "</table>\n";
		$this->dynamicFilterInit( $quest );
		print "<!-- end ORFormatter -->\n";
	}
}
?>