<?
/************************************************************************
*
*  online.QTAFI - online survey
*
*  Copyright (C) 2008  Martin Guist guist@incher.uni-kassel.de
*
*  This program is free software: you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation, either version 3 of the License, or
*  (at your option) any later version.
*
*  This program is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
*  GNU General Public License for more details.
*
*  You should have received a copy of the GNU General Public License
*  along with this program. If not, see <http://www.gnu.org/licenses/>.
*
*************************************************************************/

//include_once "Formatter.interface.php";

class StandardFormatter implements Formatter {

	public $showifarray = array();
	public $enableifarray = array();

	function jsbooleanExpr( &$farr, $fvar, $fval, $fop ){
		if( $fop == "IS" ) array_push($farr, "equals(document.qtafi2['{$fvar}'].value,'{$fval}')");
		if( $fop == "IS_NOT" ) array_push($farr, "not_equals(document.qtafi2['{$fvar}'].value,'{$fval}')");
	}
	
	function dynamicFilter( &$quest ){
		$questnum = $quest->nr;
		$attach = array();
		if( count( $quest->show_if ) > 0 ){
			$this->showifarray = array();
			foreach( $quest->show_if as $showf ){
				$fcond = $showf["cond"];
				if( $fcond == "root" ){
					$this->jsbooleanExpr( $this->showifarray,$showf["var"],$showf["val"],$showf["op"]);
					$attach[] = $showf["var"];
				}
				else if( $fcond == "AND" ){
					$andg = array();
					foreach( $showf as $showg ){
						$this->jsbooleanExpr($andg,$showg["var"],$showg["val"],$showg["op"]);
						$attach[] = $showg["var"];
					}
					$this->showifarray[] = "AND(".join(",",$andg).")";
				}
				else if( $fcond == "OR" ){
					$org = array();
					foreach( $showf as $showg ){
						$this->jsbooleanExpr($org,$showg["var"],$showg["val"],$showg["op"]);
						$attach[] = $showg["var"];
					}
					$this->showifarray[] = "OR(".join(",",$org).")";
				}
			}
			print "<script type=\"text/javascript\">\n";
			print "VariableListenerObject{$questnum} = function(){ }\n";
			print "VariableListenerObject{$questnum}.prototype.notifyVariableChanged = function(){ \n";
			print "	if( ".join("||",$this->showifarray)." ){\n";
			print "		showQuestion('TA_{$questnum}',arguments[1]);\n";
			print "	}\n";
			print "	else {\n";
			print "		hideQuestion('TA_{$questnum}',arguments[1]);\n";
			print "	}\n";
			print "}\n";
			print "var listenerobj{$questnum} = new VariableListenerObject{$questnum}();\n";
			foreach($attach as $av)print "attachVariableListener( '{$av}', listenerobj{$questnum} );\n";
			print "</script>\n";
		}
		
		if( count( $quest->enable_if ) > 0 ){
			$this->enableifarray = array();
			foreach( $quest->enable_if as $enable ){
				$evar = $enable["var"];
				$eval = $enable["val"];
				$eop = $enable["op"];
				if( $eop == "IS" ) $this->enableifarray[] = "document.qtafi2['{$evar}'].value=='{$eval}'";
				if( $eop == "IS_NOT" ) $this->enableifarray[] = "document.qtafi2['{$evar}'].value!='{$eval}'";
			}
			print "<script type=\"text/javascript\">\n";
			print "VariableListenerObject{$questnum} = function(){ }\n";
			print "VariableListenerObject{$questnum}.prototype.notifyVariableChanged = function(){ \n";
			print "	if( ".join("||",$this->enableifarray)." ){\n";
			foreach( $quest->variables as $n => $v ) print "		enableVariable('{$n}');\n";
			print "	}\n";
			print "	else {\n";
			foreach( $quest->variables as $n => $v ) print "		disableVariable('{$n}');\n";
			print "	}\n";
			print "}\n";
			print "var listenerobj{$questnum} = new VariableListenerObject{$questnum}();\n";
			foreach( $quest->enable_if as $enable ){
				$evar = $enable["var"];
				print "attachVariableListener( '{$evar}', listenerobj{$questnum} );\n";
			}
			print "</script>\n";
		}
	}

	function dynamicFilterInit( &$quest ){
		$questnum = $quest->nr;
		if( count( $quest->show_if ) > 0 ){
			$vars = array();
			foreach( $quest->show_if as $showf ){
				$fvar = $showf["var"];
				$vars[] = "document.qtafi2['{$fvar}']";
			}
			print "<script type=\"text/javascript\">\n";
			foreach( $vars as $vvv ) print "if( {$vvv} ){\n";
			foreach($quest->show_if as $showf){
				$fvar = $showf["var"];
				print "	listenerobj{$questnum}.notifyVariableChanged('{$ev}',true);\n";
			}
			foreach( $vars as $vvv ) print "}\n";
			print "</script>\n";
		}
		
		if( count( $quest->enable_if ) > 0 ){
			$evars = array();
			foreach( $quest->enable_if as $enable ){
				$evar = $enable["var"];
				$evars[] = "document.qtafi2['{$evar}']";
			}
			print "<script type=\"text/javascript\">\n";
			foreach( $evars as $vvv ) print "if( {$vvv} ){\n";
			foreach( $quest->enable_if as $enable ){
				$ev = $enable["var"];
				print "	listenerobj{$questnum}.notifyVariableChanged('{$ev}',true);\n";
			}
			foreach( $evars as $vvv ) print "}\n";
			print "</script>\n";
		}
	}
	
	function validator( &$quest ){
		if( count( $quest->execute_on ) > 0 ){
			$questnum = $quest->nr;
			print "\n<script type=\"text/javascript\">\n";
			$n = 0;
			foreach( $quest->execute_on as $act ){
				$avar = $act["var"];
				if($act["type"]=="validate"){
					$aval = $act["val"];
					$aop = $act["op"];
					switch( $aop ){
						case "IS":
							$cond = "document.qtafi2['{$avar}'].value == '{$aval}'";
						break;
						case "IS_NOT":
							$cond = "document.qtafi2['{$avar}'].value != '{$aval}'";
						break;
						case "STRLEN_LT":
							$cond = "lt(document.qtafi2['{$avar}'].value.length, {$aval})";
						break;
						case "STRLEN_GT":
							$cond = "gt(document.qtafi2['{$avar}'].value.length, {$aval})";
						break;
						case "NOT_A_NUMBER":
							$cond = "isNaN(document.qtafi2['{$avar}'].value)";
						break;
						case "A_NUMBER":
							$cond = "! isNaN(document.qtafi2['{$avar}'].value)";
						break;
					}
					print "ValidatorListenerObject{$questnum}_{$n} = function(){ }\n";
					print "ValidatorListenerObject{$questnum}_{$n}.prototype.notifyVariableChanged = function(){\n";
					//print "	if( document.qtafi2['{$avar}'].value {$aop} '{$aval}'){\n";
					print "	if( {$cond} ){\n";
					foreach( $act as $acttype => $action ){
						if( $acttype == "set" ){
							foreach( $action as $setter => $setter_vals ){
								$svar = $setter_vals["setvar"];
								$sval = $setter_vals["setval"];
								print "		set_value('{$svar}','{$sval}');\n";
							}
						}
						else if( $acttype == "alert" ){
							foreach( $action as $setter => $setter_vals ){
								$mes = $setter_vals["message"];
								print "		alert('{$mes}');\n";
							}
						}
						else if( $acttype == "enable" ){
							foreach( $action as $setter => $setter_vals ){
								$evar = $setter_vals["var"];
								print "		enableVariable('{$evar}');\n";
							}
						}
						else if( $acttype == "disable" ){
							foreach( $action as $setter => $setter_vals ){
								$evar = $setter_vals["var"];
								print "		disableVariable('{$evar}');\n";
							}
						}
						else if( $acttype == "scrollto" ){
							foreach( $action as $setter => $setter_vals ){
								$ii = $setter_vals["id"];
								print "		document.location.href='#{$ii}';\n";
							}
						}
					}
					print "	}\n";
					print "}\n";
					print "var validatorobj{$questnum}_{$n} = new ValidatorListenerObject{$questnum}_{$n}();\n";
					print "attachVariableListener( '{$avar}', validatorobj{$questnum}_{$n} );\n";
				}
				else if($act["type"]=="request_on_change"){
					print "ValidatorListenerObject{$questnum}_{$n} = function(){ }\n";
					print "ValidatorListenerObject{$questnum}_{$n}.prototype.notifyVariableChanged = function(){\n";
					if(isset($act["post"])){
						$ssa = explode(",",$act["post"]);
						$xs = array();
						foreach($ssa as $s ) array_push($xs, "'".$s."'");
						$ss = implode(",",$xs);
						print "	asynchronRequest('{$quest->id}','{$avar}',{$ss});\n";
					}
					else print "	asynchronRequest('{$quest->id}','{$avar}');\n";
					print "}\n";
					print "var validatorobj{$questnum}_{$n} = new ValidatorListenerObject{$questnum}_{$n}();\n";
					print "attachVariableListener( '{$avar}', validatorobj{$questnum}_{$n} );\n";
				}
				else if($act["type"]=="post_on_change"){
					print "ValidatorListenerObject{$questnum}_{$n} = function(){ }\n";
					print "ValidatorListenerObject{$questnum}_{$n}.prototype.notifyVariableChanged = function(){\n";
					if(isset($act["post"])){
						$ssa = explode(",",$act["post"]);
						$xs = array();
						foreach($ssa as $s ) array_push($xs, "'".$s."'");
						$ss = implode(",",$xs);
						print "	asynchronRequest('{$quest->id}','{$avar}',{$ss});\n";
					}
					else print "	asynchronRequest(null,'{$avar}');\n";
					print "}\n";
					print "var validatorobj{$questnum}_{$n} = new ValidatorListenerObject{$questnum}_{$n}();\n";
					print "attachVariableListener('{$avar}', validatorobj{$questnum}_{$n} );\n";
				}
				$n++;
			}
			print "</script>\n";
		}
	}
	
	function head( &$quest ){
		global $__DEBUG;
		if( $__DEBUG ){
			print "<small>".$quest->id;
			if( count($quest->filter) > 0 ){
				print "<br/>filter:";
				foreach( $quest->filter as $ignore ){
					print $ignore["variable"]." ".$ignore["operator"]." ".$ignore["value"];
				}
			}
			print "</small>";
		}

		$l = $quest->level;
		//if( $l == "1" ) $l = "";
		if( strlen( trim( $quest->text ) ) > 1 ){
			if( strlen( trim( $quest->number ) ) > 0 ){
				print "<table width=\"100%\" cellpadding=\"5\" cellspacing=\"0\" class=\"question_head$l\">\n";
				print "    <tr>\n";
				print "        <td class=\"question_nr$l\">".$quest->number;
				print "</td>\n";
				print "        <td class=\"question_text$l\">".$quest->text."</td>\n";
				print "    </tr>\n";
				if( mb_strlen( trim( $quest->moretext ) ) > 0 ){
					print "    <tr>\n";
					print "        <td class=\"question_more$l\" colspan=\"2\">".$quest->moretext."</td>\n";
					print "    </tr>\n";
				}
				print "</table>\n";
			}
			else{
				print "<table width=\"100%\" cellpadding=\"5\" cellspacing=\"0\" class=\"question_head$l\">\n";
				print "    <tr>\n";
				print "        <td class=\"question_text$l\">".$quest->text."</td>\n";
				print "    </tr>\n";
				if( strlen( trim( $quest->moretext ) ) > 0 ){
					print "    <tr>\n";
					print "        <td class=\"question_more$l\" >".$quest->moretext."</td>\n";
					print "    </tr>\n";
				}
				print "</table>\n";
			}
		}
		else if( strlen( trim( $quest->moretext ) ) > 0 ){
			print "<table width=\"100%\" cellpadding=\"5\" cellspacing=\"0\" class=\"question_head$l\">\n";
			print "    <tr>\n";
			print "        <td class=\"question_more$l\" colspan=\"2\">".$quest->moretext."</td>\n";
			print "    </tr>\n";
			print "</table>\n";
		}
	}

	function before( &$quest ){
        $cols = 1;
        if( $quest->layout == "horizontal" ) $cols = $quest->childCount;
        print "<!-- start StandardFormatter -->\n";
		print "            <table width=\"100%\" class=\"item".$quest->level."\" cellpadding=\"0\" cellspacing=\"0\" >\n";
		print "                <tr>\n";
		print "                    <td class=\"item".$quest->level."\">\n";

        if( strlen( trim( $quest->text ) ) > 0 ){
        	$this->head( $quest );
		}
		print "                    </td>\n";
		print "                </tr>\n";
		if( $quest->childCount > 0 ){
			print "                <tr>\n";
			print "                    <td>\n";
			print "<table><tr><td>\n";
		}
        print "<!-- end StandardFormatter -->\n";
	}

    function between( &$quest, $i = 0 ){
        print "<!-- start StandardFormatter -->\n";
        if( $quest->layout == "horizontal" ){
        	print "        </td>\n";
        	print "        <td valign=\"top\" class=\"item".($quest->level +1)."\">\n";
        }
        else{
        	print "        </td>\n";
        	print "    </tr>\n";
        	print "    <tr>\n";
        	print "        <td valign=\"top\" class=\"item".($quest->level +1)."\">\n";
        }
        print "<!-- end StandardFormatter -->\n";
    }

    function behind( &$quest ){
        print "<!-- start StandardFormatter -->\n";
        if( $quest->childCount > 0 ){
			print "</td></tr></table> \n";
			print "        </td>\n";
			print "    </tr>\n";
		}
	    print "</table>\n";
        print "<!-- end StandardFormatter -->\n";
    }
}

//$files = scandir( "./classes/format/" );
//foreach( $files as $f ) if( $f != "." && $f != ".." ) include_once $f;
?>