<?
/************************************************************************
*
*  online.QTAFI - online survey
*
*  Copyright (C) 2008  Martin Guist guist@incher.uni-kassel.de
*
*  This program is free software: you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation, either version 3 of the License, or
*  (at your option) any later version.
*
*  This program is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
*  GNU General Public License for more details.
*
*  You should have received a copy of the GNU General Public License
*  along with this program. If not, see <http://www.gnu.org/licenses/>.
*
*************************************************************************/

/**
* Formats TE-Questions
*
*/
class TEFormatter extends StandardFormatter {

	public $inputfieldsize = 12;
	public $tecols = 1;
	
    function before( &$quest ){
		if( isset( $quest->appearance["size"] ) ){
			$this->inputfieldsize = $quest->appearance["size"];
		}
		else $this->inputfieldsize = $quest->length; //deprecated    
    
    	foreach( $quest->variables as $n => $v ){
    		if( strlen( $quest->before[$n] ) > 1 ){
    			$this->tecols = 2;
    			break;
    		}
    	}
    
        $cols = 1;
        if( $quest->layout == "horizontal" ) $cols = $quest->childCount;
		$this->validator( $quest );
        print "<!-- start TEFormatter -->\n";
		$this->dynamicFilter( $quest );
		print "<table id=\"TA_{$quest->nr}\" width=\"100%\" class=\"item".$quest->level."\" cellpadding=\"0\" cellspacing=\"0\" >\n";
		print "<tr>\n";
		print "<td colspan=\"".$this->tecols."\">\n";
		$this->head( $quest );
		print "</td>\n";
		print "</tr>\n";

        foreach( $quest->variables as $n => $v ){
			print "<tr>\n";
			if( $this->tecols == 2 ){
            	print "<td class=\"item".$quest->level."\">".$quest->before[$n]."</td>\n";
            }
            print "<td class=\"item".$quest->level."\">\n";
            print "<qtafi:TE variable=\"$n\" size=\"".$this->inputfieldsize."\" prefilled=\"".$quest->prefilled."\" />\n";
            print $quest->behind[$n]."</td>";
			print "</tr>\n";
        }

		if( $quest->childCount > 0 ){
			print "<tr>\n";
			print "<td colspan=\"".$this->tecols."\">\n";
			print "<table width=\"100%\" cellspacing=\"0\" cellpadding=\"0\">\n";
			print "<tr><td class=\"item".($quest->level +1)."\" valign=\"top\">\n";
		}
        print "<!-- end TEFormatter -->\n";
    }

    function behind( &$quest ){
		print "<!-- start TEFormatter -->\n";
		if( $quest->childCount > 0 ){
			print "</td></tr></table> \n";
			print "        </td>\n";
			print "    </tr>\n";
		}
		print "</table>\n";
		$this->dynamicFilterInit( $quest );
		print "<!-- end TEFormatter -->\n";
    }
}
?>