<?
/************************************************************************
*
*  online.QTAFI - online survey
*
*  Copyright (C) 2008  Martin Guist guist@incher.uni-kassel.de
*
*  This program is free software: you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation, either version 3 of the License, or
*  (at your option) any later version.
*
*  This program is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
*  GNU General Public License for more details.
*
*  You should have received a copy of the GNU General Public License
*  along with this program. If not, see <http://www.gnu.org/licenses/>.
*
*************************************************************************/

class COUNTRYNode extends InputNode {
	
	public static $type = "COUNTRY";
	public $value;
	
	function __construct( &$doc, &$node, $n = 1 ){
		$this->document = $doc;
		$this->qtafiElement = $node;
		$this->variable = $node->getAttribute( "variable" );
		
		$this->htmlElement = $this->document->createElement( "select" );
		$this->htmlElement->setAttribute( "name", $this->variable );
		
		$lang = "en";
		if( $node->hasAttribute("lang" ) ) $lang = $node->getAttribute( "lang" );
		
		if( $lang == "de" ) $this->buildCountries_de();
		else $this->buildCountries_en();

		$parentNode = $node->parentNode;
		$parentNode->replaceChild( $this->htmlElement, $node );
	}
	
	function buildCountries_de(){
		$this->htmlElement->appendChild( $this->buildCountryNode( "Bitte auswhlen...", "0" ) );
		$this->htmlElement->appendChild( $this->buildCountryNode( "sterreich", "1" ) );
        $this->htmlElement->appendChild( $this->buildCountryNode( "Belgien", "2" ) );
        $this->htmlElement->appendChild( $this->buildCountryNode( "Bulgarien", "3" ) );
        $this->htmlElement->appendChild( $this->buildCountryNode( "Zypern", "4" ) );
        $this->htmlElement->appendChild( $this->buildCountryNode( "Tchechien", "5" ) );
        $this->htmlElement->appendChild( $this->buildCountryNode( "Dnemark", "6" ) );
        $this->htmlElement->appendChild( $this->buildCountryNode( "Estland", "7" ) );
        $this->htmlElement->appendChild( $this->buildCountryNode( "Finnland", "8" ) );
        $this->htmlElement->appendChild( $this->buildCountryNode( "Frankreich", "9" ) );
        $this->htmlElement->appendChild( $this->buildCountryNode( "Deutschland", "10" ) );
        $this->htmlElement->appendChild( $this->buildCountryNode( "Griechenland", "11" ) );
        $this->htmlElement->appendChild( $this->buildCountryNode( "Ungarn", "12" ) );
        $this->htmlElement->appendChild( $this->buildCountryNode( "Island", "13" ) );
        $this->htmlElement->appendChild( $this->buildCountryNode( "Irland", "14" ) );
        $this->htmlElement->appendChild( $this->buildCountryNode( "Italien", "15" ) );
        $this->htmlElement->appendChild( $this->buildCountryNode( "Lettland", "16" ) );
        $this->htmlElement->appendChild( $this->buildCountryNode( "Liechtenstein", "17" ) );
        $this->htmlElement->appendChild( $this->buildCountryNode( "Litauen", "18" ) );
        $this->htmlElement->appendChild( $this->buildCountryNode( "Luxemburg", "19" ) );
        $this->htmlElement->appendChild( $this->buildCountryNode( "Malta", "20" ) );
        $this->htmlElement->appendChild( $this->buildCountryNode( "Niederlande", "21" ) );
        $this->htmlElement->appendChild( $this->buildCountryNode( "Norwegen", "22" ) );
        $this->htmlElement->appendChild( $this->buildCountryNode( "Polen", "23" ) );
        $this->htmlElement->appendChild( $this->buildCountryNode( "Portugal", "24" ) );
        $this->htmlElement->appendChild( $this->buildCountryNode( "Rumnien", "25" ) );
        $this->htmlElement->appendChild( $this->buildCountryNode( "Slowakei", "26" ) );
        $this->htmlElement->appendChild( $this->buildCountryNode( "Slowenien", "27" ) );
        $this->htmlElement->appendChild( $this->buildCountryNode( "Spanien", "28" ) );
        $this->htmlElement->appendChild( $this->buildCountryNode( "Schweden", "29" ) );
        $this->htmlElement->appendChild( $this->buildCountryNode( "Schweiz", "30" ) );
        $this->htmlElement->appendChild( $this->buildCountryNode( "England", "31" ) );
        $this->htmlElement->appendChild( $this->buildCountryNode( "Andere", "32" ) );
	}
	
	function buildCountries_en(){
			$this->htmlElement->appendChild( $this->buildCountryNode( "Select...", "0" ) );
			$this->htmlElement->appendChild( $this->buildCountryNode( "Austria", "1" ) );
	        $this->htmlElement->appendChild( $this->buildCountryNode( "Belgium", "2" ) );
	        $this->htmlElement->appendChild( $this->buildCountryNode( "Bulgaria", "3" ) );
	        $this->htmlElement->appendChild( $this->buildCountryNode( "Cyprus", "4" ) );
	        $this->htmlElement->appendChild( $this->buildCountryNode( "Czech Republic", "5" ) );
	        $this->htmlElement->appendChild( $this->buildCountryNode( "Denmark", "6" ) );
	        $this->htmlElement->appendChild( $this->buildCountryNode( "Estonia", "7" ) );
	        $this->htmlElement->appendChild( $this->buildCountryNode( "Finland", "8" ) );
	        $this->htmlElement->appendChild( $this->buildCountryNode( "France", "9" ) );
	        $this->htmlElement->appendChild( $this->buildCountryNode( "Germany", "10" ) );
	        $this->htmlElement->appendChild( $this->buildCountryNode( "Greece", "11" ) );
	        $this->htmlElement->appendChild( $this->buildCountryNode( "Hungary", "12" ) );
	        $this->htmlElement->appendChild( $this->buildCountryNode( "Iceland", "13" ) );
	        $this->htmlElement->appendChild( $this->buildCountryNode( "Ireland", "14" ) );
	        $this->htmlElement->appendChild( $this->buildCountryNode( "Italy", "15" ) );
	        $this->htmlElement->appendChild( $this->buildCountryNode( "Latvia", "16" ) );
	        $this->htmlElement->appendChild( $this->buildCountryNode( "Liechtenstein", "17" ) );
	        $this->htmlElement->appendChild( $this->buildCountryNode( "Lithuania", "18" ) );
	        $this->htmlElement->appendChild( $this->buildCountryNode( "Luxembourg", "19" ) );
	        $this->htmlElement->appendChild( $this->buildCountryNode( "Malta", "20" ) );
	        $this->htmlElement->appendChild( $this->buildCountryNode( "Netherlands", "21" ) );
	        $this->htmlElement->appendChild( $this->buildCountryNode( "Norway", "22" ) );
	        $this->htmlElement->appendChild( $this->buildCountryNode( "Poland", "23" ) );
	        $this->htmlElement->appendChild( $this->buildCountryNode( "Portugal", "24" ) );
	        $this->htmlElement->appendChild( $this->buildCountryNode( "Romania", "25" ) );
	        $this->htmlElement->appendChild( $this->buildCountryNode( "Slovakia", "26" ) );
	        $this->htmlElement->appendChild( $this->buildCountryNode( "Slovenia", "27" ) );
	        $this->htmlElement->appendChild( $this->buildCountryNode( "Spain", "28" ) );
	        $this->htmlElement->appendChild( $this->buildCountryNode( "Sweden", "29" ) );
	        $this->htmlElement->appendChild( $this->buildCountryNode( "Switzerland", "30" ) );
	        $this->htmlElement->appendChild( $this->buildCountryNode( "England", "31" ) );
	        $this->htmlElement->appendChild( $this->buildCountryNode( "Other", "32" ) );
	}
	
	function buildCountryNode( $country, $val ){
		 $ctr = $this->document->createElement( "option" );
		 $ctr->setAttribute( "value", $val );
		 $label = $this->document->createTextNode( utf8_encode( $country ) );
		 $ctr->appendChild( $label );
		 return $ctr;
	}
	
	function setValue( &$vars ){
		$val = $vars[$this->variable];
		foreach( $this->htmlElement->childNodes as $child ){
			if( $child->getAttribute( "value" ) == $val ){
				$child->setAttribute( "selected", "selected" );
			}
		}
	}
}
?>