<?
/************************************************************************
*
*  online.QTAFI - online survey
*
*  Copyright (C) 2008  Martin Guist guist@incher.uni-kassel.de
*
*  This program is free software: you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation, either version 3 of the License, or
*  (at your option) any later version.
*
*  This program is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
*  GNU General Public License for more details.
*
*  You should have received a copy of the GNU General Public License
*  along with this program. If not, see <http://www.gnu.org/licenses/>.
*
*************************************************************************/

/**
* radiobutton:
* <qtafi:CV variable="varXX" value="1" />
*
*
* Pulldown:
* <qtafi:CV variable="varXX" type="pulldown" >
*     <option value="1" label=""/>
*     <option value="2" label=""/>
* </qtafi:CV>
*
*
* Pulldown with groups:
* <qtafi:CV variable="varXX" type="pulldown" >
*     <group label="Group1">
*         <option value="1" label=""/>
*         <option value="2" label=""/>
*     </group>
*     <group label="Group2">
* </qtafi:CV>
*
* Readonly
*
*/
class CVNode extends InputNode {

	public static $type = "CV";
	public $layoutType = "radiobutton";
	public $value = "1";
	public $hiddenElement = NULL;
	public $inputElement = NULL;

	function __construct( &$doc, &$node, $n ){
		global $__DEBUG;
		$this->document = $doc;
		$this->qtafiElement = $node;
		$this->variable = $node->getAttribute( "variable" );
		if( $node->hasAttribute( "type" ) ){
			$this->layoutType = $node->getAttribute( "type" );
		}

		if( $__DEBUG ){
			$this->value = 1;
			if( $node->hasAttribute( "value" ) ) $this->value = $node->getAttribute( "value" );
			$this->htmlElement = $this->document->createElement( "small" );
			$this->htmlElement->appendChild( $this->document->createTextNode( "CV(".$this->variable."=".$this->value.")" ) );
			$parentNode = $node->parentNode;
			$parentNode->replaceChild( $this->htmlElement, $node );
			return;
		}

		if( $this->layoutType == "pulldown" ){
			$this->htmlElement = $this->document->createElement( "select" );
			$onchange = "valueChanged('{$this->variable}');";
			if( $node->hasAttribute( "onChange" ) ) $onchange .= $node->getAttribute( "onChange" );

			if( strlen( $onchange ) > 1 ){
				$this->htmlElement->setAttribute( "onChange", $onchange );
			}

			$this->htmlElement->setAttribute( "name", $this->variable );
			if( $node->hasAttribute( "size" ) ){
				$this->htmlElement->setAttribute( "size", $node->getAttribute( "size" ) );
			}
			else $this->htmlElement->setAttribute( "size", "1" );

			$items = $node->childNodes;

			foreach( $items as $opt ){
				if( $opt->nodeName == "option" ){
					$optElement = $this->document->createElement( "option" );
					$optElement->setAttribute( "value", $opt->getAttribute( "value" ) );
					$label = "Label";
					if( $opt->hasAttribute( "label" ) ) $label = $opt->getAttribute( "label" );
					$tt = $this->document->createTextNode( $label );
					$optElement->appendChild( $tt );
					$this->htmlElement->appendChild( $optElement );
				}
				elseif( $opt->nodeName == "group" ){
					$optgroupElement = $this->document->createElement( "optgroup" );
					$label = "Label";
					if( $opt->hasAttribute( "label" ) ) $label = $opt->getAttribute( "label" );
					$optgroupElement->setAttribute( "label", $label );
					$optitems = $opt->getElementsByTagName( "option" );
					foreach( $optitems as $gropt ){
						$optElement = $this->document->createElement( "option" );
						$optElement->setAttribute("value", $gropt->getAttribute( "value" ) );
						$label = "Label";
						if( $gropt->hasAttribute("label" ) ) $label = $gropt->getAttribute("label");
						$tt = $this->document->createTextNode( $label );
						$optElement->appendChild( $tt );
						$optgroupElement->appendChild( $optElement );
					}
					$this->htmlElement->appendChild( $optgroupElement );
				}
			}

			$parentNode = $node->parentNode;
			$parentNode->replaceChild( $this->htmlElement, $node );
			return;
		}
		if($this->layoutType == "readonly"){
			global $user;
			$this->htmlElement = $this->document->createElement("span");
			$items = $node->childNodes;
			$value = $user->getValue($this->variable);
			foreach($items as $opt){
				if($opt->nodeName == "option"){
					if($opt->getAttribute("value") == $value){
						$tt = $this->document->createTextNode($opt->getAttribute("label"));
						$this->htmlElement->appendChild($tt);
						break;
					}
				}
			}
			$parentNode = $node->parentNode;
			$parentNode->replaceChild($this->htmlElement, $node);
			return;
		}
		$this->value = 1;
		if($node->hasAttribute("value")) $this->value = $node->getAttribute("value");

		$onclick = "";
		if( $node->hasAttribute( "onClick" ) ) $onclick = $node->getAttribute( "onClick" );

		$this->htmlElement = $this->document->createElement( "span" );
		$this->inputElement = $this->document->createElement( "input" );
		$this->inputElement->setAttribute( "type", "radio" );
		$this->inputElement->setAttribute( "name", "__".$this->variable );
		$this->inputElement->setAttribute( "value", $this->value );
		$this->inputElement->setAttribute( "onClick", "toggle_CV( '".$this->variable."', '-9', '".$this->value."', ".($n-1)." ); $onclick" );

		$this->htmlElement->appendChild( $this->inputElement );

		//once
		if( ! in_array( $this->variable, Postprocessor::$flaggedVariables ) ){
			$this->hiddenElement = $this->document->createElement( "input" );
			$this->hiddenElement->setAttribute( "type", "hidden" );
			$this->hiddenElement->setAttribute( "name", $this->variable );
			$this->htmlElement->appendChild( $this->hiddenElement );
			array_push( Postprocessor::$flaggedVariables, $this->variable );
		}

		$parentNode = $node->parentNode;
		$parentNode->replaceChild( $this->htmlElement, $node );
	}

	function setValue(&$vars){
		$val = html_entity_decode( $vars[$this->variable], ENT_QUOTES, "utf-8" );
		if( strlen( $val ) == 0 ) $val = "-9";
		if( $this->layoutType == "pulldown" ){
			$items = $this->htmlElement->getElementsByTagName("option");
			foreach( $items as $opt ){
				if( $opt->getAttribute("value") == $val ){
					$opt->setAttribute( "selected", "selected" );
				}
			}
			return;
		}
		if($this->layoutType == "readonly") return;
		if( $this->hiddenElement ) $this->hiddenElement->setAttribute( "value", $val );
		if( $this->value == $val ){
			if( $this->inputElement ) $this->inputElement->setAttribute( "checked", "checked" );
		}
	}
}

?>