<?
/************************************************************************
*
*  online.QTAFI - online survey
*
*  Copyright (C) 2008  Martin Guist guist@incher.uni-kassel.de
*
*  This program is free software: you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation, either version 3 of the License, or
*  (at your option) any later version.
*
*  This program is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
*  GNU General Public License for more details.
*
*  You should have received a copy of the GNU General Public License
*  along with this program. If not, see <http://www.gnu.org/licenses/>.
*
*************************************************************************/

/**
* 
* <qtafi:ERROR>
*     <MESSAGE code="1"></MESSAGE>
* </qtafi:ERROR>
*
*/
class ERRORNode extends InputNode {
	
	public static $type = "ERROR";
	public $messages = array();
	
	function __construct( &$doc, &$node, $n = 1 ){
		$this->document = $doc;
		$this->qtafiElement = $node;
		$this->messages[0] = "";
		$this->messages[1] = "The PIN is not valid. Please try again.";
		$this->messages[2] = "No configuration file";
		$this->messages[99] = "Unknown error";
		
		$messages = $node->getElementsByTagName( "MESSAGE" );
		foreach( $messages as $message ){
			if( $message->hasAttribute( "code" ) ){
				$this->messages[intval($message->getAttribute("code"))] = $message->textContent;
			}
		}
		$this->htmlElement = $this->document->createElement( "span" );
		$parentNode = $node->parentNode;
		$parentNode->replaceChild( $this->htmlElement, $this->qtafiElement );
	}
	
	function setValue( &$vars ){
		global $__AUTHENTICATION,$__PAGE, $__ERROR;
		if( $__ERROR > 0 ){
			$errorNode = $this->document->createElement( "font" );
			$errorNode->setAttribute( "color", "#ff0000" );
			$img = $this->document->createElement( "img" );
			$img->setAttribute( "src", ROOT_PATH."/images/errorArrow.gif" );
			$img->setAttribute( "border", "0" );	
			$errorNode->appendChild( $img );
			if( isset( $this->messages[$__ERROR] ) ){
				$errorNode->appendChild( $this->document->createTextNode( " ".$this->messages[$__ERROR] ) );
			}
			else {
				$errorNode->appendChild( $this->document->createTextNode( " Error Code: ".$__ERROR ) );
			}
			$errorNode->appendChild( $this->document->createElement( "br" ) );
			$errorNode->appendChild( $this->document->createElement( "br" ) );
			$this->htmlElement->appendChild( $errorNode );
		}
	}
}

?>