<?
/************************************************************************
*
*  online.QTAFI - online survey
*
*  Copyright (C) 2008  Martin Guist guist@incher.uni-kassel.de
*
*  This program is free software: you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation, either version 3 of the License, or
*  (at your option) any later version.
*
*  This program is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
*  GNU General Public License for more details.
*
*  You should have received a copy of the GNU General Public License
*  along with this program. If not, see <http://www.gnu.org/licenses/>.
*
*************************************************************************/

/**
*
* <qtafi:HIDDEN variable="var" value_of="" />
* <qtafi:HIDDEN variable="var" staticvalue="" />
*
* (1) __pin erlauben
*/
class HIDDENNode extends InputNode {

	public static $type = "HIDDEN";
	public $value_of = null;
	public $staticvalue = null;

	function __construct( &$doc, &$node ){
		global $__DEBUG;
		$this->document = $doc;
		$this->qtafiElement = $node;
		$this->variable = $node->getAttribute( "variable" );

		if( $__DEBUG ){
			$this->htmlElement = $this->document->createElement( "small" );
			$this->htmlElement->appendChild( $this->document->createTextNode( "HIDDEN(".$this->variable.")" ) );
			$parentNode = $node->parentNode;
			$parentNode->replaceChild( $this->htmlElement, $node );
			return;
		}


		if( $node->hasAttribute( "value_of" ) ){
			$this->value_of = $node->getAttribute( "value_of" );
		}
		if( $node->hasAttribute( "staticvalue" ) ){
			$this->staticvalue = $node->getAttribute( "staticvalue" );
			$this->htmlElement = $this->document->createElement( "input" );
			$this->htmlElement->setAttribute( "type", "hidden" );
			$this->htmlElement->setAttribute( "name", $this->variable );

		}
		if( $node->hasAttribute( "readonly" ) ){
			$this->htmlElement = $this->document->createElement( "span" );
		}
		else{
			$this->htmlElement = $this->document->createElement( "input" );
			$this->htmlElement->setAttribute( "type", "hidden" );
			$this->htmlElement->setAttribute( "name", $this->variable );
		}

		$parentNode = $node->parentNode;
		$parentNode->replaceChild( $this->htmlElement, $node );
	}

	function setValue( &$vars ){
		if(  $this->staticvalue != null ){
			$this->htmlElement->setAttribute( "value", $this->staticvalue );
		}
		elseif( $this->value_of != null ){
			$val = html_entity_decode( $vars[$this->value_of], ENT_QUOTES, "utf-8" );
			$this->htmlElement->setAttribute( "value", $val );
		}
		else {
			$val = html_entity_decode( $vars[$this->variable], ENT_QUOTES, "utf-8" );
			$this->htmlElement->setAttribute( "value", $val );
		}
	}
}

?>
