<?
/************************************************************************
*
*  online.QTAFI - online survey
*
*  Copyright (C) 2008  Martin Guist guist@incher.uni-kassel.de
*
*  This program is free software: you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation, either version 3 of the License, or
*  (at your option) any later version.
*
*  This program is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
*  GNU General Public License for more details.
*
*  You should have received a copy of the GNU General Public License
*  along with this program.  If not, see <http://www.gnu.org/licenses/>.
*
*************************************************************************/

/**
* Ignores the html if variable == value
*
* <qtafi:IGNORE_IF text="" variable="var1" value="1">
*	<html>
* </qtafi:IGNORE_IF>
*
*/
class IGNORE_IFNode extends InputNode {

	public static $type = "IGNORE_IF";
	public $value = "";
	public $htmlContent;

	function __construct( &$doc, &$node ){
		$this->document = $doc;
		$this->qtafiElement = $node;
		$this->variable = $node->getAttribute( "variable" );
		$this->value = $node->getAttribute( "value" );
		
		$this->htmlContent = $this->document->createElement( "div" );
		foreach( $node->childNodes as $ch ) $this->htmlContent->appendChild( $ch->cloneNode( true ) );
		
		$this->htmlElement = $this->document->createElement( "span" );

		$parentNode = $node->parentNode;
		$parentNode->replaceChild( $this->htmlContent, $node );
	}

	function setValue( &$vars ){
		if( isset( $vars[$this->variable] ) ){
			$val = html_entity_decode( $vars[$this->variable], ENT_QUOTES, "utf-8" );
			if( strlen( $val ) == 0 ) $val = "-9";
			if( $val == $this->value ){
				$par = $this->htmlContent->parentNode;
				$par->replaceChild( $this->htmlElement, $this->htmlContent );
			}
		}
	}
}
?>