<?
/************************************************************************
*
*  online.QTAFI - online survey
*
*  Copyright (C) 2008  Martin Guist guist@incher.uni-kassel.de
*
*  This program is free software: you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation, either version 3 of the License, or
*  (at your option) any later version.
*
*  This program is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
*  GNU General Public License for more details.
*
*  You should have received a copy of the GNU General Public License
*  along with this program. If not, see <http://www.gnu.org/licenses/>.
*
*************************************************************************/

/**
* checkbox
*
* <qtafi:MD variable="var" value="3" />
*
*/
class MDNode extends InputNode {

	public static $type = "MD";
	public $value = 1;
	public $hiddenElement = NULL;
	public $inputElement = NULL;

	function __construct( &$doc, &$node, $n ){
		global $__DEBUG;
		$this->document = $doc;
		$this->qtafiElement = $node;
		$this->variable = $node->getAttribute( "variable" );

		$this->value = 1;
		if( $node->hasAttribute( "value" ) ) $this->value = $node->getAttribute( "value" );

		if( $__DEBUG ){
			$this->htmlElement = $this->document->createElement( "small" );
			$this->htmlElement->appendChild( $this->document->createTextNode( "MD(".$this->variable."=".$this->value.")" ) );
			$parentNode = $node->parentNode;
			$parentNode->replaceChild( $this->htmlElement, $node );
			return;
		}

		$onclick = "";
		if( $node->hasAttribute( "onClick" ) ) $onclick = $node->getAttribute( "onClick" );

		//$this->htmlElement = $this->document->createElement( "input" );
		//$this->htmlElement->setAttribute( "type", "checkbox" );
		//$this->htmlElement->setAttribute( "name", "__".$this->variable );
		//$this->htmlElement->setAttribute( "value", $this->value );
		//$this->htmlElement->setAttribute( "onClick", "toggle_MD( '".$this->variable."', '-9', '1' ); $onclick" );

		$this->htmlElement = $this->document->createElement( "span" );

		$this->inputElement = $this->document->createElement( "input" );
		$this->inputElement->setAttribute( "type", "checkbox" );
		$this->inputElement->setAttribute( "name", "__".$this->variable );
		$this->inputElement->setAttribute( "value", $this->value );
		$this->inputElement->setAttribute( "onClick", "toggle_MD( '".$this->variable."', '-9', '".$this->value."' ); $onclick" );

		$this->htmlElement->appendChild( $this->inputElement );

		$this->hiddenElement = $this->document->createElement( "input" );
		$this->hiddenElement->setAttribute( "type", "hidden" );
		$this->hiddenElement->setAttribute( "name", $this->variable );
		$this->hiddenElement->setAttribute( "value", "1" );
		$this->htmlElement->appendChild( $this->hiddenElement );

		$parentNode = $node->parentNode;
		$parentNode->replaceChild( $this->htmlElement, $node );
	}

	function setValue( &$vars ){
		$val = html_entity_decode( $vars[$this->variable], ENT_QUOTES, "utf-8" );
		if( strlen( $val ) == 0 ) $val = "-9";
		if( $this->hiddenElement ) $this->hiddenElement->setAttribute( "value", $val );
		if( $this->value == $val ){
			$this->htmlElement->setAttribute( "checked", "checked" );
			$this->inputElement->setAttribute( "checked", "checked" );
			$this->hiddenElement->setAttribute( "value", "$val" );
		}
		else if( $this->hiddenElement ) $this->hiddenElement->setAttribute( "value", MISSING );
	}
}

?>