<?
/************************************************************************
*
*  online.QTAFI - online survey
*
*  Copyright (C) 2008  Martin Guist guist@incher.uni-kassel.de
*
*  This program is free software: you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation, either version 3 of the License, or
*  (at your option) any later version.
*
*  This program is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
*  GNU General Public License for more details.
*
*  You should have received a copy of the GNU General Public License
*  along with this program.  If not, see <http://www.gnu.org/licenses/>.
*
*************************************************************************/

class MENode extends InputNode {

	public static $type = "ME";
	public $decimal = "44";

	function __construct( &$doc, &$node ){
		global $__DEBUG;
		$this->document = $doc;
		$this->qtafiElement = $node;
		$this->variable = $node->getAttribute( "variable" );

		if( $__DEBUG ){
			$this->htmlElement = $this->document->createElement( "small" );
			$this->htmlElement->appendChild( $this->document->createTextNode( "ME(".$this->variable.")" ) );
			$parentNode = $node->parentNode;
			$parentNode->replaceChild( $this->htmlElement, $node );
			return;
		}

		$size = 4;
		if( $node->hasAttribute( "size" ) ) $size = $node->getAttribute( "size" );
		if( $node->hasAttribute( "decimal" ) ){
			$dec = $node->getAttribute( "decimal" );
			if( $dec == '.' ) $this->decimal = "46";
			elseif( $dec == ',' ) $this->decimal = "44";
		}
		
		$this->htmlElement = $this->document->createElement( "input" );
		$this->htmlElement->setAttribute( "type", "text" );
		$this->htmlElement->setAttribute( "style", "text-align:right" );
		$this->htmlElement->setAttribute( "name", $this->variable );
		$this->htmlElement->setAttribute( "size", $size );
		$this->htmlElement->setAttribute( "maxlength", $size );
		$this->htmlElement->setAttribute( "onkeyPress", "return checkInteger(event,".$this->decimal.");" );
		
		$keyup = "valueChanged('{$this->variable}');";
		if( $node->hasAttribute( "onkeyup" ) ){
			$keyup .= $node->getAttribute( "onkeyup" );
		}
		$this->htmlElement->setAttribute( "onkeyup", $keyup );

		if( $node->hasAttribute( "disabled" ) ){
			$dis = $node->getAttribute( "disabled" );
			if( $dis == "true" ) $this->htmlElement->setAttribute( "disabled", "disabled" );
		}

		$parentNode = $node->parentNode;
		$parentNode->replaceChild( $this->htmlElement, $this->qtafiElement );
	}

	function setValue( &$vars ){
		$val = html_entity_decode( $vars[$this->variable], ENT_QUOTES, "utf-8" );
		if( $val == MISSING ) $val = "";
		$this->htmlElement->setAttribute( "value", $val );
	}
}
?>