<?
/************************************************************************
*
*  online.QTAFI - online survey
*
*  Copyright (C) 2008  Martin Guist guist@incher.uni-kassel.de
*
*  This program is free software: you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation, either version 3 of the License, or
*  (at your option) any later version.
*
*  This program is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
*  GNU General Public License for more details.
*
*  You should have received a copy of the GNU General Public License
*  along with this program.  If not, see <http://www.gnu.org/licenses/>.
*
*************************************************************************/

/**
*
* <qtafi:OR variable="var1" value="2" />
*
* rather similar to CVNode
*/
class ORNode extends InputNode {

	public static $type = "OR";
	public $value;
	public $hiddenElement = NULL;
	public $inputElement = NULL;

	function __construct( &$doc, &$node, $n ){
		global $__DEBUG;
		$this->document = $doc;
		$this->qtafiElement = $node;
		$this->variable = $node->getAttribute( "variable" );

		$this->value = 1;
		if( $node->hasAttribute( "value" ) ) $this->value = $node->getAttribute( "value" );

		if( $__DEBUG ){
			$this->htmlElement = $this->document->createElement( "small" );
			$this->htmlElement->appendChild( $this->document->createTextNode( "OR(".$this->variable."=".$this->value.")" ) );
			$parentNode = $node->parentNode;
			$parentNode->replaceChild( $this->htmlElement, $node );
			return;
		}
		//$this->htmlElement = $this->document->createElement( "input" );
		//$this->htmlElement->setAttribute( "type", "radio" );
		//$this->htmlElement->setAttribute( "name", "__".$this->variable );
		//$this->htmlElement->setAttribute( "value", $this->value );
		//$this->htmlElement->setAttribute( "onClick", "toggle_CV( '".$this->variable."', '-9', '".$this->value."', ".($n-1)." );" );

		$this->htmlElement = $this->document->createElement( "div" );

		$this->inputElement = $this->document->createElement( "input" );
		$this->inputElement->setAttribute( "type", "radio" );
		$this->inputElement->setAttribute( "name", "__".$this->variable );
		$this->inputElement->setAttribute( "value", $this->value );
		$this->inputElement->setAttribute( "onClick", "toggle_OR( '".$this->variable."', '-9', '".$this->value."', ".($n-1)." );" );

		$this->htmlElement->appendChild( $this->inputElement );

		if( ! in_array( $this->variable, Postprocessor::$flaggedVariables ) ){
			$this->hiddenElement = $this->document->createElement( "input" );
			$this->hiddenElement->setAttribute( "type", "hidden" );
			$this->hiddenElement->setAttribute( "name", $this->variable );
			$this->htmlElement->appendChild( $this->hiddenElement );
			array_push( Postprocessor::$flaggedVariables, $this->variable );
		}

		$parentNode = $node->parentNode;
		$parentNode->replaceChild( $this->htmlElement, $node );
	}

	function setValue( &$vars ){
		$val = html_entity_decode( $vars[$this->variable], ENT_QUOTES, "utf-8" );
		if( $this->hiddenElement ) $this->hiddenElement->setAttribute( "value", $val );
		if( $this->value == $val ){
			$this->inputElement->setAttribute( "checked", "checked" );
		}
	}
}
?>