<?
/************************************************************************
*
*  online.QTAFI - online survey
*
*  Copyright (C) 2008  Martin Guist guist@incher.uni-kassel.de
*
*  This program is free software: you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation, either version 3 of the License, or
*  (at your option) any later version.
*
*  This program is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
*  GNU General Public License for more details.
*
*  You should have received a copy of the GNU General Public License
*  along with this program. If not, see <http://www.gnu.org/licenses/>.
*
*************************************************************************/

/**
* 
* <RECEPTION variable="var" method="post" requestvar="user" />
*
* adds a variable
* fetches the var from the $_POST or $_GET and saves the value.
*
* fetch method
*/
class RECEPTIONNode extends InputNode {

	public static $type = "INBOX";
	public $value = ""; 

	function __construct( &$doc, &$node ){
		global $_POST, $_GET, $user;
		$this->document = $doc;
		$this->qtafiElement = $node;
		$this->variable = NULL;
		
		$parentNode = $node->parentNode;
		
		if( $node->hasAttribute( "variable" ) ){
			$this->variable = $node->getAttribute( "variable" );
		}
		else{
			$parentNode->removeChild( $node );
			return;
		}
		
		$requestvar = $this->variable;
		if( $node->hasAttribute( "requestvar" ) ){
			$requestvar = $node->getAttribute( "requestvar" );
		}
		
		$method = "POST_AND_GET"; 
		if( $node->hasAttribute( "method" ) ){
			$method = $node->getAttribute( "method" );
		}
		
		if( $method == "post" ){
			if( isset( $_POST[$requestvar] ) ){
				$this->value = $_POST[$requestvar];
			}
		}
		else if( $method == "get" ){
			if( isset( $_GET[$requestvar] ) ){
				$this->value = $_GET[$requestvar];
			}
		}
		else{
			if( isset( $_POST[$requestvar] ) ){
				$this->value = $_POST[$requestvar];
			}
			else if( isset( $_GET[$requestvar] ) ){
				$this->value = $_GET[$requestvar];
			}
		}
		
		/**
		* adds the variable even there is no authentication!!
		*/
		$user->addVariable( $this->variable );
		
		$this->htmlElement = $this->document->createElement( "input" );
		$this->htmlElement->setAttribute( "type", "hidden" );
		$this->htmlElement->setAttribute( "name", $this->variable );
		$this->htmlElement->setAttribute( "value", $this->value );
		
		$parentNode->replaceChild( $this->htmlElement, $node );
	}

	function setValue( &$vars ){
	}
}
?>