<?
/************************************************************************
*
*  online.QTAFI - online survey
*
*  Copyright (C) 2008  Martin Guist guist@incher.uni-kassel.de
*
*  This program is free software: you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation, either version 3 of the License, or
*  (at your option) any later version.
*
*  This program is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
*  GNU General Public License for more details.
*
*  You should have received a copy of the GNU General Public License
*  along with this program. If not, see <http://www.gnu.org/licenses/>.
*
*************************************************************************/

/**
*
* <qtafi:RESULT type="number" variable="varXX" />
*
* or:
* <qtafi:RESULT type="circularchart" variable="varXX">
*     <label value="1">xxx<label>
* </qtafi:RESULT>
*
* Types:
* - count
* - percent
* - barchart (single)
* - circularchart
*
*/
class RESULT extends InputNode {

	public static $type = "RESULT";
	public $value = "1";
	public $variable = "__n";
	public $variant = "percent";
	public $width =  300;
	public $height = 200;

	function __construct( &$doc, &$node ){
		global $__ROW_COUNT;
		if( $__ROW_COUNT < 0 ){
			$res = mysql_query( "SELECT COUNT(*) FROM ".DATABASE , DB_HANDLE );
			$row = mysql_fetch_assoc( $res );
			$__ROW_COUNT = $row["COUNT(*)"];
		}

		$this->document = $doc;
		$this->qtafiElement = $node;

		$this->variable = "__n";
		if( $node->hasAttribute( "variable" ) ) $this->variable = $node->getAttribute( "variable" );
		$var = $this->variable;

		$this->value = "1";
		if( $node->hasAttribute( "value" ) ) $this->value = $node->getAttribute( "value" );
		$val = (string)$this->value;

		if( $node->hasAttribute( "type" ) ) $this->variant = $node->getAttribute( "type" );
		if( $node->hasAttribute( "width" ) ) $this->width = $node->getAttribute( "width" );
		if( $node->hasAttribute( "height" ) ) $this->height = $node->getAttribute( "height" );

		switch( $this->variant ){
		case "count":
			$valuecount = 0;
			if( $val == "*" ){
				$res = mysql_query( "SELECT COUNT(*) FROM ".DATABASE , DB_HANDLE ) or die( mysql_error() );
			}
			else $res = mysql_query( "SELECT COUNT(*) FROM ".DATABASE." WHERE $var=\"$val\" " , DB_HANDLE ) or die( mysql_error() );
			$row = mysql_fetch_assoc( $res );
			$valuecount = $row["COUNT(*)"];
			$this->htmlElement = $this->document->createElement( "span" );
			$te = $this->document->createTextNode( $valuecount );
			$this->htmlElement->appendChild( $te );
			break;

		case "percent":
			$valuecount = 0;
			$res = mysql_query( "SELECT COUNT(*) FROM ".DATABASE." where $var=\"$val\" " , DB_HANDLE ) or die( mysql_error() );
			$row = mysql_fetch_assoc( $res );
			$valuecount = $row["COUNT(*)"];
			$this->htmlElement = $this->document->createElement( "span" );
			$te = $this->document->createTextNode( number_format(($valuecount/$__ROW_COUNT*100.0),1,'.','' )." %" );
			$this->htmlElement->appendChild( $te );
			break;

		case "barchart":
			$valuecount = 0;
			$res = mysql_query( "SELECT COUNT(*) FROM ".DATABASE." where $var=\"$val\" " , DB_HANDLE ) or die( mysql_error() );
			$row = mysql_fetch_assoc( $res );
			$valuecount = $row["COUNT(*)"];
			$color = "ff0000";
			if( $node->hasAttribute( "color" ) ) $color = $node->getAttribute( "color" );
			$vv = intval( $valuecount/$__ROW_COUNT*100 );
			$this->htmlElement = $this->document->createElement( "img" );
			$this->htmlElement->setAttribute( "src", ROOT_PATH."/chart.php?value=$vv&color1=$color" );
			$this->htmlElement->setAttribute( "title", "$vv %" );
			break;

		case "circularchart":
			$res = mysql_query( "SELECT $var, COUNT($var) FROM ".DATABASE." GROUP BY $var ", DB_HANDLE ) or die( mysql_error() );

			$counts = array();
			$values = array();
			while( $row = mysql_fetch_assoc( $res ) ){
				$c = intval($row["COUNT($var)"]);
				if( $c > 0 ){
					$counts[] = $c;
					$values[] = $row["$var"];
				}
			}

			$labs = array();
			$labelNodes = $node->getElementsByTagName( "label" );
			foreach( $labelNodes as $ll ){
				$labs[ (string)$ll->getAttribute("value")] = $ll->textContent;
			}

			foreach( $values as $vv ){
				if( isset( $labs[(string)$vv] ) ) $labels[] = $labs[$vv];
				else $labels[] = "Value: $vv";
			}

			$wi = $this->width;
			$he = $this->height;
			$this->htmlElement = $this->document->createElement( "img" );
			$this->htmlElement->setAttribute( "src", ROOT_PATH."/jpgraph.php?width=$wi&height=$he&values=".implode("|",$counts)."&labels=".implode("|",$labels) );
			break;

			default:
				$this->htmlElement = $this->document->createElement( "span" );
				$this->htmlElement->appenChild( $this->document->createTextNode( "unknown" ) );
				break;
		}

		$parentNode = $node->parentNode;
		$parentNode->replaceChild( $this->htmlElement, $node );
	}

	function setValue( &$vars ){ }
}

?>