<?
/************************************************************************
*
*  online.QTAFI - online survey
*
*  Copyright (C) 2008  Martin Guist guist@incher.uni-kassel.de
*
*  This program is free software: you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation, either version 3 of the License, or
*  (at your option) any later version.
*
*  This program is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
*  GNU General Public License for more details.
*
*  You should have received a copy of the GNU General Public License
*  along with this program. If not, see <http://www.gnu.org/licenses/>.
*
*************************************************************************/

/**
*
* EXAMPLE
*
* <qtafi:TE variable="var" size="10" prefilled="" disabled="true" />
*/
class TENode extends InputNode {

	public static $type = "TE";
	public $prefilled = "";

	function __construct( &$doc, &$node ){
		global $__DEBUG;
		$this->document = $doc;
		$this->qtafiElement = $node;
		$this->variable = $node->getAttribute( "variable" );

		if( $__DEBUG ){
			$this->htmlElement = $this->document->createElement( "small" );
			$this->htmlElement->appendChild( $this->document->createTextNode( "TE(".$this->variable.")" ) );
			$parentNode = $node->parentNode;
			$parentNode->replaceChild( $this->htmlElement, $node );
			return;
		}


		$this->htmlElement = $this->document->createElement( "input" );
		$this->htmlElement->setAttribute( "type", "text" );
		$this->htmlElement->setAttribute( "name", $this->variable );

		if( $node->hasAttribute( "prefilled" ) ){
			$this->prefilled = $node->getAttribute( "prefilled" );
			$this->htmlElement->setAttribute( "onClick", "if(this.value == '".$this->prefilled."') this.value=''" );
			$this->htmlElement->setAttribute( "onBlur", "if(this.value == '') this.value='".$this->prefilled."'" );
		}

		if( $node->hasAttribute( "disabled" ) ){
			$dis = $node->getAttribute( "disabled" );
			if( $dis == "true" ) $this->htmlElement->setAttribute( "disabled", "disabled" );
		}

		$keyup = "valueChanged('{$this->variable}');";
		if( $node->hasAttribute( "onkeyup" ) ){
			$keyup .= $node->getAttribute( "onkeyup" );
		}
		$this->htmlElement->setAttribute( "onkeyup", $keyup );
		
		$size = 10;
		if( $node->hasAttribute( "size" ) ) $size = $node->getAttribute( "size" );
		$this->htmlElement->setAttribute( "size", $size );

		$parentNode = $node->parentNode;
		$parentNode->replaceChild( $this->htmlElement, $this->qtafiElement );
	}

	function setValue( &$vars ){
		$val = html_entity_decode( $vars[$this->variable], ENT_QUOTES, "utf-8" );
		if( $val == MISSING || $val == "" ) $val = $this->prefilled;
		$this->htmlElement->setAttribute( "value", $val );
	}
}

?>