<?
/************************************************************************
*
*  online.QTAFI - online survey
*
*  Copyright (C) 2008  Martin Guist guist@incher.uni-kassel.de
*
*  This program is free software: you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation, either version 3 of the License, or
*  (at your option) any later version.
*
*  This program is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
*  GNU General Public License for more details.
*
*  You should have received a copy of the GNU General Public License
*  along with this program. If not, see <http://www.gnu.org/licenses/>.
*
*************************************************************************/

class TLNode extends InputNode {

	public static $type = "TL";

	function __construct( &$doc, &$node ){
		global $__DEBUG;
		$this->document = $doc;
		$this->qtafiElement = $node;
		$this->variable = $node->getAttribute( "variable" );

		if( $__DEBUG ){
			$this->htmlElement = $this->document->createElement( "small" );
			$this->htmlElement->appendChild( $this->document->createTextNode( "TL(".$this->variable.")" ) );
			$parentNode = $node->parentNode;
			$parentNode->replaceChild( $this->htmlElement, $node );
			return;
		}

		$this->htmlElement = $this->document->createElement( "textarea" );
		$this->htmlElement->setAttribute( "name", $this->variable );

		$cols = 50;
		if( $node->hasAttribute( "width" ) ) $cols = $node->getAttribute( "width" );

		$rows = 3;
		if( $node->hasAttribute( "height" ) ) $rows = $node->getAttribute( "height" );

		$this->htmlElement->setAttribute( "cols", $cols );
		$this->htmlElement->setAttribute( "rows", $rows );

		$parentNode = $node->parentNode;
		$parentNode->replaceChild( $this->htmlElement, $this->qtafiElement );
	}

	function setValue( &$vars ){
		$val = html_entity_decode( $vars[$this->variable], ENT_QUOTES, "utf-8" );
		if( $val == MISSING ) $val = "";
		$valnode = $this->document->createTextNode( $val );
		$this->htmlElement->appendChild( $valnode );
	}
}

?>