<?
/************************************************************************
*
*  online.QTAFI - online survey
*
*  Copyright (C) 2008  Martin Guist guist@incher.uni-kassel.de
*
*  This program is free software: you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation, either version 3 of the License, or
*  (at your option) any later version.
*
*  This program is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
*  GNU General Public License for more details.
*
*  You should have received a copy of the GNU General Public License
*  along with this program. If not, see <http://www.gnu.org/licenses/>.
*
*************************************************************************/

include_once "config.php";
include_once "./classes/Administrator.class.php";
include_once "./classes/AdministratorLog.class.php";
/**
*
*/

$available_methods = array("authenticate","changePassword","startPage","getCount","getData","getTxtData","postData","clearDatabase","getStatistic","getLog","clearLog","getFile","postFile","listFiles","deleteFile");

$admin = new Administrator();
$admin->authenticate($_POST);

$readaccess = $admin->readaccess();
$writeaccess = $admin->writeaccess();

$database = $__PROJECT."_db";
$log_database = $__PROJECT."_log";
$path = PROJECTS_PATH."/".$__PROJECT."/";

header("Content-Type: text/xml; charset=utf-8");
header("Content-Disposition: attachment; filename=data.xml");//to force download

$log = new AdministratorLog();
$log->write();
if($log->isBlocked()){
	header( "X-Qtafi-Response: ERROR" );
	header( "X-Qtafi-Response-Type: message" );
	header( "X-Qtafi-Project: $__PROJECT" );
	print "<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n";
	print "<qtafi>\n";
	print "    <message>\n";
	print "        <response>ERROR Blocked</response>\n";
	print "        <id>0</id>\n";
	print "    </message>\n";
	print "</qtafi>\n";
	die();
}

if(file_exists($path.CONFIG)){
	$configuration = simplexml_load_file( $path.CONFIG );
	foreach( $configuration->config[0] as $tag => $v ){
		switch( $tag ){
			case "start" :
				$__START = (string)$v;
			break;
			case "end" :
				$__END =  (string)$v;
			break;
			case "author" :
				$__AUTHOR = (string)$v;
			break;
			case "authentication" :
				$__AUTHENTICATIONMODE = (string)$v;
			break;
			case "log":
				$__LOGMODE = (string)$v;
			break;
			case "statistic":
				$__LOGMODE = (string)$v;
			break;
		}
	}
}

if(isset( $_POST["requestAction"])){
	if($_POST["requestAction"] == "authenticate"){
		if($__AUTHENTICATION == "authenticated"){
			header("X-Qtafi-Response: OK");
			header("X-Qtafi-Response-Type: message");
			header("X-Qtafi-Project: $__PROJECT");
			print "<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n";
			print "<qtafi>\n";
			print "    <message>\n";
			print "        <response>Authentication successfull</response>\n";
			print "        <id>$__ID</id>\n";
			print "    </message>\n";
			print "</qtafi>\n";
			die();
		}
		else{
			header( "X-Qtafi-Response: ERROR" );
			header( "X-Qtafi-Response-Type: message" );
			header( "X-Qtafi-Project: $__PROJECT" );
			print "<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n";
			print "<qtafi>\n";
			print "    <message>\n";
			print "        <response>ERROR: Authentication failed</response>\n";
			print "        <id>0</id>\n";
			print "    </message>\n";
			print "</qtafi>\n";
			die();
		}
	}
}

if($__AUTHENTICATION != "authenticated"){
	header( "X-Qtafi-Response: ERROR" );
	header( "X-Qtafi-Response-Type: message" );
	header( "X-Qtafi-Project: $__PROJECT" );
	print "<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n";
	print "<qtafi>\n";
	print "    <message>\n";
	print "        <response>ERROR: Authentication error</response>\n";
	print "        <id>$__ID</id>\n";
	print "    </message>\n";
	print "</qtafi>\n";
	die();
}


if(isset($_POST["requestAction"]) && isset($_POST["value"])){
	if(in_array($_POST["requestAction"],$available_methods)) call_user_func($_POST["requestAction"], htmlentities($_POST["value"]));
	else {
		header( "X-Qtafi-Response: ERROR" );
		header( "X-Qtafi-Response-Type: message" );
		header( "X-Qtafi-Project: $__PROJECT" );
		print "<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n";
		print "<qtafi>\n";
		print "    <message>\n";
		print "        <response>ERROR: Invalid action</response>\n";
		print "        <id>$__ID</id>\n";
		print "    </message>\n";
		print "</qtafi>\n";
		die();
	}
}

function changePassword($v){
	global $admin,$__PROJECT,$_POST, $__ID, $readaccess, $writeaccess;
	if(! hasWriteAccess("password")){
		header( "X-Qtafi-Response: ERROR" );
		header( "X-Qtafi-Response-Type: message" );
		header( "X-Qtafi-Project: $__PROJECT" );
		print "<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n";
		print "<qtafi>\n";
		print "    <message>\n";
		print "        <response>ERROR: Permission denied</response>\n";
		print "        <id>0</id>\n";
		print "    </message>\n";
		print "</qtafi>\n";
		die();
	}
	if(isset($_POST["old"] ) && isset($_POST["new"])&& isset($_POST["__name"])){
		$change = $admin->changePassword($_POST["old"],$_POST["new"], $_POST["__name"]);
		if($change == true){
			header( "X-Qtafi-Response: OK" );
			header( "X-Qtafi-Response-Type: message" );
			header( "X-Qtafi-Project: $__PROJECT" );
			print "<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n";
			print "<qtafi>\n";
			print "    <message>\n";
			print "        <response>Password changed</response>\n";
			print "        <id>$__ID</id>\n";
			print "    </message>\n";
			print "</qtafi>\n";
			die();
		}
	}
	header( "X-Qtafi-Response: ERROR" );
	header( "X-Qtafi-Response-Type: message" );
	header( "X-Qtafi-Project: $__PROJECT" );
	print "<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n";
	print "<qtafi>\n";
	print "    <message>\n";
	print "        <response>ERROR: Password not changed</response>\n";
	print "        <id>$__ID</id>\n";
	print "    </message>\n";
	print "</qtafi>\n";
	die();
}

function responseCount(){
	global $__PROJECT, $readaccess, $writeaccess;
	$database = $__PROJECT."_db";
	$res = mysql_query( "SELECT COUNT(__n) from ".$database , DB_HANDLE );
	if( $res ){
		$rows = mysql_fetch_row( $res );
		return $rows[0];
	}
	return 0;
}

function startPage($v){
	global $__PROJECT, $__END,$__START, $readaccess, $writeaccess;
	if(file_exists(PROJECTS_PATH."/admin/startpage.html")) readfile(PROJECTS_PATH."/admin/startpage.html");
	else {
		print "<html><body>";
		print "<h1>Welcome</h1>";
		print "</body></html>";
	}
	die();
}

function getCount( $v ){
	global $admin,$database,$__PROJECT,$readaccess, $writeaccess;
	if(! hasReadAccess("count")){
		header( "X-Qtafi-Response: ERROR" );
		header( "X-Qtafi-Response-Type: message" );
		header( "X-Qtafi-Project: $__PROJECT" );
		print "<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n";
		print "<qtafi>\n";
		print "    <message>\n";
		print "        <response>ERROR: Permission denied</response>\n";
		print "        <id>0</id>\n";
		print "    </message>\n";
		print "</qtafi>\n";
		die();
	}
	$count = 0;
	if( $v == "error" ){
		$database = $__PROJECT."_log";
		$res = mysql_query( "SELECT COUNT(__n) from ".$database." where status!=0", DB_HANDLE );
		if( $res ){
			$rows = mysql_fetch_row( $res );
			$count = $rows[0];
		}
	}
	else if($v == "access"){
		$database = $__PROJECT."_log";
		$res = mysql_query( "SELECT COUNT(n) from ".$database, DB_HANDLE );
		if( $res ){
			$rows = mysql_fetch_row( $res );
			$count = $rows[0];
		}
	}
	else if($v == "response"){
		$database = $__PROJECT."_db";
		$res = mysql_query( "SELECT COUNT(__n) from ".$database, DB_HANDLE );
		if( $res ){
			$rows = mysql_fetch_row( $res );
			$count = $rows[0];
		}
	}
	header( "X-Qtafi-Response: OK" );
	header( "X-Qtafi-Response-Type: count" );
	header( "X-Qtafi-Project: $__PROJECT" );
	header( "X-Qtafi-Cases: 0" );
	print "<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n";
	print "<qtafi>\n";
	print "		<count {$v}=\"{$count}\" />";
	print "</qtafi>\n";
	die();
}

function getData( $v ){
	global $admin,$database,$__PROJECT,$readaccess, $writeaccess;
	if(! hasReadAccess("data")){
		header( "X-Qtafi-Response: ERROR" );
		header( "X-Qtafi-Response-Type: message" );
		header( "X-Qtafi-Project: $__PROJECT" );
		print "<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n";
		print "<qtafi>\n";
		print "    <message>\n";
		print "        <response>ERROR: Permission denied</response>\n";
		print "        <id>0</id>\n";
		print "    </message>\n";
		print "</qtafi>\n";
		die();
	}
	$rowcount = -9;
	$offset = 0;
	if( isset($_POST["count"]) ) $rowcount = (int)$_POST["count"];
	if( isset($_POST["offset"]) ) $offset = (int)$_POST["offset"];
	$rowsres = mysql_query( "SELECT COUNT(__n) from ".$database, DB_HANDLE );
	if( ! $rowsres ){
		header( "X-Qtafi-Response: OK" );
		header( "X-Qtafi-Response-Type: data" );
		header( "X-Qtafi-Project: $__PROJECT" );
		header( "X-Qtafi-Cases: 0" );
		print "<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n";
		print "<qtafi>\n";
		print "	<data>\n";
		print "		<definition><__n/></definition>";
		print "		<row><c>[empty]</c></row>";
		print "	</data>\n";
		print "</qtafi>\n";
		die();
	}
	$rows = mysql_fetch_row( $rowsres );
	//$result = mysql_query( "select * from ".$database, DB_HANDLE );
	if( $rowcount > 0 ) $result = mysql_unbuffered_query( "select * from ".$database." LIMIT {$offset},{$rowcount}", DB_HANDLE );// LIMIT 5,10
	$result = mysql_unbuffered_query( "select * from ".$database, DB_HANDLE );
	if( ! $result ){
		header( "X-Qtafi-Response: OK" );
		header( "X-Qtafi-Response-Type: data" );
		header( "X-Qtafi-Project: $__PROJECT" );
		header( "X-Qtafi-Cases: 0" );
		print "<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n";
		print "<qtafi>\n";
		print "	<data>\n";
		print "		<definition><__n/></definition>";
		print "		<row><c>[empty]</c></row>";
		print "	</data>\n";
		print "</qtafi>\n";
		die();
	}
	header( "X-Qtafi-Response: OK" );
	header( "X-Qtafi-Response-Type: data" );
	header( "X-Qtafi-Project: $__PROJECT" );
	header( "X-Qtafi-Cases: $rows" );
	print "<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n";
	print "<qtafi>\n";

	$row = 1;
	$vars = array();
   	$arr = mysql_fetch_assoc( $result );
	$vvv = count( $arr );
	print "	<data rows=\"".$rows[0]."\" variables=\"".$vvv."\">\n";
	do{
		$num = $arr["__n"];
		if( $row == 1 ){
			print "		<definition>\n";
			foreach( $arr as $n => $v ){
				array_push( $vars, $n );
				print "			<$n/>\n";
			}
			print "		</definition>\n";
		}
		print "		<row>\n";
		foreach( $vars as $n ){
			$vv = "-9";
			if( isset( $arr[$n] ) ){
				$vv = $arr[$n];
				$vv = str_replace( "&", "&amp;", $vv );
				$vv = str_replace( "<", "&lt;", $vv );
				$vv = str_replace( ">", "&gt;", $vv );
				$vv = str_replace( "\n", "<br/>", $vv );
				$vv = str_replace( "\r", "", $vv );
				$vv = str_replace( "\t", "<tab/>", $vv );
			}
			print "			<c>".$vv."</c>\n";
		}
		print "		</row>\n";
		$row++;
		flush();
	}
	while( $arr = mysql_fetch_assoc( $result ) );

	print "	</data>\n";
	print "</qtafi>\n";
	die();
}

/**
* Returns the response data tabulator separated
* F.E.
* __n	__pin	....	....	V23
* 1	12345	.....	....	xx
*
*/
function getTxtData($v){
	global $admin,$database,$__PROJECT,$readaccess, $writeaccess;
	if(! hasReadAccess("data")){
		header( "X-Qtafi-Response: ERROR" );
		header( "X-Qtafi-Response-Type: message" );
		header( "X-Qtafi-Project: $__PROJECT" );
		print "<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n";
		print "<qtafi>\n";
		print "    <message>\n";
		print "        <response>ERROR: Permission denied</response>\n";
		print "        <id>0</id>\n";
		print "    </message>\n";
		print "</qtafi>\n";
		die();
	}
	
	$rowcount = -9;
	$offset = 0;
	if( isset($_POST["count"]) ) $rowcount = (int)$_POST["count"];
	if( isset($_POST["offset"]) ) $offset = (int)$_POST["offset"];
	
	$rowsres = mysql_query( "SELECT COUNT(__n) from ".$database, DB_HANDLE );
	if( ! $rowsres ){
		header( "X-Qtafi-Response: OK" );
		header( "X-Qtafi-Response-Type: txtdata" );
		header( "X-Qtafi-Project: $__PROJECT" );
		header( "X-Qtafi-Cases: 0" );
		print "[empty]";
		die();
	}
	$rows = mysql_fetch_row( $rowsres );
	//$result = mysql_query( "select * from ".$database, DB_HANDLE );
	if( $rowcount > 0 ) $result = mysql_unbuffered_query( "select * from ".$database." LIMIT {$offset},{$rowcount}", DB_HANDLE );// LIMIT 5,10
	$result = mysql_unbuffered_query( "select * from ".$database, DB_HANDLE );
	if( ! $result ){
		header( "X-Qtafi-Response: OK" );
		header( "X-Qtafi-Response-Type: txtdata" );
		header( "X-Qtafi-Project: $__PROJECT" );
		header( "X-Qtafi-Cases: 0" );
		print "[empty]";
		die();
	}
	header( "X-Qtafi-Response: OK" );
	header( "X-Qtafi-Response-Type: txtdata" );
	header( "X-Qtafi-Project: $__PROJECT" );
	header( "X-Qtafi-Cases: $rows" );

	$row = 1;
	$vars = array();
	$arr = mysql_fetch_assoc($result);
	$vvv = count($arr);
	do{
		$num = $arr["__n"];
		if( $row == 1 ){
			foreach( $arr as $n => $v ){
				array_push( $vars, $n );
				print "$n\t";
			}
			print "\n";
		}
		foreach( $vars as $n ){
			$vv = "-9";
			if( isset( $arr[$n] ) ){
				$vv = $arr[$n];
				$vv = str_replace( "\n", "<br/>", $vv );
				$vv = str_replace("\r", "", $vv );
				$vv = str_replace( "\t", "<tab/>", $vv );
			}
			print html_entity_decode( $vv, ENT_QUOTES, "utf-8" )."\t";
		}
		print "\n";
		$row++;
		flush();
	}
	while( $arr = mysql_fetch_assoc( $result ) );
	die();
}


/**
* <qtafi>
*	<data>
*		<row>
*			<variable>....</variable>
*		</row>
*	</data>
* </qtafi>
* oder
* <qtafi>
*	<data>
*		<defintion>
*			<variable/>
*		</definition>
*		<row>
*			<c>....</c>
*		</row>
*	</data>
*<qtafi>
*/
function postData( $v ){
	global $_FILES,$admin, $database,$__PROJECT, $__ID,$readaccess, $writeaccess;
	if( ! hasWriteAccess("data") ){
		header( "X-Qtafi-Response: ERROR" );
		header( "X-Qtafi-Response-Type: message" );
		header( "X-Qtafi-Project: $__PROJECT" );
		print "<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n";
		print "<qtafi>\n";
		print "    <message>\n";
		print "        <response>ERROR: Permission denied</response>\n";
		print "        <id>0</id>\n";
		print "    </message>\n";
		print "</qtafi>\n";
		die();
	}
	$result = mysql_query( "select * from ".$database, DB_HANDLE );
	if( ! $result ) User::createTable( $database );
	if( $_FILES["uploadFile"]["error"] > 0 ) {
		header( "X-Qtafi-Response: ERROR" );
		header( "X-Qtafi-Response-Type: message" );
		header( "X-Qtafi-Project: $__PROJECT" );
		print "<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n";
		print "<qtafi>\n";
		print "    <message>\n";
		print "        <response>ERROR: Post data - ". $_FILES["uploadFile"]["error"]."</response>\n";
		print "        <id>$__ID</id>\n";
		print "    </message>\n";
		print "</qtafi>\n";
		die();
	}
	if( file_exists( $_FILES["uploadFile"]["tmp_name"] ) ){
		//mysql_query( "delete from ".$database, DB_HANDLE ) or die( "error: request::postdata()" );
		$document = new DOMDocument();
		$document->load( $_FILES["uploadFile"]["tmp_name"] );
		$rootelement = $document->documentElement;
		$deflist = $rootelement->getElementsByTagName( "definition" );
		$def = $deflist->item(0);
		$definition = array();
		$lengths = array();
		if( $def ){
			$defvars = $def->childNodes;
			foreach( $defvars as $var ){
				if( $var->nodeType == 1 ){
					array_push( $definition, $var->nodeName );
					if( $var->hasAttribute( "maxlength") ){
						$ll = $var->getAttribute( "maxlength" );
						$lengths[$var->nodeName] = $ll;
					}
					else $lengths[$var->nodeName] = 10;
				}
			}
		}
		modifyTable( $lengths );

		$rows = $rootelement->getElementsByTagName( "row" );
		$vars = array();
		$num = 0;
		foreach( $rows as $row ){
			$variables = $row->childNodes;
			$cellnum = 0;
			foreach( $variables as $variable ){
				if( $variable->nodeType == 1 ){
					$tt = $variable->textContent;
					if( count( $definition ) > 0  ){
						$vars[ $definition[$cellnum] ] = $tt;
					}
					$cellnum++;
				}
			}
			write( $vars ,$num );
			$num++;
		}
		$res = mysql_query( "select * from ".$database, DB_HANDLE );
		$n = mysql_num_rows( $res );
		print "\n\nCOUNT".$n;
	}
}

function write( &$vars, $num ){
	global $_FILES,$admin,$database,$__PROJECT,$readaccess, $writeaccess;
	//Fall eintragen
	//mysql_query( "insert into ".$database." ( __id, __fill ) values ( \"$num\", -1 )" );
	//$updateVars = array();
	$variables = array();
	$values = array();
	foreach( $vars as $n => $v ){
		if( substr( $n, 0, 2 ) != "__" ){
			if( $v == "(bitte angeben)" ) $v = MISSING;
			if( strlen(chop(trim($v))) == 0 ) $v = MISSING;
			//array_push( $updateVars , "$n=\"".chop(trim($v))."\"" );
			array_push( $variables, $n );
			array_push( $values, "\"".chop(trim( $v ) )."\"" );
		}
		else if( $n == "__pin" ){
			//array_push( $updateVars , "$n=\"".chop(trim($v))."\"" );
			array_push( $variables, $n );
			array_push( $values, "\"".chop(trim( $v ) )."\"" );
		}
	}
	//print "insert into ".$database." ( __id, __fill, ". join( ",", $variables )." ) values ( \"$num\", -1, ".join(",", $values )." )\n";
	mysql_query( "insert into ".$database." ( __id, __fill, ". join( ",", $variables )." ) values ( \"$num\", -1, ".join(",", $values )." )", DB_HANDLE ) or die( "error: request::insert() ".mysql_error() );
	/*
	if( sizeof( $updateVars ) > 0 ) {
		mysql_query( "update ".$database." set ".join(",", $updateVars )." where __id=\"".$num."\"", DB_HANDLE) or die( "error: request::write3() ".mysql_error() );
	}
	*/
}

/**
* $vars[name] = len
*/
function modifyTable( &$vars ){
	global $_FILES,$admin,$database,$__PROJECT,$readaccess, $writeaccess;
	$names = array();
	$res = mysql_query( "show columns from ".$database, DB_HANDLE );
	if( mysql_num_rows( $res ) > 0 ){
		while( $row = mysql_fetch_assoc( $res ) ) $names[$row["Field"]] = 1;
	}
	$missing_vars = array();
	foreach( $vars as $n => $len ){
		if( ! array_key_exists( (string)$n, $names ) ){
			array_push( $missing_vars, (string)$n." ".SMALL_TYPE );
		}
	}
	if( sizeof( $missing_vars ) > 0 ){
		mysql_query( "alter table ".$database." add ( ".join( ", ", $missing_vars )." )", DB_HANDLE ) or die( "error: request::write2()".__LINE__." ".mysql_error( ) );
	}

	global $_FILES,$admin,$database,$__PROJECT;
	//check whether the field can store the data
	$res = mysql_query( "show columns from ".$database, DB_HANDLE );
	$types = array();
	if( mysql_num_rows( $res ) > 0 ){
		while( $row = mysql_fetch_assoc( $res ) ) $types[ $row["Field"]] = $row["Type"];
	}
	$alter_vars = array();
	foreach( $vars as $n => $len ){
		if( substr( $n, 0, 2 ) != "__" && strlen( $n ) > 1 ){//Systemvariablen
			if( $types[$n] == SMALL_TYPE && $len > 10 ){
				if( $len < 50 ){
					array_push( $alter_vars, "modify ".(string)$n." ".MEDIUM_TYPE );
				}
				else{
					array_push( $alter_vars, "modify ".(string)$n." ".TEXT_TYPE );
				}
			}
			else if( $types[$n] == MEDIUM_TYPE && $len > 50 ){
				array_push( $alter_vars, "modify ".(string)$n." ".TEXT_TYPE );
			}
		}
	}
	if( sizeof( $alter_vars ) > 0 ){
		print "alter table <br />";
		print_r( $alter_vars );
		mysql_query( "alter table ".$database." ".join( ", ", $alter_vars )." ", DB_HANDLE ) or die( "error: User::write()".__LINE__." ".mysql_error( ) );
	}
}

function getStatistic( $v ){
	getLog( $v );
}

function getLog( $v ){
	global $admin,$log_database,$__PROJECT,$readaccess, $writeaccess;
	if(! hasReadAccess("log")){
		header( "X-Qtafi-Response: ERROR" );
		header( "X-Qtafi-Response-Type: message" );
		header( "X-Qtafi-Project: $__PROJECT" );
		print "<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n";
		print "<qtafi>\n";
		print "    <message>\n";
		print "        <response>ERROR: Permission denied</response>\n";
		print "        <id>0</id>\n";
		print "    </message>\n";
		print "</qtafi>\n";
		die();
	}
	$rowcount = -9;
	$offset = 0;
	if( isset($_POST["count"]) ) $rowcount = (int)$_POST["count"];
	if( isset($_POST["offset"]) ) $offset = (int)$_POST["offset"];
	
	//$result = mysql_query( "select * from ".$log_database , DB_HANDLE );
	if( $rowcount > 0 ) $result = mysql_unbuffered_query( "select * from ".$log_database." LIMIT {$offset},{$rowcount}", DB_HANDLE );// LIMIT 5,10
	$result = mysql_unbuffered_query( "select * from ".$log_database, DB_HANDLE );

	if( ! $result ){
		header( "X-Qtafi-Response: OK" );
		header( "X-Qtafi-Response-Type: data" );
		header( "X-Qtafi-Project: $__PROJECT" );
		print "<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n";
		print "<qtafi>\n";
		print "	<data>\n";
		print "		<definition><n/></definition>";
		print "		<row><c>[empty]</c></row>";
		print "	</data>\n";
		print "</qtafi>\n";
		die();
	}
	header( "X-Qtafi-Response: OK" );
	header( "X-Qtafi-Response-Type: data" );
	header( "X-Qtafi-Project: $__PROJECT" );
	print "<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n";
	print "<qtafi>\n";
	print "	<data>\n";
	$row = 1;
	$vars = array();
	while( $arr = mysql_fetch_assoc( $result ) ){
		$num = $arr["n"];
		if( $row == 1 ){
			print "		<definition>\n";
			foreach( $arr as $n => $v ){
				array_push( $vars, $n );
				print "			<$n/>\n";
			}
			print "		</definition>\n";
		}
		print "		<row>\n";
		foreach( $vars as $n ){
			$vv = "";
			if( isset( $arr[$n] ) ) print "			<c>".$arr[$n]."</c>\n";
			else print "			<c>-9</c>\n";
		}
		print "		</row>\n";
		$row++;
	}
	print "	</data>\n";
	print "</qtafi>\n";
	die();
}

function clearStatistic( $v ){
	clearLog($v);
}

function clearLog($v){
 	global $admin,$__ID,$log_database,$__PROJECT,$readaccess, $writeaccess;
	if(! hasWriteAccess("log")){
		header( "X-Qtafi-Response: ERROR" );
		header( "X-Qtafi-Response-Type: message" );
		header( "X-Qtafi-Project: $__PROJECT" );
		print "<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n";
		print "<qtafi>\n";
		print "    <message>\n";
		print "        <response>ERROR: Permission denied</response>\n";
		print "        <id>0</id>\n";
		print "    </message>\n";
		print "</qtafi>\n";
		die();
	}
	$result = mysql_query( "drop table ".$log_database." ", DB_HANDLE );
	if( ! $result ){
		header( "X-Qtafi-Response: ERROR" );
		header( "X-Qtafi-Response-Type: message" );
		header( "X-Qtafi-Project: $__PROJECT" );
		print "<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n";
		print "<qtafi>\n";
		print "    <message>\n";
		print "        <response>ERROR: ".mysql_error()."</response>\n";
		print "        <id>$__ID</id>\n";
		print "    </message>\n";
		print "</qtafi>\n";
		die();
	}
	header( "X-Qtafi-Response: OK" );
	header( "X-Qtafi-Response-Type: message" );
	header( "X-Qtafi-Project: $__PROJECT" );
	print "<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n";
	print "<qtafi>\n";
	print "    <message>\n";
	print "        <response>OK</response>\n";
	print "        <id>$__ID</id>\n";
	print "    </message>\n";
	print "</qtafi>\n";
}


function getFile($v){
	global $path,$__PROJECT, $__ID,$readaccess, $writeaccess;
	/**
	* Sicherheit!!
	* Codebook andere
	*/
	if(! hasReadAccess($v)){
		header( "X-Qtafi-Response: ERROR" );
		header( "X-Qtafi-Response-Type: message" );
		header( "X-Qtafi-Project: $__PROJECT" );
		print "<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n";
		print "<qtafi>\n";
		print "    <message>\n";
		print "        <response>ERROR: Permission denied</response>\n";
		print "        <id>0</id>\n";
		print "    </message>\n";
		print "</qtafi>\n";
		die();
	}
	if(strpos( $v, "/" ) > 0){
		if(strpos( $v, "/.questionnaire") > 0 ){ //Exception codebook other projects
			if(file_exists( $path.$v)){
				header( "X-Qtafi-Response: OK" );
				header( "X-Qtafi-Response-Type: file" );
				header( "X-Qtafi-Project: $__PROJECT" );
				readfile( $path.$v );
				return;
			}
		}
		return "ERROR";
	}
	if( strpos( $v, "\\" ) > 0 ) return "ERROR";
	if( strpos( $v, ".." ) > 0 ) return "ERROR";
	if( ! is_dir( $path ) ) mkdir( $path );
	if( file_exists( $path.$v ) ){
		header( "X-Qtafi-Response: OK" );
		header( "X-Qtafi-Response-Type: file" );
		header( "X-Qtafi-Project: $__PROJECT" );
		readfile( $path.$v );
		return;
	}
	else{
		if( $v == ".config" ){
			header( "X-Qtafi-Response: OK" );
			header( "X-Qtafi-Response-Type: file" );
			header( "X-Qtafi-Project: $__PROJECT" );
			readfile( $path."../admin/.config" );
			return;
		}
		elseif( $v == ".questionnaire" ){
			header( "X-Qtafi-Response: OK" );
			header( "X-Qtafi-Response-Type: file" );
			header( "X-Qtafi-Project: $__PROJECT" );
			readfile( $path."../admin/.questionnaire" );
			return;
		}
		elseif( $v == ".user" ){
			header( "X-Qtafi-Response: OK" );
			header( "X-Qtafi-Response-Type: file" );
			header( "X-Qtafi-Project: $__PROJECT" );
			readfile( $path."../admin/.user" );
			return;
		}
		elseif( $v == "style.css" ){
			header( "X-Qtafi-Response: OK" );
			header( "X-Qtafi-Response-Type: file" );
			header( "X-Qtafi-Project: $__PROJECT" );
			readfile( $path."../admin/style.css" );
			return;
		}
	}
	header("X-Qtafi-Response: ERROR" );
	header("X-Qtafi-Response-Type: message" );
	header("X-Qtafi-Project: $__PROJECT" );
	print "<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n";
	print "<qtafi>\n";
	print "    <message>\n";
	print "        <response>ERROR: File {$path} {$v} does not exist</response>\n";
	print "        <id>$__ID</id>\n";
	print "    </message>\n";
	print "</qtafi>\n";
}

function postFile( $v ){
	global $_FILES, $__ID,$path,$__PROJECT,$readaccess, $writeaccess;
	/**
	* Sicherheit
	* path
	*/
	if(! hasWriteAccess($v)){
		header( "X-Qtafi-Response: ERROR" );
		header( "X-Qtafi-Response-Type: message" );
		header( "X-Qtafi-Project: $__PROJECT" );
		print "<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n";
		print "<qtafi>\n";
		print "    <message>\n";
		print "        <response>ERROR: Permission denied</response>\n";
		print "        <id>0</id>\n";
		print "    </message>\n";
		print "</qtafi>\n";
		die();
	}
	if( strpos( $v, "/" ) > 0 ) return "ERROR";
	if( strpos( $v, "\\" ) > 0 ) return "ERROR";
	if( strpos( $v, ".." ) > 0 ) return "ERROR";
	if( move_uploaded_file( $_FILES['uploadFile']['tmp_name'], $path.$v ) ){
		header( "X-Qtafi-Response: OK" );
		header( "X-Qtafi-Response-Type: message" );
		header( "X-Qtafi-Project: $__PROJECT" );
		print "<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n";
		print "<qtafi>\n";
		print "    <message>\n";
		print "        <response>OK</response>\n";
		print "        <id>$__ID</id>\n";
		print "    </message>\n";
		print "</qtafi>\n";
	}
	else {
		header( "X-Qtafi-Response: ERROR" );
		header( "X-Qtafi-Response-Type: message" );
		header( "X-Qtafi-Project: $__PROJECT" );
		print "<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n";
		print "<qtafi>\n";
		print "    <message>\n";
		print "        <response>ERROR: File Upload</response>\n";
		print "        <id>$__ID</id>\n";
		print "    </message>\n";
		print "</qtafi>\n";
	}
	die();
}

function deleteFile( $v ){
	global $_FILES, $__ID,$path,$__PROJECT,$readaccess, $writeaccess;
	if( strpos( $v, "/" ) === true ) return "ERROR";
	if( strpos( $v, "\\" ) === true ) return "ERROR";
	if( strpos( $v, ".." ) === true ) return "ERROR";
	if(! hasWriteAccess($v)){
		header( "X-Qtafi-Response: ERROR" );
		header( "X-Qtafi-Response-Type: message" );
		header( "X-Qtafi-Project: $__PROJECT" );
		print "<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n";
		print "<qtafi>\n";
		print "    <message>\n";
		print "        <response>ERROR: Permission denied</response>\n";
		print "        <id>0</id>\n";
		print "    </message>\n";
		print "</qtafi>\n";
		die();
	}
	if( file_exists( $path.$v ) ){
		unlink( $path.$v );
		header( "X-Qtafi-Response: OK" );
		header( "X-Qtafi-Response-Type: message" );
		header( "X-Qtafi-Project: $__PROJECT" );
		print "<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n";
		print "<qtafi>\n";
		print "    <message>\n";
		print "        <response>OK</response>\n";
		print "        <id>$__ID</id>\n";
		print "    </message>\n";
		print "</qtafi>\n";
	}
	else {
		header( "X-Qtafi-Response: ERROR" );
		header( "X-Qtafi-Response-Type: message" );
		header( "X-Qtafi-Project: $__PROJECT" );
		print "<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n";
		print "<qtafi>\n";
		print "    <message>\n";
		print "        <response>ERROR: Delete File $v</response>\n";
		print "        <id>$__ID</id>\n";
		print "    </message>\n";
		print "</qtafi>\n";
	}
	die();
}

function listFiles($v){
	global $path,$__PROJECT,$readaccess, $writeaccess;
	if(! hasReadAccess("filesystem")) return "ERROR";
	if(file_exists($path.$v)){
		if( is_dir($path.$v) ){
			header( "X-Qtafi-Response: OK" );
		    header( "X-Qtafi-Response-Type: file" );
			header( "X-Qtafi-Project: $__PROJECT" );
			print "<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n";
			print "<qtafi>\n";
			print "    <filelist>\n";
			$files = scandir( $path.$v );
			foreach( $files as $f ){
				if( $f == "." ) continue;
				if( $f == ".." ) continue;
				if( substr( $f, 0, 5 ) == ".user" ) continue;
				if( substr( $f, 0, 7 ) == ".config" ) continue;
				print "		<file name=\"$f\" />\n";
			}
			print "    </filelist>\n";
			print "</qtafi>\n";
			return;
		}
	}
	header( "X-Qtafi-Response: ERROR" );
	header( "X-Qtafi-Response-Type: message" );
	header( "X-Qtafi-Project: $__PROJECT" );
	print "<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n";
	print "<qtafi>\n";
	print "    <message>\n";
	print "        <response>ERROR: list files</response>\n";
	print "        <id>$__ID</id>\n";
	print "    </message>\n";
	print "</qtafi>\n";
}

function clearDatabase($v){
 	global $admin,$__ID, $database,$__PROJECT,$readaccess, $writeaccess;
	if(! hasWriteAccess("data")) return "ERROR";
	$result = mysql_query("drop table ".$database." ", DB_HANDLE ) or die();
	if(! $result){
		header( "X-Qtafi-Response: ERROR" );
		header( "X-Qtafi-Response-Type: message" );
		header( "X-Qtafi-Project: $__PROJECT" );
		print "<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n";
		print "<qtafi>\n";
		print "    <message>\n";
		print "        <response>ERROR: ".mysql_error()."</response>\n";
		print "        <id>$__ID</id>\n";
		print "    </message>\n";
		print "</qtafi>\n";
		die();
	}
	header( "X-Qtafi-Response: OK" );
	header( "X-Qtafi-Response-Type: message" );
	header( "X-Qtafi-Project: $__PROJECT" );
	print "<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n";
	print "<qtafi>\n";
	print "    <message>\n";
	print "        <response>OK</response>\n";
	print "        <id>$__ID</id>\n";
	print "    </message>\n";
	print "</qtafi>\n";
}


function hasWriteAccess( $name ){
	global $admin,$__ID, $database, $__PROJECT, $readaccess, $writeaccess;
	if(strlen($writeaccess) == 0) return true;
	$accessnames = split(",", $writeaccess);
	foreach($accessnames as $accessname){
		if(strpos(strtolower($name), strtolower($accessname)) !== false) return true;
	}
	return false;
}

function hasReadAccess( $name ){
	global $admin,$__ID, $database, $__PROJECT, $readaccess, $writeaccess;
	if(strlen($readaccess) == 0) return true;
	$accessnames = split(",", $readaccess);
	foreach($accessnames as $accessname ){
		if(strpos( strtolower($name), strtolower($accessname)) !== false) return true;
	}
	return false;
}

?>